Implementation Status version 0.9.0
---------------------------------------
# Global-View
* Not support async clause and wait_async directive without reflect directive
* Not support tasks directive
* Not support gmove in/out clause
* In XMP/C, not support block(n) distribution in distribute directive
* In a task construct, a section of a node array or a template shall not appear in the on clause of a directive.

# Local-View
* To define a coarray, coarray directive is used as following in XMP/C.
    * This definiton manner is defined in the XMP Specification ver. 1.0.
    * The latest definition manner in the XMP Specification is not supported. 

--
    int a[100];
    #pragma xmp coarray a:[*]
--

* "Coarray" and "image" directives in the latest XMP Specification are not supported.
* In XMP/Fortran, not support following remote access functions
    * Coarray, "Post/wait", "lock/unlock"
* On the K computer and FX10, not support stride access of coarray, "lock/unlock".

# Intrinsic and Library Procedures
* Not support following image index translation intrinsic procedures
    * xmp_get_primary_image_index()
    * xmp_get_image_index()

* In XMP/C, not support following synchronization functions of coarray
    * xmp_sync_image()
    * xmp_sync_images()
    * xmp_sync_images_all()

* Not support the following functions
    * xmp_nodes_attr()

* Not support following intrinsic/built-in transformational procedures
    * xmp_scatter()
    * xmp_gather()
    * xmp_pack()
    * xmp_unpack()
    * xmp_sortup()
    * xmp_sortdown()

# Known issues
## XMP/C
* In "for statement" with loop directive, a distributed array cannot be used with different distribution manner.
* In "for statement" with loop directive, index in a non-distributed array is not correct. ([xmp-users-ja:3])
