Implementation Status version 0.9.1
---------------------------------------
# Global-View
* Not support the async clause of the gmove directive
* Not support tasks directive
* Not support gmove in/out clause
* In XMP/C, not support block(n) distribution in distribute directive
* In a task construct, a section of a node array or a template shall not appear in the on clause of a directive.

# Local-View
* The manner in the latest XMP Specification has been supported. 
--
    int a[100]:[*];       // describing specification of a coarray
--

* "Coarray" and "image" directives in the latest XMP Specification are not supported.
* In XMP/Fortran, not support following remote access functions
    * Coarray, "Post/wait", "lock/unlock"
* On the K computer and FX10, not support stride access of coarray, "lock/unlock".

* Implementation status on Coarray Fortran is shown in the other file ../STATUS_COARRAY.md.

# Intrinsic and Library Procedures
* Not support following image index translation intrinsic procedures
    * xmp_get_primary_image_index()
    * xmp_get_image_index()

* In XMP/C, not support following synchronization functions of coarray
    * xmp_sync_image()
    * xmp_sync_images()
    * xmp_sync_images_all()

* Not support the following functions
    * xmp_nodes_attr()

# Known issues
## XMP/C
* In "for statement" with loop directive, a distributed array cannot be used with different distribution manner.
* In "for statement" with loop directive, index in a non-distributed array is not correct. ([xmp-users-ja:2]).
