#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20120115

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

#define YYPREFIX "yy"

#define YYPURE 0

#line 307 "F95-parser.y"
#include "F-front.h"
static int st_no;

static char *formatString = NULL;

/* omp buffer for simple omp lex.  */
static char *pragmaString = NULL;

typedef union {
    expr val;
    int code;
} yyStackType;

#define YYSTYPE yyStackType

extern void     yyerror _ANSI_ARGS_((char *s));
extern int      yylex _ANSI_ARGS_((void));
static int      yylex0 _ANSI_ARGS_((void));
static void     flush_line _ANSI_ARGS_((void));

static void set_pragma_str _ANSI_ARGS_((char *p));
static void append_pragma_str _ANSI_ARGS_((char *p));

#define GEN_NODE(TYPE, VALUE) make_enode((TYPE), ((void *)((_omAddrInt_t)(VALUE))))
#define OMP_LIST(op, args) list2(LIST, GEN_NODE(INT_CONSTANT, op), args)
#define XMP_LIST(op, args) list2(XMP_PRAGMA, GEN_NODE(INT_CONSTANT, op), args)

/* statement name */
expr st_name;

static expr
gen_default_real_kind(void) {
    return list2(F_ARRAY_REF,
                 GEN_NODE(IDENT, find_symbol("kind")),
                 list1(LIST, 
                       make_float_enode(F_DOUBLE_CONSTANT,
                                        0.0,
                                        strdup("0.0D0"))));
}
    
#line 60 "F95-parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define EOS 257
#define CONSTANT 258
#define IDENTIFIER 259
#define GENERIC_SPEC 260
#define UNKNOWN 261
#define STATEMENT_LABEL_NO 262
#define TRUE_CONSTANT 263
#define FALSE_CONSTANT 264
#define KW_INTEGER 265
#define KW_REAL 266
#define KW_COMPLEX 267
#define KW_DOUBLE 268
#define KW_DCOMPLEX 269
#define KW_LOGICAL 270
#define KW_CHARACTER 271
#define KW_UNDEFINED 272
#define KW_NONE 273
#define PARAMETER 274
#define INCLUDE 275
#define LET 276
#define ARITHIF 277
#define LOGIF 278
#define IFTHEN 279
#define ASSIGN 280
#define ASSIGNMENT 281
#define BLOCKDATA 282
#define CALL 283
#define CLOSE 284
#define COMMON 285
#define CONTINUE 286
#define DATA 287
#define DIMENSION 288
#define CODIMENSION 289
#define DO 290
#define ENDDO 291
#define DOWHILE 292
#define WHILE 293
#define ELSE 294
#define ELSEIF 295
#define ELSEIFTHEN 296
#define END 297
#define ENDFILE 298
#define ENDFILE_P 299
#define ENDIF 300
#define ENTRY 301
#define EQUIV 302
#define EXTERNAL 303
#define FORMAT 304
#define FUNCTION 305
#define GOTO 306
#define IMPLICIT 307
#define IMPLICIT_NONE 308
#define SET_LEN 309
#define SET_KIND 310
#define INTRINSIC 311
#define NAMELIST 312
#define PAUSE 313
#define PRINT 314
#define PROGRAM 315
#define READ 316
#define READ_P 317
#define RETURN 318
#define SAVE 319
#define STOP 320
#define SUBROUTINE 321
#define THEN 322
#define P_THEN 323
#define KW_TO 324
#define WRITE 325
#define WRITE_P 326
#define OPEN 327
#define INQUIRE 328
#define BACKSPACE 329
#define BACKSPACE_P 330
#define REWIND 331
#define REWIND_P 332
#define POINTER 333
#define ENDPROGRAM 334
#define MODULE 335
#define ENDMODULE 336
#define INTERFACE 337
#define INTERFACEASSIGNMENT 338
#define INTERFACEOPERATOR 339
#define ENDINTERFACE 340
#define PROCEDURE 341
#define MODULEPROCEDURE 342
#define PRIVATE 343
#define SEQUENCE 344
#define RESULT 345
#define RECURSIVE 346
#define PURE 347
#define ELEMENTAL 348
#define CONTAINS 349
#define KW_TYPE 350
#define ENDTYPE 351
#define ALLOCATABLE 352
#define INTENT 353
#define EXIT 354
#define CYCLE 355
#define PUBLIC 356
#define OPTIONAL 357
#define TARGET 358
#define WHERE 359
#define ELSEWHERE 360
#define ENDWHERE 361
#define FORALL 362
#define ENDFORALL 363
#define ENDFUNCTION 364
#define ENDSUBROUTINE 365
#define ENDBLOCKDATA 366
#define SELECT 367
#define CASEDEFAULT 368
#define CASE 369
#define ENDSELECT 370
#define KW_DEFAULT 371
#define KW_WHILE 372
#define KW_USE 373
#define KW_ONLY 374
#define ALLOCATE 375
#define DEALLOCATE 376
#define NULLIFY 377
#define KW_STAT 378
#define SYNCALL 379
#define SYNCIMAGES 380
#define SYNCMEMORY 381
#define LOCK 382
#define UNLOCK 383
#define CRITICAL 384
#define ENDCRITICAL 385
#define ERRORSTOP 386
#define KW_SYNC 387
#define KW_ALL 388
#define KW_IMAGES 389
#define KW_MEMORY 390
#define KW_ERROR 391
#define REF_OP 392
#define L_ARRAY_CONSTRUCTOR 393
#define R_ARRAY_CONSTRUCTOR 394
#define KW_IN 395
#define KW_OUT 396
#define KW_INOUT 397
#define KW_LEN 398
#define KW_KIND 399
#define KW_DBL 400
#define KW_SELECT 401
#define KW_BLOCK 402
#define KW_ENDBLOCK 403
#define KW_GO 404
#define KW_PRECISION 405
#define OPERATOR 406
#define COL2 407
#define POWER 408
#define CONCAT 409
#define AND 410
#define OR 411
#define NEQV 412
#define EQV 413
#define NOT 414
#define EQ 415
#define LT 416
#define GT 417
#define LE 418
#define GE 419
#define NE 420
#define USER_DEFINED_OP 421
#define PRAGMA_SLINE 422
#define PRAGMA_HEAD 423
#define OMPKW_LINE 424
#define OMPKW_PARALLEL 425
#define OMPKW_END 426
#define OMPKW_PRIVATE 427
#define OMPKW_SHARED 428
#define OMPKW_DEFAULT 429
#define OMPKW_NONE 430
#define OMPKW_FIRSTPRIVATE 431
#define OMPKW_REDUCTION 432
#define OMPKW_IF 433
#define OMPKW_COPYIN 434
#define OMPKW_DO 435
#define OMPKW_LASTPRIVATE 436
#define OMPKW_SCHEDULE 437
#define OMPKW_STATIC 438
#define OMPKW_DYNAMIC 439
#define OMPKW_GUIDED 440
#define OMPKW_ORDERED 441
#define OMPKW_RUNTIME 442
#define OMPKW_AFFINITY 443
#define OMPKW_SECTIONS 444
#define OMPKW_SECTION 445
#define OMPKW_NOWAIT 446
#define OMPKW_SINGLE 447
#define OMPKW_MASTER 448
#define OMPKW_CRITICAL 449
#define OMPKW_BARRIER 450
#define OMPKW_ATOMIC 451
#define OMPKW_FLUSH 452
#define OMPKW_THREADPRIVATE 453
#define OMPKW_WORKSHARE 454
#define OMPKW_COPYPRIVATE 455
#define XMPKW_LINE 456
#define XMPKW_END 457
#define XMPKW_NODES 458
#define XMPKW_TEMPLATE 459
#define XMPKW_TEMPLATE_FIX 460
#define XMPKW_DISTRIBUTE 461
#define XMPKW_ALIGN 462
#define XMPKW_SHADOW 463
#define XMPKW_TASK 464
#define XMPKW_TASKS 465
#define XMPKW_LOOP 466
#define XMPKW_REFLECT 467
#define XMPKW_GMOVE 468
#define XMPKW_BARRIER 469
#define XMPKW_REDUCTION 470
#define XMPKW_BCAST 471
#define XMPKW_WAIT_ASYNC 472
#define XMPKW_COARRAY 473
#define XMPKW_WAIT 474
#define XMPKW_POST 475
#define XMPKW_CRITICAL 476
#define XMPKW_ARRAY 477
#define XMPKW_LOCAL_ALIAS 478
#define XMPKW_ON 479
#define XMPKW_ONTO 480
#define XMPKW_WITH 481
#define XMPKW_FROM 482
#define XMPKW_WIDTH 483
#define XMPKW_PERIODIC 484
#define XMPKW_ASYNC 485
#define XMPKW_NOWAIT 486
#define XMPKW_MASTER 487
#define XMPKW_IN 488
#define XMPKW_OUT 489
#define XMPKW_BEGIN 490
#define XMPKW_MASTER_IO 491
#define XMPKW_GLOBAL_IO 492
#define XMPKW_ATOMIC 493
#define XMPKW_DIRECT 494
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    0,  181,  182,  180,  180,  180,  183,  180,  180,
  180,   55,   55,   55,   55,   55,   55,   55,   55,   55,
   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
   55,   55,   55,   55,   55,   55,   55,   55,   55,   55,
   55,   55,   55,   55,   55,   55,   55,   56,   66,   66,
  165,  165,  147,  147,  147,  147,  147,  147,  147,  147,
  147,  147,  147,  147,  147,  147,  147,  147,  147,  147,
  146,  146,  145,  148,  148,  149,  149,  149,  143,  144,
  144,   67,   67,   67,   68,   68,   69,   69,   70,   71,
   71,   71,   71,   71,   71,   71,   71,   71,   71,   71,
   71,   71,   71,  150,  150,  150,  150,  150,  150,  150,
  150,  150,  150,  150,  150,  150,  150,  150,  150,  150,
  150,  150,  161,  161,  162,  162,  162,  163,  163,  164,
  172,  172,  173,  174,  174,  175,  175,  184,  184,  151,
  151,  152,  152,  152,  152,  152,  152,  152,  152,  152,
  152,  152,  152,  153,  153,  154,  154,  154,   78,   78,
   79,   79,   79,   79,   80,   81,   81,   81,   81,   81,
   81,  166,  166,  166,  166,  155,  157,  157,  157,  157,
  157,  157,  157,  157,  157,  158,  159,  159,  160,  156,
  156,  156,  156,   82,   82,   82,  185,   83,   83,   83,
   83,   84,   84,  102,   85,   85,   86,   86,   87,   87,
   91,   91,   88,   88,   89,   90,   90,   92,   92,   93,
   94,   94,   95,   95,   95,   96,   96,   96,   97,   97,
   97,   98,   98,   99,   99,  123,  123,  124,  124,  122,
  122,  100,  100,  101,  104,  104,  103,  103,  105,  105,
  106,  106,  107,  107,  107,  108,  109,  109,  110,  110,
  111,  111,  112,  112,  113,  113,  113,  113,  114,  114,
  115,  115,  116,  116,  117,  117,  119,  119,  118,  118,
  120,  120,  121,  121,   72,   72,   72,   72,   72,   72,
   72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
   72,   72,   72,   72,   72,   72,   72,   76,   76,   77,
  125,  125,   73,   73,   74,   74,   75,   75,   75,   75,
   75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
   75,   75,   75,  167,  167,  167,  167,  167,  176,  176,
  177,  177,  168,  168,  169,  169,  169,  169,  169,  169,
  169,  170,  186,  186,  131,  131,  128,  127,  127,  127,
  126,  126,  126,  126,  126,  126,  171,  171,  171,  129,
  130,  130,  133,  133,  133,  133,  133,  133,  133,  133,
  133,  133,  133,  133,  133,  133,  133,  133,  133,  135,
  135,  136,  136,  136,  136,  136,  136,  132,  134,  134,
  137,  137,  138,  138,  139,  139,  139,  139,  139,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,   57,   57,   57,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   59,   59,   59,   59,
   59,   59,   59,   59,   60,   60,   60,   60,   60,   60,
   60,   60,   61,   61,   61,   61,   65,   65,  142,   62,
   63,   63,  140,  140,  140,  140,  140,  140,  141,  141,
   64,   64,   64,  178,  178,  179,  179,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    3,
    3,    4,    4,    4,    5,    5,    6,    6,    7,    7,
    7,    8,    8,  187,    8,    8,    8,    8,    8,    8,
  188,    8,    8,   14,   14,   14,   14,   14,   14,   14,
   14,    9,    9,   11,   11,   11,   11,   12,   12,   13,
   13,   13,   13,   10,   10,   10,   15,   15,   15,   15,
   15,   15,   15,   15,   15,   15,  190,   15,   15,   15,
  191,   15,   15,   15,   15,   15,   15,   15,   15,   16,
   16,   16,   16,   16,   16,   17,   17,   18,   18,   19,
   19,   20,   20,   21,   21,   21,   22,   23,   23,   24,
   24,   25,   26,   26,   27,   27,   27,   27,   28,   28,
   29,   30,   30,   31,   31,   31,   31,   36,   36,   36,
   36,   32,   32,   33,   33,   33,   33,   34,   34,   35,
   35,   35,   35,  195,   37,   38,   38,   39,   54,   54,
   54,   54,   54,   54,   54,   54,   40,   40,   41,   42,
   42,   43,  196,   43,  197,   43,   44,   44,   45,   45,
   52,   52,   53,   53,   53,   53,   51,   51,   46,   46,
   47,   47,   48,  199,  194,  200,  192,  201,  193,  202,
  198,  203,  189,   49,   49,   50,   50,   50,   50,   50,
   50,
};
static const short yylen[] = {                            2,
    0,    3,    0,    0,    1,    2,    2,    0,    3,    2,
    1,    2,    2,    2,    2,    5,    4,    2,    1,    2,
    5,    5,    5,    5,    1,    2,    2,    2,    3,    4,
    2,    5,    6,    6,    7,    7,    2,    3,    4,    5,
    1,    1,    1,    1,    2,    1,    1,    1,    0,    1,
    0,    4,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    1,    1,    2,    1,    1,    1,    1,    0,
    1,    0,    2,    3,    1,    3,    1,    1,    1,    3,
    2,    3,    3,    2,    2,    1,    2,    2,    1,    3,
    4,    2,    1,    3,    6,    1,    2,    3,    3,    3,
    1,    2,    3,    1,    3,    1,    2,    5,    6,    7,
    7,    3,    1,    3,    1,    4,    8,    1,    3,    1,
    1,    3,    3,    1,    3,    1,    1,    0,    1,    3,
    4,    1,    1,    1,    4,    4,    1,    5,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    3,
    4,    6,    7,    6,    1,    4,    2,    2,    2,    1,
    1,    1,    1,    1,    1,    1,    0,    3,    3,    6,
    8,    3,    6,    2,    4,    3,    1,    1,    3,    3,
    3,    3,    3,    0,    2,    4,    1,    1,    2,    5,
    3,    1,    3,    2,    1,    3,    1,    3,    3,    5,
    1,    3,    1,    3,    5,    1,    1,    1,    3,    4,
    1,    3,    1,    2,    3,    1,    2,    2,    1,    1,
    1,    1,    3,    1,    1,    1,    3,    1,    1,    1,
    3,    1,    3,    3,    1,    3,    1,    5,    0,    3,
    1,    3,    1,    3,    1,    3,    1,    3,    1,    3,
    0,    3,    1,    3,    1,    3,    2,    1,    1,    1,
    1,    3,    1,    3,    5,    2,    1,    3,    1,    3,
    4,    6,    1,    3,    1,    6,    3,    4,    2,    2,
    1,    2,    5,    5,    6,    6,    2,    2,    4,    5,
    1,    5,    1,    4,    5,    2,    2,    0,    1,    3,
    5,    7,    1,    1,    2,    4,    5,    1,    2,    2,
    6,    6,    9,    2,    4,    5,    2,    2,    2,    1,
    1,    1,    1,    2,    2,    4,    4,    4,    1,    3,
    1,    1,    2,    4,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    1,    0,    1,    3,    0,    1,    3,
    1,    1,    2,    3,    5,    3,    1,    1,    3,    3,
    1,    3,    2,    4,    3,    4,    3,    4,    2,    4,
    4,    4,    3,    2,    3,    2,    3,    2,    5,    1,
    3,    1,    1,    1,    3,    3,    1,    3,    1,    1,
    0,    1,    1,    3,    1,    5,    5,    7,    5,    1,
    3,    3,    1,    1,    3,    3,    2,    2,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    2,    3,    3,    2,    1,    1,    2,    2,    3,
    3,    1,    2,    2,    3,    3,    3,    4,    4,    5,
    3,    4,    4,    5,    1,    2,    2,    3,    1,    2,
    2,    3,    3,    4,    3,    4,    1,    3,    2,    5,
    0,    1,    1,    3,    1,    1,    3,    3,    1,    1,
    5,    5,    5,    1,    3,    1,    3,    2,    2,    2,
    3,    3,    4,    2,    3,    3,    4,    1,    2,    3,
    1,    2,    1,    2,    4,    5,    1,    1,    1,    4,
    1,    2,    4,    1,    3,    3,    4,    0,    1,    0,
    1,    1,    3,    2,    1,    4,    0,    1,    1,    3,
    2,    4,    4,    0,    5,    4,    4,    4,    6,    4,
    0,    5,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    1,    3,    3,    5,    1,    3,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    1,    2,    0,    3,    2,    2,
    0,    3,    2,    2,    2,    4,    2,    2,    2,    4,
    6,    6,    5,    7,    7,    4,    5,    6,    7,    9,
   10,    4,    5,    4,    4,    7,    3,    4,    7,    5,
   10,    2,    3,    1,    8,    8,   11,    5,    3,    6,
    3,    7,    5,    2,    2,    2,    2,    3,    4,    1,
    1,    1,    3,    1,    3,    5,    1,    1,    3,    1,
    1,    4,    4,    0,    2,    0,    2,    5,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    3,    2,    0,
    3,    0,    0,    2,    0,    2,    1,    3,    1,    3,
    1,    3,    1,    3,    2,    4,    0,    4,    0,    1,
    1,    2,    4,    0,    2,    0,    2,    0,    2,    0,
    2,    0,    2,    0,    1,    0,    1,    1,    2,    1,
    2,
};
static const short yydefred[] = {                         1,
    0,   11,    0,    0,    0,    8,    0,   47,  172,  173,
  174,  170,  171,  175,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  318,    0,    0,    0,
    0,    0,    0,    0,   46,    0,    0,    0,    0,    0,
    0,  103,    0,    0,    3,   96,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    4,    0,    0,    0,    0,  116,   76,   77,   78,   41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  303,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  345,  352,  346,  347,  348,  349,  350,  351,
  333,    6,   42,   43,  285,  313,  314,    0,  165,  332,
    0,   74,   44,    0,  330,  331,    0,    0,   10,    0,
    0,    0,  511,    0,  498,    0,  501,    0,  507,  508,
    0,    0,  514,    7,    0,    2,    0,    0,  197,    0,
  169,    0,    0,   89,   45,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  413,  315,
    0,  436,    0,    0,    0,   48,    3,   50,   28,    0,
    0,    0,  202,    0,    0,    0,  198,    0,  247,    0,
  218,  245,    0,  139,    0,    0,    0,  290,   81,  292,
    0,  297,    0,  399,    0,  410,  386,    0,  394,  393,
    0,  397,    0,  390,  298,    0,    0,    0,    0,    0,
    0,    0,  319,    0,  273,    0,    0,    0,   98,    0,
  328,    0,   12,    0,    0,  327,    0,  329,    0,    0,
    0,    0,  384,    0,  388,    0,    0,    0,  213,    0,
   13,   79,   14,   15,   73,   18,    0,    0,    0,    0,
   20,  240,    0,    0,    0,    3,    0,    0,  107,    0,
    3,  335,  334,  239,  238,    0,    0,  236,    0,    0,
    0,    0,   37,   31,    0,  306,    0,  307,    0,    0,
    0,    0,    0,    3,    0,    0,    0,    0,    0,    0,
    0,   75,    0,    0,    0,  168,  167,  176,    0,    0,
  356,  343,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  543,    0,    0,  488,    0,  529,    0,
    0,  512,    0,    0,  502,    0,    0,  490,  494,  499,
    0,    0,    0,    3,    0,    0,    0,    0,    0,    0,
  684,    0,  577,    0,    0,  581,    0,    0,    0,  684,
    0,    0,    0,    9,  187,    0,    0,    0,    0,    0,
    0,    0,    0,  242,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  467,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  469,    0,    0,    0,    0,    0,
    0,    0,  204,    0,    0,    0,  199,    0,  354,    0,
    0,    0,    0,    0,  159,    0,    0,    0,  287,    0,
    0,    0,    0,  385,    0,    3,  211,    0,    0,  205,
    0,    3,    0,  271,    0,    3,    0,  207,    0,    0,
    0,    0,    0,  234,  235,    0,  232,   29,    0,    0,
    0,  383,  387,    0,    0,    0,    0,  123,    0,    0,
    0,    0,    0,    0,    0,    0,  104,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    3,    0,  341,    0,  342,    0,  339,    0,    0,    0,
    0,    0,    0,    3,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  359,    0,
  362,  368,    0,    0,    0,    0,  534,    0,    0,    0,
    0,  492,    0,  541,  496,  516,    0,  531,    0,    0,
    0,  519,  491,  495,  525,    0,  500,    0,  522,    0,
  515,    0,  552,    0,  554,    0,    0,  574,    0,    0,
    0,  567,    0,    0,  568,    0,    0,  572,    0,    0,
  569,    0,    0,  570,    0,    0,  571,  573,    0,    0,
  576,    0,    0,    0,  579,  580,    0,    0,    0,    0,
    0,  583,    3,    0,  584,    0,  587,  585,    0,    0,
  695,  588,  697,    0,    0,  589,    3,  179,    3,  182,
    3,  178,    0,    0,    0,  101,  479,  480,  474,  447,
    0,    0,    0,  441,    0,    0,  477,  478,    0,    0,
  403,  411,    0,    0,    0,  412,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  451,    0,  446,    0,    0,
    0,    0,    0,    3,    0,  325,    0,  382,  268,  269,
    0,    0,  263,  265,  203,  201,    0,    0,  219,  246,
    0,    0,    0,    0,  231,    0,  221,  223,    0,  230,
    0,    0,    0,    0,  288,  299,    3,  396,  395,    0,
  391,   87,   88,   83,    0,   85,    0,    0,  209,    0,
    0,    0,    0,    0,    0,  274,    0,    0,    0,    0,
    0,    0,    0,    0,  381,    0,    0,  214,    0,    0,
   17,   54,   70,   66,   67,   69,   68,   65,   59,   61,
   64,   62,   63,   60,   57,   58,   55,   56,    0,    0,
   71,    0,    0,    0,   53,    0,  241,  155,  154,    0,
  166,  156,  157,  158,    0,  237,    0,    0,  304,    0,
    0,    0,    0,    0,    0,    0,  456,    0,    0,  460,
    0,    0,  336,  338,  337,    3,  142,    0,    0,  147,
  149,  152,  151,  144,    0,  150,  153,  140,  143,    0,
    0,    0,    3,   30,    0,  191,  192,  190,  193,    0,
  363,    0,    0,    0,  357,    0,  344,    0,    0,    0,
    0,  551,  547,  548,  550,  549,  544,  545,  546,    0,
    0,    0,    0,    0,  530,  493,  497,  517,    0,    0,
  524,    0,  505,    0,  510,    0,    0,  513,  624,  625,
  626,  627,    0,  637,    0,  632,    0,    0,    0,    0,
    0,  640,    0,  638,    0,    0,    0,    0,    0,    0,
    0,  631,    0,    0,  685,  693,    0,  578,    0,    0,
    0,  612,    0,  681,    0,    0,  664,  666,  582,  614,
    0,  656,  652,  653,  655,  654,  649,  651,  650,    0,
    0,    0,    0,    0,    0,  699,  701,    0,    0,    0,
  185,    0,  243,    0,  370,  449,    0,  448,    0,    0,
  468,    0,    0,    0,  453,    0,  452,    0,    0,  294,
  293,    0,  317,  326,    0,    0,  262,    0,    0,    0,
  224,  229,  227,  228,    0,    0,  220,    0,    0,    0,
  160,    0,    0,    0,    0,   84,    0,   40,  212,    0,
  206,   32,    0,  272,    0,    0,  277,    0,  208,  283,
    0,    0,  233,  389,    0,    0,    0,  217,  130,    0,
  128,  124,    0,   16,   22,   24,   21,   23,    0,    0,
    0,  300,  309,  302,  487,  305,  485,    0,    0,    0,
  131,  463,    0,    0,  257,  259,    0,  458,  465,    0,
  462,  340,    0,    0,    0,    3,    3,  141,    0,    3,
  196,    0,    0,  360,  369,  532,  533,  565,  564,  566,
    0,  536,    0,  540,  538,  537,  560,  561,  562,  563,
    0,    0,    0,  523,  506,  553,  556,  555,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  686,    0,  688,    0,    0,    0,    0,  607,    0,  644,
    0,    3,  682,    0,  691,    0,    0,  619,    0,    0,
    3,    3,  621,  586,    0,    0,    0,    0,    0,    0,
  450,    0,    0,    0,    0,  404,  482,  483,  481,  454,
    0,    0,  295,    0,  266,  264,  200,  248,  222,  225,
  226,  255,    0,    0,  251,  253,    0,    0,  286,  296,
   86,    0,  210,  321,    0,    0,    0,  275,    0,    0,
  215,    0,    0,   72,  105,    0,    0,    0,    0,    0,
    0,  256,  464,  466,   34,    0,    0,    0,    0,   33,
    0,    0,  535,    0,  542,    0,  526,    0,    0,  633,
    0,    0,    0,  596,    0,  604,    0,    0,  639,    0,
  686,    0,    0,  688,    0,    0,  602,    0,    0,  628,
  684,    0,    0,    0,    0,    0,  613,    0,    0,  657,
    3,    0,    0,    0,    0,  180,    0,  183,    0,  407,
    0,  406,  409,  470,    0,    0,    0,  250,    0,    0,
    0,    0,    0,  280,  278,  284,  282,  129,    0,    0,
  133,    0,  136,    0,  134,  132,  260,  258,  145,  146,
    0,   35,   36,    0,  539,    0,  557,    0,  669,    0,
    0,    0,    0,    0,  643,  642,    0,    0,    0,  687,
    0,    0,  689,    0,  629,    0,  608,    0,  645,    0,
  610,  683,    0,  659,    0,  648,    0,    0,    0,    0,
  618,    0,  623,    0,    0,    0,    0,    0,  254,  252,
    0,    0,    0,    0,   52,    0,    0,  148,  591,  592,
    0,    0,    0,    0,    0,  598,    0,    0,    0,  644,
  647,    0,    0,  658,  620,  678,    3,    3,    0,  181,
  408,  323,  163,    0,  135,  670,    0,    0,  606,    0,
    0,    0,    0,    0,    0,  671,    0,  661,    0,    0,
  622,  127,    0,    0,  609,    0,    0,    3,    0,  616,
    0,  615,  600,    0,    0,  672,    0,  674,    3,    0,
  676,  611,    0,  617,
};
static const short yydgoto[] = {                          1,
  144,  553,  557,  558,  559,  327,  328,  329,  564, 1041,
  567, 1051, 1052,  840,  364,  572,  575,  581,  584,  587,
  578,  588,  888,  595,  596,  899,  605,  602,  608,  607,
  568,  865,  866,  873,  874,  884, 1192, 1269,  603, 1199,
 1200, 1274,  597,  890, 1250,  892,  893,  894,  612,  616,
 1088, 1335, 1336,  910,  112,  454,  230,  206,  168,  503,
  504,  415,  867,  169,  384,  179,  446,  715,  716,  155,
  113,  114,  115,  116,  117, 1002, 1003,  434,  435,  118,
  119,  306,  185,  465,  451,  459,  218,  248,  249,  987,
  448,  190,  191,  696,  697,  698,  699,  466,  467,  373,
  374,  187,  192,  193,  960, 1124, 1125,  787, 1014, 1015,
  423,  682,  683,  684,  455,  224,  225,  977,  978,  229,
  981,  263,  277,  278,  198,  529,  530,  378,  379,  632,
  312,  212,  120,  207,  213,  214,  984,  640,  641,  171,
  629,  172,  255,  200,  256,  760,  761,  121,  122,  123,
  296,  808,  809,  775,  307,  308,  151, 1098,  367, 1096,
  477,  478,  990,  991,  968,  124,  125,  126,  127,  128,
  534, 1010, 1233, 1234, 1235,  506,  507,  499,  500,    7,
  226,  258,  145,  195,  309,  426,  830,  844,  591,  593,
  600, 1182, 1185,  589, 1193,  598,  599,  895,  590, 1183,
 1186,  896,  592,
};
static const short yysindex[] = {                         0,
  424,    0, 3980, -292, 1404,    0, -101,    0,    0,    0,
    0,    0,    0,    0,  163,  149,  -31,  262,  252,  258,
  279,   74,  269,  317,  561,   47,    0,  151,  203,  -75,
  358,  593,  358,  598,    0,  191,   76,  358,  393,  631,
  203,    0,  420,  219,    0,    0,  203,  638,  262,  191,
  269,  191,   76,  262,  203,  262,  442,   76,  672,  690,
  191,   76,  191,   76,   -2,  358,  477,  358,  477,  723,
    0,  323,  483,  483,  203,    0,    0,    0,    0,    0,
   21,  519,  203,  733,  358,  358,  -81,  203,  203,  742,
  761,    0,  358,  358,  765,  358,  777,  358,  580,  805,
  821,  827,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   53,    0,    0,
 1298,    0,    0,  202,    0,    0,  854,  861,    0, 2988,
 1322, 1762,    0, 1762,    0, 1762,    0,  863,    0,    0,
  865,  871,    0,    0, 3433,    0,  662,  662,    0,  662,
    0,  301,  656,    0,    0,  828,  131,  833,  839,  724,
  262,  262,  262,  262,  674,  692,  874,  619,    0,    0,
  882,    0,  262,  262,  262,    0,    0,    0,    0,  902,
   76,  908,    0,  698,  918,  714,    0,  151,    0,  937,
    0,    0,  679,    0,  731,  938,  -13,    0,    0,    0,
  262,    0,  262,    0, 3735,    0,    0,  569,    0,    0,
 3735,    0,  574,    0,    0,  961,  744,  989,  746,  961,
  937,   74,    0,  995,    0, 1427,  795,  803,    0, 3735,
    0, 1020,    0, 1022,  603,    0,   56,    0,  961,  677,
   76,   76,    0,  705,    0,  711,  744, 1029,    0,  822,
    0,    0,    0,    0,    0,    0, 1024, 1066, 1074, 1083,
    0,    0, 1042, 1042,  398,    0,  869,  873,    0,  822,
    0,    0,    0,    0,    0,  398, 1099,    0,  483,  822,
  262,  262,    0,    0,  262,    0,  262,    0, 1104,  893,
  893,  893,  898,    0,  318,   22,  731,  904,  905, 1125,
  870,    0,  748,  262,  262,    0,    0,    0, 1049,  778,
    0,    0,  857, 1134, 1148, 1150, 1158, 1171, 1172, 1173,
 1762, 1177, 1178,    0, 1762, 1762,    0,  166,    0, -203,
  789,    0,  789,  179,    0, 1187,  789,    0,    0,    0,
  988, 1017,   93,    0,  223,  236,  244,  260,  268,  270,
    0,    0,    0, 1208,    0,    0, 1215, 1222, 1237,    0,
 1023,  793,  319,    0,    0, 3735,  781,  792,  808,  867,
 3735, 1234,  883,    0,  568, 1050,  262,  633, 1273,  568,
  568,  951, 3735,   40,    0, 1644, 3774,   54,   54, 1253,
 1820,  262,  262,  262,  262,  262,  262,  262,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,  262,
 1056,  652, 1279,  262,    0, 2868, 2882, 2924,  993,  159,
  895,  390,    0, 1278,  714,   12,    0, 1294,    0,  151,
  151,  579,  908, 1301,    0,  262, 1309, 1094,    0, 2952,
 2977,  571,   76,    0,  155,    0,    0,  903, 1317,    0,
 1314,    0, 1319,    0,  926,    0, 1276,    0, 1324, 1331,
  724,  724,  724,    0,    0, 1338,    0,    0,  724,  927,
  936,    0,    0, 1340, 1351, 1352, 1357,    0, 1380, 3750,
 1366, 3464, 1182, 1099, -136, 1408,    0, 1357,  702, 1099,
  398, 1042, 1357, 2992, 3042, 3056, 3735, 1398, 1416, 1414,
    0,  600,    0,  749,    0,  945,    0,  954,  956,  961,
 4080, 1207,  731,    0, 1301,  961,  961, 1223, 1430, 3081,
 3111, 3126, 1016, 3735,  602,   74, 3735,   17,    0,  969,
    0,    0, 3735,  974, 1017, 1017,    0, 1017,  473,  262,
   93,    0, 1017,    0,    0,    0, 1762,    0,  789,  789,
  789,    0,    0,    0,    0, 1453,    0,  -30,    0, 1236,
    0, 1446,    0,  975,    0, 1240,  976,    0,  386, 1461,
 1097,    0, 1466, 1097,    0, 1477,  226,    0, 1494,  226,
    0, 1510, 1097,    0, 1520, 1097,    0,    0,   86, 1040,
    0, 1041, 1531,  262,    0,    0,    0, 1085, 1098,    0,
  506,    0,    0,  262,    0,  262,    0,    0,   86, 1189,
    0,    0,    0, 1093, 1109,    0,    0,    0,    0,    0,
    0,    0,  980,  262,  656,    0,    0,    0,    0,    0,
 3735,  120, 1346,    0, 1569, 1348,    0,    0, 1942, 1564,
    0,    0,  724,  262, 1111,    0, 3735, 1203,   43, 1644,
 3820, 3787, 3787,   35,   35,   35,   35,   35,   35, 3774,
   54,   54, 1203, 1203, 3735,    0, 1350,    0, 1575, 1354,
 1557,   74, 3665,    0, 1359,    0,  982,    0,    0,    0,
 2081,  994,    0,    0,    0,    0,  937,  274,    0,    0,
  854,  629,  629,  674,    0,  996,    0,    0, 1574,    0,
 1529,  731, 3394,  262,    0,    0,    0,    0,    0, 3735,
    0,    0,    0,    0, 1003,    0, 1277,  744,    0,  744,
 1362, 1277,   74,   74,  937,    0, 1368, 1370, 1372, 1581,
 1581, 1581,   56, 1581,    0,  724, 1374,    0, 1570,  822,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1375, 1595,
    0, 1598, 1599, 1600,    0, 1602,    0,    0,    0, 1242,
    0,    0,    0,    0, 1606,    0,  744,  744,    0,  262,
  358,  262,  -93,  262, 1396, 1196,    0,  132, 1400,    0,
  139,  893,    0,    0,    0,    0,    0, 1617, 1572,    0,
    0,    0,    0,    0, 1621,    0,    0,    0,    0,  961,
 1301, 4080,    0,    0,  961,    0,    0,    0,    0, 1008,
    0,  262,  262,  778,    0,  778,    0, 1019, 1027, -175,
 1033,    0,    0,    0,    0,    0,    0,    0,    0, 1608,
 3140, 1038, 1046,  430,    0,    0,    0,    0, 1017,  179,
    0, 1623,    0, 1409,    0, 1622,  103,    0,    0,    0,
    0,    0, 1097,    0, 1052,    0, 1613, 1097, 1078, 1097,
 1632,    0, 1092,    0,  226, 1103, 1097, 1114, 1097, 1132,
 1636,    0, 1097,    0,    0,    0, 1097,    0,   86, 1141,
 3735,    0,    0,    0, 1637, 1193,    0,    0,    0,    0,
   86,    0,    0,    0,    0,    0,    0,    0,    0, 1624,
    0, 1143, 1199,    0, 1424,    0,    0, 1285, 1287, 1289,
    0, 3735,    0,  262,    0,    0, 1431,    0, 1209, 1084,
    0, 3157, 1658, 3176,    0, 1451,    0,  262, 1657,    0,
    0, 1389,    0,    0, 1196,  390,    0,  714,  606, 1671,
    0,    0,    0,    0, 3439,  579,    0, 1251,  632, 1672,
    0,  262, 3190, 1391,  281,    0, 1675,    0,    0, 1201,
    0,    0, 1212,    0,  262, 1673,    0,  136,    0,    0,
 1677,  724,    0,    0, 1581,  908, 1676,    0,    0, 1224,
    0,    0, 1670,    0,    0,    0,    0,    0, 1463,  203,
  874,    0,    0,    0,    0,    0,    0, 1334, 1666, 1681,
    0,    0, 3681,  144,    0,    0, 1468,    0,    0, 1469,
    0,    0, 1277,  390,  632,    0,    0,    0, 1277,    0,
    0, 3735, 1674,    0,    0,    0,    0,    0,    0,    0,
 1688,    0, 1017,    0,    0,    0,    0,    0,    0,    0,
 1689, 1687, 1228,    0,    0,    0,    0,    0, 1474, 1229,
 1097,   81,  262, 1249, 1328, 1258, 1244,  226, 1478, 1260,
    0, 1270,    0, 1295, 1347, 1097, 1698,    0, 1296,    0,
  262,    0,    0, 1482,    0,    0, 1493,    0,   86, 1716,
    0,    0,    0,    0, 1697, 1719, 1700, 1723, 1704, 3735,
    0, 3176, 1726, 1310, 1727,    0,    0,    0,    0,    0,
 1731,   74,    0, 3735,    0,    0,    0,    0,    0,    0,
    0,    0, 3698,  146,    0,    0,   20, 3616,    0,    0,
    0,  477,    0,    0, 3735, 1514, 1368,    0, 1515,  638,
    0, 1570, 1383,    0,    0,  483, 1519, 1527, 1528, 1196,
 1196,    0,    0,    0,    0, 1332,  154,  702, 1277,    0,
 1277,  262,    0, 1339,    0,  262,    0, 1741, 1728,    0,
 1532,  113, 1735,    0, 1532,    0, 1757, 3204,    0, 1760,
    0, 1542, 1323,    0, 1543, 1325,    0, 1532, 1345,    0,
    0,    0, 1335, 3735, 1321, 1766,    0, 1761, 1349,    0,
    0,  262,  884, 1330,  262,    0,  262,    0,  262,    0,
 1084,    0,    0,    0, 1773, 1196,  632,    0,  262,  262,
  579,  262, 1787,    0,    0,    0,    0,    0, 1573, 1042,
    0, 1334,    0, 1789,    0,    0,    0,    0,    0,    0,
 1793,    0,    0, 3735,    0, 3735,    0,  235,    0, 1791,
 1429, 1433,  262, 1791,    0,    0, 1097, 1578, 1434,    0,
 1583, 1803,    0, 1791,    0,   86,    0, 1215,    0, 1804,
    0,    0,  483,    0, 1493,    0,    0, 3263,   86,   86,
    0,   86,    0, 3735, 3735, 3278, 1805,   74,    0,    0,
 3735, 3735, 1367, 3735,    0, 1807, 1527,    0,    0,    0,
 1591, 1532, 1532, 3735, 1371,    0, 1532, 1819, 1097,    0,
    0,   66, 1369,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1828,    0,    0, 1791, 1791,    0, 1791,
 1097, 1376,    0,  262, 1378,    0, 1802,    0,    0, 1393,
    0,    0, 1382, 1467,    0, 1812,   66,    0,  262,    0,
   86,    0,    0, 1532,  262,    0,    0,    0,    0, 1791,
    0,    0,    0,    0,
};
static const short yyrindex[] = {                         0,
    0,    0, 1618,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1105,    0,    0,    0,    0,    0,
    0,    0, 1619,    0,    0,    0,    0,    0, 1625, 1620,
 1626,    0, 1626,    0,    0,    0,    0, 1626,    0,    0,
 1625,    0,    0,    0,    0,    0, 1625,    0, 1628,    0,
 1619,    0,    0, 1628,   92, 1628,    0,    0,    0,    0,
    0,    0,    0,    0, 1625, 1626,    0, 1626, 1645,    0,
    0, 1646,    0,    0,  332,    0,    0,    0,    0,    0,
 1625, 1647, 1625,    0, 1626, 1626, 1648, 1625, 1625,    0,
 1649,    0, 1626, 1626,    0, 1626,    0, 1626,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1625,    0,    0,
    0,    0,    0, 1128,    0,    0, 1650,    0,    0, 1651,
    0, 1651,    0, 1651,    0, 1651,    0, 1659,    0,    0,
 1660,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  813, 1701,  911,  987,    0,
    0,    0,    0,    0,    0,    0, 3720, 1738,    0,    0,
 1403,    0,    0,    0,    0,    0,    0,    0,    0, 1661,
    0,   70,    0,    0,   65,    0,    0,    0,    0,  243,
    0,    0,    0,    0,    0,    0, 1663,    0,    0,    0,
    0,    0,    0,    0,  117,    0,    0, 2414,    0,    0,
 1384,    0,    0,    0,    0, -128,    0, 1665,    0, -128,
  320,    0,    0, 1667,    0,    0,    0,    0,    0,  204,
    0, 1678,    0, 1679,    0,    0,    0,    0, 1680,    0,
    0,    0,    0,    0,    0,    0,    0, 1682,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1690, 1702,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1712,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1824,    0, 1713,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   64,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1651,    0,    0,    0, 1651, 1651,    0, 1714,    0, 1715,
 1717,    0, 1717, 1718,    0, 1720, 1717,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -150,    0,    0, -132,    0,    0,    0,    0,    0,
    0, 1721, 1724,    0,    0, 1388,    0,    0,    0,    0,
 1333,    0,    0,    0,    0,    0,    0, 1868, 1479,    0,
    0,    0,  110,    0,    0,  452, 3660, 2203, 2256,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1921, 1533, 1824,    0,    0,    0,    0,    0,   79,
    0,    0,    0,    0,   32,    0,    0,    0,    0,    0,
    0,    0,   91, 1733,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1734,    0,    0,    0,    0,    0,  273,    0, 1736,    0,
    0,    0, 1737,    0,    0, 1739,    0,    0, 1742,    0,
    0,    0,    0,    0,    0,  487, 1743,    0,    0,    0,
    0,    0,    0, 1745,    0,    0,    0, 1747,    0, 1748,
    0, 1750, 1754,    0,    0,    0,  655,    0,    0, 1837,
    0, 1390,    0, 1394,    0,    0,    0,    0,    0, -128,
    0,    0,    0,    0, 1755, -128, 1680,    0,    0,    0,
    0,    0,    0, 1327, 1136,    0,   69,    0,    0,    0,
    0,    0, 1395,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1717, 1717,
 1717,    0,    0,    0,    0,    0,    0, 1756,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  704,    0,    0,  704,    0,    0,    0,    0,    0,    0,
    0,    0,  704,    0,    0,  704,    0,    0,    0,    0,
    0,    0, 1422,    0,    0,    0, -116,    0,    0,   13,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1758, 1774,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  165,    0,    0,    0, 1609,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1775, 1997, 2462, 2593,
 2917, 3387, 3609, 2644, 2669, 2720, 2727, 2803, 2861, 3664,
 2334, 2385, 2127, 2164, 1776,    0,    0,    0, 1662,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1399,    0,    0,    0,    0,    0, 1634,    0,    0,    0,
  238,    0,    0,    0,    0,    0,    0,    0, 1418,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0, 1437,
    0,    0,    0,    0,    0,    0, 1777,    0,    0,    0,
    0, 1777,    0,    0, 1221,    0,    0,    0,    0, 1778,
 1779, 1780,    0, 1788,    0, 1794,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1882,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1800, 1800,    0, 1442,
 1626, 1824,    0,    0,    0,    0,    0, 1447,    0,    0,
 1448,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -128,
 1808,    0,    0,    0, -128,    0,    0,    0,    0,    0,
    0,    0,  704,   29,    0,   29,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  704,    0,    0,    0, 1456,  704,    0,  704,
 1472,    0,    0,    0,    0,    0,  704,    0,  704,    0,
  156,    0,  199, -116,    0,    0,  704,    0,    0,    0,
 1487,    0,  -82,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   90,    0,    0, -116,    0,    0,    0,    0,    0,    0,
    0, 1492,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1887,    0,    0,
    0,    0,    0,    0, 1497,    0,    0,    0, 2414,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  116,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  167,    0,    0,    0,    0,
  524,    0,    0,    0, 1809, 1889,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1625,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1810,
    0,    0,  171,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1777,    0,    0,    0,    0,    0, 1777,    0,
    0, 1498, 1517,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1890,    0,    0,    0,    0,    0,    0,    0,    0,
  704,    0,  704,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  704,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -116,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  528,
    0, 1888,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  126,    0,    0,    0,    0,    0,    0,
    0,    0,  171,    0,    0,    0,  494,  249,    0,    0,
    0,    0,    0,    0, 1811,    0,    0,    0, 1886,    0,
    0,    0,  497,    0,    0,    0,    0, 1830,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1777,    0,
 1777,    0,    0,    0,    0,    0,    0,    0, 1832,    0,
    0,    0, 1518,    0,    0,    0,    0,    0,    0, 1834,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -116,  -45, 1538,  -43,    0,    0, 1544,    0,    0,
    0,    0,  -43, -116,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1835,
    0,  502,    0, 1839,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1552,    0, 1893,    0,    0,    0, 1840,
    0,    0,    0, 1841,    0,    0,  704,    0,    0,    0,
    0,    0,    0, 1842,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  -43,    0,    0,    0,
    0,    0,    0, 1897, 1932,    0,    0,    0,    0,    0,
  514,  523,    0,  329,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1554,    0,    0,    0,    0,  704,    0,
    0,  704,    0,    0,    0,    0,    0,    0, -116,    0,
    0,    0,    0,    0,    0,    0, 1843, 1844,    0, 1845,
  704,    0, -116,  704,    0,    0, 1556,    0,  -43,  -43,
    0,    0,    0,    0,    0, 1560,  704,    0, 1442,    0,
    0,    0,    0,    0, 1442,    0,  -43,    0,    0, 1846,
    0,    0,  -43,    0,
};
static const short yygindex[] = {                         0,
    0,  246,    0,    0, -475,  624,    0,  -12, -481,    0,
 1435,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -559, -697, -408,  912, -598,  678,    0,  730,    0,
  717,    0,    0,  102, -488, -572,    0, 1130,    0,    0,
 -379,    0,  699,    0,    0,  -21,  -16,    7,    0,    0,
    0, -184,  -49, -419,    0, 1999, -179,    0, 1129,    0,
    0,    0,    0, 1432, 1458, 1326, 2058,  225, 1405,   41,
    0, 1146,    0,   -7,    0,    0,    0,    0, 1640,    0,
 1413,    0, 1699,  914, 1180, 1176, -519,    0, 1407,    0,
 1512, -169, -333, 1950,    0, 1116,  925, -380,    0,  992,
 1711, 1137, 1206, -753, 1439,    0, 1707, 1028,    0, 1026,
    0,  -71,  305, 1669, -189, -269, 1744,  -95,  -79,    0,
    0, -239,    0,  913, 1288, 1732,    0, -393, -154, -414,
  451,    0,  -63,    6, 2095,    0, 1694, 2059,  433,    0,
    0, 1385, 1696, 1021,    0,    0,    0,    0,  644,    0,
   16, 1443,    0, 1044, -627,    0,    0,    0,    0,    0,
    0,    0, -734,    0,  885,  590, 1392, 1410,    0,    0,
 -151,    0,    0,  -25, 2172, -178,    0,    0,    0,    0,
    0, 1031, 1018, -350,    0,    0,    0, -882,    0,    0,
    0,    0,    0,
};
#define YYTABLESIZE 4438
static const short yytable[] = {                        231,
  177,  166,  264,  253,  236,  385,  238,  439,  197,  609,
  914,  430,  695,  850,  869,  219,  427,  700,  186,  205,
  211,  227,  223,  878,  167,  419,  880,  900, 1090,  237,
  438,  311, 1016,  205,  189,  205,  211,  247,  202,  250,
  452,  211,  453,  215,  205,  211,  205,  211, 1011,  265,
  505,  505,  505,  828,  829,  268,  831,  270,  184,  468,
  267,  843,  279,  280,  266,  514, 1221,  730,  731,  732,
  531,  251,  412,  254,  823,  734,  408,  406,  354,  407,
 1220,  409,  851,  643,  408,  406,  471,  407,  413,  409,
  272,  273,  297,  184,  972,  408,  294,  690,  283,  284,
  409,  286,  184,  288,  358,  165,  575,  358,  163,  361,
  164,  353,  361,  261,  485,  165,  261,  210,  163,  489,
  164,  471,  358,  790,  662,  883,  472,  882,   82,  129,
  366,  366,  261,  366,  261,  371,  471,  261,  138,  566,
  679, 1172,  511,  383,  386,  387,  388,  389,  391, 1059,
  405,  261,  883,  405, 1251,  146,  416,  417,  418,  194,
  400,  301,  194,  924,  211, 1008,  270,  376, 1017,  270,
  310,  876,  953,  954,  680, 1020,  194,  274,  275, 1137,
  531,  261,  176,  196,  440, 1077,  441, 1151,  153, 1217,
  188, 1115,  569,  634,  189,  714,  713, 1217,  165,  676,
  526,  163,  150,  164,  149, 1126,  768,  492,  371,  547,
  279,  646,  925,  677,  270,  249,   82,  249,  270,  769,
  249,  377,  786,  447,  211,  211,  154,  668, 1138,  786,
  165,  549,  204,  163,  249,  164, 1152,  498, 1218,  471,
  550,  305,  889,  149,  472,  196, 1240,  472,  705,  901,
  551, 1038, 1039,  474, 1040,  686,  471,  371,  222,  279,
  528,  472,  571,  270,  494,  495,  457,  872,  496,  679,
  497, 1126,  695,  695,  883,  574, 1299,  700,  700,  229,
 1009,  229,  353,  577,  229,  488,  520,  521,  522,  311,
 1080,  173,  524,  527,  717,  493,  533,  174,  635,  580,
  722,  165, 1086, 1060,  163,  182,  164,  583, 1064,  586,
 1066, 1078, 1090,  188,  464,  548,  276, 1072,  175, 1074,
 1090,   91,  713,  156,  157,  276,  261, 1079,  158,  159,
  796,  176,  669,  156,  208,  692,  813,  814,  158,  159,
  370, 1093,  985,  163,  881,  164,  677,  261,   99,  783,
  138,  565,  662,  391,  690,  663,  665,  293,  437,  353,
  631, 1058,  812, 1170,  671,  639,  405, 1053,  690,  312,
  528,  881,  194,  400, 1054,  647,  648,  649,  650,  651,
  652,  653,  654,  655,  656,  657,  658,  659,  660,  661,
  662,  663,  664,  665, 1090, 1155, 1237, 1016,   77,   78,
   79, 1160,  690,  527,  194,  681,  788, 1018,  791,  157,
 1021, 1219,  630,  712, 1236,  555,  156,  525,  687,  703,
  183,  158,  159,  822,  556,  710,  211,  194,  513,  165,
  249,  680,  163,  642,  164,  471,  189,  189, 1121,  646,
  354,  690,  393,  394,  383,  383,  383,  679,  156,  157,
  393,  911,  383,  158,  159,  183, 1090, 1090,  160,  194,
  472,  393, 1289, 1126,  183,  918, 1070,  919,  160,  920,
  471,  147,  148,  353, 1090,  472,  176,  221,  261,  161,
 1090,  570,  261,  209,  871,  471,  162, 1171,  931,  161,
 1201,  684,  432,  881,  573,  432,  162,  690,  950,   95,
  138,  353,  576,  405,  821,  311,  391,  194,  948,  432,
  303,  304,  432, 1197,  839,  837, 1189,  838,  579,  156,
  157,  515,  942,  841,  158,  159,  582,  178,  585,  276,
  125, 1242,  949, 1243,  845, 1104,  695,  161,  695,  712,
  126,  700,  432,  700,  432,  137,  975,  909,  907, 1334,
  908,  160,  505,  302, 1034,  964, 1035,  164,  156,  157,
 1089, 1164,  630,  158,  159,  249,  162,  988,  684,  484,
  353,  372,  161, 1252,  690,  180,  320,  891,  554,  162,
  490,  252,  561,  160,  531,  312,  531,  891,  114,  891,
  138,  138,  314,  315,  316,  951,  317,  318,  319,  320,
  181,  322,  323,  259,  161,  376,  324,  922,  310,  194,
  165,  162,  709,  163,  444,  164,  199,  443,  694, 1267,
  372,  692,  512,  693,  555,  630,  383,  932,  934,  442,
 1027, 1283,  201,  556,  630, 1030,  785,  203,  376,  310,
  630,  310,  376,  463, 1023,  310,  443,  156,  157, 1300,
  939,  216,  158,  159,  160,  411,  274,  275,  310,  377,
  784, 1029,  784,   77,   78,   79,  436, 1310,  694,  633,
  217,  165,  414,  680,  163,  161,  164,  955,  220,    2,
 1317, 1318,  162, 1319,  228,    3, 1254,  963,  667, 1122,
  786,  414,  377,  160,  189,  486,  377, 1305,  486, 1264,
  239,  165,  974,  365,  163,  912,  164,  913,  432,  377,
  432,  241,  472,  165,  161,  390,  163,  469,  164,  383,
  443,  162,  431,  377,  969,  432,  447,  302,  260,  242,
 1005,  832,  498,  408,  406,  252,  407,  811,  409, 1103,
 1105,  262,  377,  125,  471,  472, 1341,  471,  443, 1332,
  161,  473, 1359,  126,  443,  338,  432,  339,  137,  340,
 1345,  471,  257,  382,  902,  497,  163,  710,  164, 1013,
  164, 1343,  271, 1033,  528, 1106,  528,  269, 1117,  162,
  281,  281,  160, 1001, 1001,  789, 1006,  165,  310,  519,
  163,  368,  164,  369,  846,  847,  848,  432,  432,  432,
  282,  695, 1140,  161,  285, 1032,  700,  527,  613,  527,
  162,  614,  615, 1327, 1328, 1271,  287,  165, 1330,  526,
  163,  618,  164, 1281,  617,  627,  628, 1106,  156,  157,
  637,  638,  620,  158,  159,  619,  156,  691,  289,  786,
 1266,  158,  159,  432,  290,  432,    4,    5,  622,  859,
  860,  621,  473,  473,  473,  473,  473,  473,  432,  473,
  291,  432,  432,  432,  432, 1360,  292, 1047, 1048, 1049,
  473, 1050,  432,  473, 1158, 1159,  861,  862, 1161,    6,
  508,  509,  833,  834,  835,  836,  156,  952, 1111,  156,
  157,  158,  159,  310,  158,  159,  165, 1315,  532,  163,
  313,  164,  341,  473,  342,  473,  165, 1100,  623,  163,
  343,  164, 1102,  383,  372,  903,  904,  905,  906,  156,
  157,  414,  375,  626,  158,  159,  625,  380, 1114,  681,
 1195,  156,  157,  381,  410,  678,  158,  159,  443, 1203,
 1204,  420, 1123,  719,  542, 1128,  718,  422,  545,  546,
  475,  475,  475,  475,  475,  475,  424,  475, 1135, 1350,
 1352,  425,  232,  160,  234,  383,  725,  735,  475,  724,
  443,  475,  182,  243, 1146,  245,  736, 1362,  708,  443,
  429,  156,  157, 1364,  161,  793,  158,  159,  792,  433,
  382,  162,  390,  163,  794,  164,  795,  792,  436,  792,
  445,  475,  157,  475,  450,  156,  157,  681, 1123,  825,
  158,  159,  824, 1173,  827,  855,  858,  826,  854,  857,
  921, 1287,  944,  644,  160,  824,  476,  476,  476,  476,
  476,  476,  449,  476,  947,  156,  525,  946,  456,  956,
  158,  159,  957,  966,  476,  161,  965,  476, 1031, 1277,
 1178,  644,  162,  458,  160,  165, 1106,  820,  163, 1036,
  164,  460,  854,  461, 1194,  462,  160, 1037, 1223,  473,
  854,  473,  475, 1042, 1230,  161,  854,  476, 1045,  476,
  476,  857,  162,  392,  479,  483, 1046,  161,  523,  854,
 1215,  163, 1062,  164,  162, 1061,  772,  773,  774,  393,
  394,  395,  396,  397,  398,  480,  399,  400,  401,  402,
  403,  404,  405,  481,  156,  157,  160,  473, 1065,  158,
  159, 1061,  482,  382,  156,  157,  163,  486,  164,  158,
  159,  487, 1069, 1114, 1013, 1068,  165,  161,  864,  163,
  160,  164,  491, 1071,  162, 1244, 1068,  501,  177, 1246,
  165,  502,  933,  163, 1073,  164,  510, 1061,  473,  473,
  473,  161,  516,  517,  267, 1339, 1340,  475,  162,  475,
  160,  194, 1075,  535,  518, 1061,  437,  437,  437,  437,
  437, 1082,  437, 1091, 1081, 1278, 1081,  536, 1284,  537,
 1285,  161, 1286,  437,  383,  177, 1357,  538,  162, 1114,
 1123, 1313, 1291, 1292,  473, 1294,  473, 1363,  156,  157,
  539,  540,  541,  158,  159,  475,  543,  544,  194,  473,
  473,  473,  473,  473,  473,  473,  560,  473,  473,  473,
  473,  473,  473,  473,  552,  165, 1304,  680,  163, 1092,
  164, 1133, 1081,  476,  718,  476,  562,  594,  382,  160,
  933,  163, 1134,  164,  601,  724,  475,  475,  475,  160,
  353,  604, 1337,  353, 1143,  353, 1322, 1142, 1167, 1169,
  161,  854, 1061,  156,  157,  563,  606,  162,  158,  159,
  161,  610,  611,  165, 1346, 1177,  163,  162,  164, 1174,
  694,  476, 1061,  692,  624,  693,  644, 1337, 1176, 1358,
 1181, 1061,  475, 1068,  475, 1361,  156,  157,  630,  636,
 1184,  158,  159, 1061,  666,  670,  675,  475,  475,  475,
  475,  475,  475,  475,  685,  475,  475,  475,  475,  475,
  475,  475,  476,  476,  476, 1187, 1191,  688, 1061, 1061,
  235,  156,  949,  160,  702,  240,  158,  159,  704,  244,
 1212,  246,  196, 1211,  156,  157,  720,  721,  723,  158,
  159,  177, 1279,  177,  161, 1280,  727,  728,  156,  157,
  195,  162, 1239,  158,  159,  946,  184,  729,  476, 1245,
  476,  733,  854,  737,  194, 1265,  194,  195, 1061, 1276,
  247,  739, 1275,  476,  476,  476,  476,  476,  476,  476,
  740,  476,  476,  476,  476,  476,  476,  476,  160,  177,
  956, 1329,  483, 1323, 1061, 1338, 1344,  195, 1348, 1061,
  741, 1347, 1353,  184,  392, 1061,  762,  392,  188,  161,
  455,  188,  194,  455,  459,  367,  162,  459,  367,  270,
  767,  160,  270,  414,  414,  414,  414,  414,  771,  414,
  177,  177,  177,  156,  157,  780,  781,  782,  158,  159,
  414,  226,  161,  414,  226,  810,  156,  949,  421,  162,
  816,  158,  159,  194,  194,  194,  160,  398,  353,  353,
  398,  815,  471,  353,  353,  471,  853,  457,  461,  160,
  457,  461,  849,  414,  852,  414,  634,  161,  856,  634,
  863,  156,  157,  160,  162,  868,  158,  159,  156,  952,
  161,  177,  641,  158,  159,  641,  870,  162,  885,  438,
  438,  438,  438,  438,  161,  438,  886,  667,  470,  471,
  667,  162,  244,  875,  194,  244,  438,  267,  366,  438,
  267,  366,  437,  437,  437,  437,  437,  437,  437,  877,
  437,  437,  437,  437,  437,  437,  437,  364,  635,  879,
  364,  635,    9,   10,   11,   12,   13,   14,   15,  438,
  887,  438,  897,  443,  443,  443,  443,  443,  668,  443,
  915,  668,  916,  195,  660,  195,  898,  660,  160,  184,
  443,  184,  365,  443,  636,  365,  673,  636,  917,  673,
  675,  160,  298,  675,  926,  927,  928,  930,  935,  161,
  393,  936,  937,  353,  938,  958,  162,  943,  299,  959,
  971,  967,  161,  443,  982,  443,  976,  989,  979,  162,
  980,  195,  986,  993,  353,  994,  160,  184,  995,  996,
  997,  353,  998,   77,   78,   79, 1000,  300,  999,  440,
  440,  440,  440,  440, 1012,  440, 1024,  161, 1019,  414,
 1026,  414, 1025, 1055,  162, 1043,  440, 1056, 1057,  440,
 1063, 1067,  195,  195,  195, 1076, 1084, 1085,  184,  184,
  184, 1087, 1094, 1095, 1097,  408,  406, 1099,  407, 1101,
  409,    9,   10,   11,   12,   13,   14,   15, 1108,  440,
 1112,  440,  445,  445,  445,  445,  445,  414,  445, 1110,
 1113, 1118, 1130,  149, 1132, 1144, 1141, 1136,  195,  445,
 1139, 1145,  445, 1148, 1149, 1147, 1153, 1154, 1163, 1165,
 1166, 1162, 1168,  195, 1175,  438, 1180,  438, 1190,  184,
 1196,  437,  437,  437,  437,  437,  330,  437,  414,  414,
  414, 1198,  445, 1188,  445, 1202,  331, 1205,  437, 1206,
 1207,  437,  332, 1208, 1209,  333, 1210, 1213,  334,  335,
  336, 1214, 1224, 1226, 1229,  337,  300, 1231,  442,  442,
  442,  442,  442,  438,  442, 1232, 1008, 1247, 1248,  443,
 1249,  443, 1253,  437,  414,  442,  414, 1255,  442, 1257,
 1259, 1262, 1260, 1270, 1268, 1263, 1272, 1273, 1282,  414,
  414,  414,  414,  414,  414,  414, 1288,  414,  414,  414,
  414,  414,  414,  414,  438,  438,  438, 1295,  130,  131,
  442, 1296, 1297, 1298, 1301, 1302, 1306,  443,  132, 1303,
 1307, 1308, 1309, 1312,  133, 1321, 1324,  134,  135, 1326,
  136,  137,  138,  139,  140,  141,  142,  143, 1331, 1349,
  646,  408,  406,  645,  407,  440,  409,  440, 1342, 1355,
  438, 1351,  438, 1354,    5,   49,  291,  484,  443,  443,
  443,  471,   80,  138,  471,  438,  438,  438,  438,  438,
  438,  438,  353,  438,  438,  438,  438,  438,  438,  438,
  684,   19,   25,  106,  111,  301,  355,  527,  439,  439,
  439,  439,  439,  440,  439,  503,  509,  324,  445,  289,
  445,   94,   53,   97,  443,  439,  443,  471,  439,  216,
  558,  405,  354,  559,  373,  379,   82,  189,  102,  443,
  443,  443,  443,  443,  443,  443,   27,  443,  443,  443,
  443,  443,  443,  443,  440,  440,  440,  437,   26,  437,
  439,  444,  444,  444,  444,  444,  445,  444,  112,  117,
  528,  489,  186,  518,  520,  842,  504,  694,  444, 1179,
  696,  444,  646,  408,  406,  929,  407, 1333,  409,   90,
   92, 1314,   93,  377,  442,  100,  442, 1311,  375,  109,
  440,  115,  440,  122,  113,  437,  108,  445,  445,  445,
  110,   38,  521,  444,  698,  440,  440,  440,  440,  440,
  440,  440, 1083,  440,  440,  440,  440,  440,  440,  440,
  700,  316,  310,   51,  374,  380,  378,  421,  421,  421,
  421,  421,  442,  421,  376, 1356,  437,  437,  437,  233,
  401,  393,  394,  445,  421,  445,  308,  421,  399,  400,
  401,  402,  403,  404,   39,  402,  118,  322,  445,  445,
  445,  445,  445,  445,  445,  170,  445,  445,  445,  445,
  445,  445,  445,  442,  442,  442,  119,  421,  590,  421,
  605,  121,  437, 1131,  437,  120,  593,  597,  603,  594,
  595,  599,  601, 1004,  940, 1127,  961,  437,  437,  437,
  437,  437,  437,  437,  738,  437,  437,  437,  437,  437,
  437,  437,  408,  406,  439,  407,  439,  409,  689,  442,
  941,  442,  970, 1120, 1293, 1119,  923,  428,  945,  983,
 1157, 1290, 1238,  701,  442,  442,  442,  442,  442,  442,
  442, 1116,  442,  442,  442,  442,  442,  442,  442,  776,
 1156,  973,  726,  677, 1225, 1227,  261,  419,  419,  419,
  419,  419,  439,  419,  711,  766,  295,  444, 1241,  444,
  770, 1325,  992, 1022,  419, 1228,  152,  419,  314,  315,
  316, 1007,  317,  318,  319,  320, 1028,  322,  323,    0,
    0, 1261,  324,    0,  420,  420,  420,  420,  420,    0,
  420, 1258,    0,  439,  439,  439,    0,  419,    0,  419,
    0,  420,    0,    0,  420,  444,    0,  393,  394,  395,
  396,  397,  398,    0,  399,  400,  401,  402,  403,  404,
  405,    0,    0,  417,    0,  417,  417,  417,    0,    0,
    0,    0,    0,  421,  420,  421,  420,    0,    0,  439,
  417,  439,    0,  417,    0,    0,  444,  444,  444,    0,
    0,    0,    0,    0,  439,  439,  439,  439,  439,  439,
  439,    0,  439,  439,  439,  439,  439,  439,  439,    0,
    0,    0,    0,  417,    0,  417,  418,    0,  418,  418,
  418,  421,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  444,  418,  444,    0,  418,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  444,  444,  444,
  444,  444,  444,  444,    0,  444,  444,  444,  444,  444,
  444,  444,  421,  421,  421,    0,  418,    0,  418,  393,
  394,  395,  396,  397,  398,    0,  399,  400,  401,  402,
  403,  404,  405,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  415,    0,  415,  415,  415,    0,
    0,    0,    0,  419,    0,  419,    0,    0,  421,    0,
  421,  415,    0,    0,  415,    0,    0,    0,    0,    0,
    0,    0,    0,  421,    0,  421,  421,  421,  421,  421,
    0,  421,  421,  421,  421,  421,  421,  421,    0,    0,
  420,    0,  420,    0,  415,  416,  415,  416,  416,  416,
    0,  419,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  416,    0,    0,  416,    0,    0,    0,    0,
    0,    0,    0,    0,  437,  437,  437,  437,  437,  417,
  437,  417,    0,    0,    0,    0,    0,    0,  420,    0,
    0,    0,  419,  419,  419,  416,    0,  416,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  393,  394,
  395,  396,  397,  398,    0,  399,  400,  401,  402,  403,
  404,  405,  433,    0,    0,  433,    0,  417,    0,  420,
  420,  420,  418,    0,  418,    0,    0,    0,  419,  433,
  419,    0,  433,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  419,    0,  419,  419,  419,  419,  419,
    0,  419,  419,  419,  419,  419,  419,  419,  417,  417,
  417,    0,  433,    0,  433,  420,    0,  420,    0,    0,
  418,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  420,    0,  420,  420,  420,  420,  420,    0,  420,  420,
  420,  420,  420,  420,  420,    0,    0,    0,    0,    0,
  415,    0,  415,    0,  417,    0,  417,    0,    0,    0,
    0,  418,  418,  418,    0,    0,    0,    0,    0,  417,
    0,  417,  417,  417,  417,  417,    0,  417,  417,  417,
  417,  417,  417,  417,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  431,    0,    0,  431,    0,  415,    0,
    0,  416,    0,  416,    0,    0,    0,  418,    0,  418,
  431,    0,    0,  431,    0,    0,    0,    0,    0,    0,
    0,    0,  418,    0,  418,  418,  418,  418,  418,    0,
  418,  418,  418,  418,  418,  418,  418,    0,    0,  415,
  415,  415,    0,  431,  422,  431,    0,  422,    0,  416,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  422,    0,    0,  422,    0,    0,    0,    0,  424,
    0,    0,  424,    0,    0,    0,    0,    0,  433,    0,
  433,    0,    0,    0,    0,  415,  424,  415,    0,  424,
  416,  416,  416,    0,  422,    0,  422,    0,    0,    0,
  415,    0,  415,  415,  415,  415,  415,    0,  415,  415,
  415,  415,  415,  415,  415,    0,    0,    0,    0,  424,
  423,  424,    0,  423,    0,    0,  433,  426,    0,    0,
  426,    0,    0,    0,    0,    0,  416,  423,  416,    0,
  423,    0,    0,    0,  426,    0,    0,  426,    0,    0,
    0,  416,    0,  416,  416,  416,  416,  416,    0,  416,
  416,  416,  416,  416,  416,  416,    0,  433,  433,  433,
  423,    0,  423,    0,    0,    0,    0,  426,    0,  426,
    0,  437,  437,  437,  437,  437,  437,    0,  437,  437,
  437,  437,  437,  437,  437,    0,    0,    0,    0,    0,
    0,    0,    0,  425,    0,    0,  425,    0,    0,  431,
    0,  431,    0,  433,    0,  433,    0,    0,    0,    0,
  425,    0,    0,  425,    0,    0,    0,    0,  433,    0,
  433,  433,  433,  433,  433,    0,  433,  433,  433,  433,
  433,  433,  433,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  425,    0,  425,    0,  431,    0,    0,
  422,  427,  422,    0,  427,    0,    0,    0,  672,  408,
  406,    0,  407,    0,  409,    0,    0,    0,  427,    0,
    0,  427,  673,  408,  406,  424,  407,  424,  409,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  431,  431,
  431,    0,    0,    0,    0,    0,    0,    0,  422,    0,
    0,  427,    0,  427,    0,    0,    0,  430,    0,    0,
  430,    0,    0,    0,  674,  408,  406,    0,  407,    0,
  409,    0,    0,  424,  430,    0,  423,  430,  423,    0,
    0,    0,    0,  426,  431,  426,  431,    0,    0,  422,
  422,  422,  706,  408,  406,    0,  407,    0,  409,  431,
    0,    0,  431,  431,  431,  431,    0,  430,    0,  430,
    0,    0,    0,  431,  424,  424,  424,  707,  408,  406,
    0,  407,    0,  409,  423,    0,    0,    0,    0,    0,
    0,  426,  777,  408,  406,  422,  407,  422,  409,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  422,    0,    0,  422,  422,  422,  422,    0,    0,  425,
  424,  425,  424,    0,  422,  423,  423,  423,    0,    0,
    0,    0,  426,  426,  426,  424,    0,    0,  424,  424,
  424,  424,  778,  408,  406,    0,  407,    0,  409,  424,
    0,    0,    0,    0,    0,    0,  779,  408,  406,    0,
  407,    0,  409,    0,    0,    0,    0,  425,    0,    0,
    0,  423,    0,  423,    0,    0,    0,  427,  426,  427,
  426,  817,  408,  406,    0,  407,  423,  409,    0,  423,
  423,  423,  423,  426,    0,    0,  426,  426,  426,  426,
  423,    0,    0,    0,    0,    0,    0,  426,  425,  425,
  425,  818,  408,  406,    0,  407,    0,  409,    0,    0,
    0,    0,    0,    0,    0,  427,  819,  408,  406,    0,
  407,    0,  409,  430,    0,  430,    0,    0,    0,    0,
 1044,  408,  406,    0,  407,    0,  409,    0,    0,    0,
    0,    0,    0,    0,  425,    0,  425, 1107,  408,  406,
    0,  407,    0,  409,    0,    0,  427,  427,  427,  425,
    0,    0,  425,  425,  425,  425, 1109,  408,  406,    0,
  407,  430,  409,  425,    0,    0,    0,    0,    0,    0,
 1129,  408,  406,    0,  407,    0,  409,    0,    0,    0,
    0,    0,    0,    0, 1256,  408,  406,    0,  407,    0,
  409,    0,  427,    0,  427,    0,    0,    0,    0,    0,
    0,    0,  430,  430,  430,    0,    0,  427,    0,    0,
  427,  427,  427,  427,    0,  393,  394,  395,  396,  397,
  398,  427,  399,  400,  401,  402,  403,  404,  405,  393,
  394,  395,  396,  397,  398,    0,  399,  400,  401,  402,
  403,  404,  405, 1316,  408,  406,    0,  407,  430,  409,
  430,    0,    0,    0,    0,    0,    0,    0, 1320,  408,
  406,    0,  407,  430,  409,    0,    0,  430,  430,  430,
    0,  393,  394,  395,  396,  397,  398,  430,  399,  400,
  401,  402,  403,  404,  405,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  393,
  394,  395,  396,  397,  398,    0,  399,  400,  401,  402,
  403,  404,  405,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  393,  394,  395,  396,  397,  398,
    0,  399,  400,  401,  402,  403,  404,  405,    0,  393,
  394,  395,  396,  397,  398,    0,  399,  400,  401,  402,
  403,  404,  405,    0,  314,  315,  316,    0,  317,  318,
  319,  320,  321,  322,  323,    0,    0,  429,  324,    0,
  429,  325,    0,    0,    0,  408,  406,  962,  407,    0,
  409,  326,    0,    0,  429,    0,    0,  429,    0,  393,
  394,  395,  396,  397,  398,    0,  399,  400,  401,  402,
  403,  404,  405,  393,  394,  395,  396,  397,  398,    0,
  399,  400,  401,  402,  403,  404,  405,  429,    0,  429,
  408,  406,  645,  407,    0,  409,    0,    0,  393,  394,
  395,  396,  397,  398,    0,  399,  400,  401,  402,  403,
  404,  405,    0,    0,    0,  757,  755,    0,  756,  765,
  758,    0,    0,    0,    0,    0,    0,    0,  393,  394,
  395,  396,  397,  398,  764,  399,  400,  401,  402,  403,
  404,  405,    0,  393,  394,  395,  396,  397,  398,    0,
  399,  400,  401,  402,  403,  404,  405,  393,  394,  395,
  396,  397,  398,    0,  399,  400,  401,  402,  403,  404,
  405,    0,    0,    0,  393,  394,  395,  396,  397,  398,
    0,  399,  400,  401,  402,  403,  404,  405,    0,    0,
    0,    0,    0,  393,  394,  395,  396,  397,  398,    0,
  399,  400,  401,  402,  403,  404,  405,  393,  394,  395,
  396,  397,  398,    0,  399,  400,  401,  402,  403,  404,
  405,  393,  394,  395,  396,  397,  398,    0,  399,  400,
  401,  402,  403,  404,  405,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  429,    0,  429,    0,    0,    0,  428,
    0,    0,  428,    0,    0,    0,    0,  408,  406, 1222,
  407,    0,  409,    0,    0,    0,  428,    0,    0,  428,
  393,  394,  395,  396,  397,  398,    0,  399,  400,  401,
  402,  403,  404,  405,    0,  393,  394,  395,  396,  397,
  398,  429,  399,  400,  401,  402,  403,  404,  405,  428,
  435,  428,    0,  435,  434,    0,    0,  434,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  435,    0,    0,
  435,  434,  408,  406,  434,  407,    0,  409,    0,    0,
    0,    0,  429,  429,  429,    0,    0,    0, 1150,  408,
  406,    0,  407,    0,  409,    0,    0,    0,    0,    0,
  435,    0,  435,    0,  434, 1216,  434,    0,    0,    0,
    0,  410,  410,    0,  410,    0,  410,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  408,  406,  429,  407,
  429,  409,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  757,  755,  429,  756,  759,  758,    0,  429,  429,
    0,  393,  394,  395,  396,  397,  398,  429,  399,  400,
  401,  402,  403,  404,  405,  408,  406,    0,  407,    0,
  409,    0,    0,    0,    0,    0,    0,    0,  408,  406,
    0,  407,    0,  409,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  393,  394,  395,  396,
  397,  398,    0,  399,  400,  401,  402,  403,  404,  405,
    0,  408,  406,    0,  407,  428,  409,  428,    0,    0,
    0,  742,  743,  744,  745,  746,  747,  748,  749,  750,
  751,  752,  753,  754,  763,    0,    0,    0,    0,  344,
  345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
  355,  356,  357,  358,  359,    0,    0,    0,    0,  360,
  361,    0,    0,  428,    0,    0,  435,    0,  435,    0,
  434,    0,  434,  362,  363,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   18,   19,    0,    0,   22,    0,    0,   24,   25,    0,
   27,    0,    0,    0,  428,  428,  428,    0,    0,    0,
    0,    0,   36,   37,  435,    0,    0,    0,  434,    0,
   44,    0,    0,    0,    0,    0,    0,   49,   50,    0,
   52,   53,   54,    0,   56,    0,    0,    0,    0,    0,
   58,   59,   60,   61,   62,   63,   64,    0,    0,    0,
  428,    0,  428,    0,    0,  435,  435,  435,    0,  434,
  434,  434,    0,    0,    0,  428,    0,    0,   85,   86,
  428,  428,    0,  393,  394,  395,  396,  397,  398,  428,
  399,  400,  401,  402,  403,  404,  405,    0,    0,  100,
  101,  102,    0,  103,  104,  105,  106,  107,  108,  109,
  110,  435,    0,  435,    0,  434,    0,  434,    0,    0,
    0,    0,    0,    0,    0,    0,  435,    0,    0,    0,
  434,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  435,    0,    0,    0,  434,    0,  111,    0,  393,  394,
  395,  396,  397,  398,    0,  399,  400,  401,  402,  403,
  404,  405,    0,    0,    0,  393,  394,  395,  396,  397,
  398,  410,  399,  400,  401,  402,  403,  404,  405,    0,
    0,    0,    0,    0,    0,    0,    0,  410,  410,  410,
  410,  410,  410,    0,  410,  410,  410,  410,  410,  410,
  410,    0,  393,  394,  395,  396,  397,  398,    0,  399,
  400,  401,  402,  403,  404,  405,    0,  742,  743,  744,
  745,  746,  747,  748,  749,  750,  751,  752,  753,  754,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  393,  394,  395,  396,  397,  398,    0,  399,  400,
  401,  402,  403,  404,  393,  394,  395,  396,    0,    0,
    0,  399,  400,  401,  402,  403,  404,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  393,  394,  395,
    0,    0,    0,    0,  399,  400,  401,  402,  403,  404,
    8,    0,    0,    0,    9,   10,   11,   12,   13,   14,
   15,    0,    0,   16,   17,   18,   19,   20,   21,   22,
    0,   23,   24,   25,   26,   27,   28,   29,    0,   30,
   31,   32,    0,   33,    0,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,    0,    0,
   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
   57,    0,    0,    0,    0,   58,   59,   60,   61,   62,
   63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,    0,   77,   78,   79,   80,   81,
   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
   92,    0,    0,   93,   94,    0,   95,   96,   97,   98,
    0,    0,   99,  797,  100,  101,  102,    0,  103,  104,
  105,  106,  107,  108,  109,  110,    0,  798,  799,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  800,    0,    0,    0,    0,    0,    0,    0,
  801,    0,    0,    0,    0,    0,    0,    0,  802,    0,
    0,  111,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  803,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  768,    0,    0,    0,    0,    0,    0,    0,
    0,  804,  805,    0,    0,  769,  806,  807,
};
static const short yycheck[] = {                         49,
   22,   18,   74,   67,   54,  160,   56,  197,   30,  360,
  609,  190,  432,   44,  574,   41,  186,  432,   26,   36,
   37,   47,   44,  583,   18,  177,  586,  600,  911,   55,
   44,  127,  786,   50,   28,   52,   53,   40,   33,   65,
  220,   58,  221,   38,   61,   62,   63,   64,  783,   75,
  290,  291,  292,  535,  536,   81,  538,   83,   47,  239,
   40,  543,   88,   89,   44,   44,   47,  461,  462,  463,
  310,   66,  168,   68,   58,  469,   42,   43,   47,   45,
   61,   47,  558,   44,   42,   43,   58,   45,  168,   47,
   85,   86,  118,   47,  722,   42,   44,  431,   93,   94,
   47,   96,   47,   98,   41,   40,  257,   44,   43,   41,
   45,   47,   44,   44,  266,   40,   47,   42,   43,  271,
   45,   58,   44,  504,  257,   40,   58,   42,  257,  422,
  147,  148,   42,  150,   44,  152,   58,   47,   47,   47,
  257,   61,  294,  160,  161,  162,  163,  164,  165,   47,
   41,   61,   40,   44,   42,  257,  173,  174,  175,   44,
   44,  121,   47,   44,  181,  259,   41,   37,   37,   44,
   40,  580,  692,  693,  257,   37,   61,  259,  260,   44,
  420,   91,  258,  259,  201,  883,  203,   44,   40,   44,
   40,  945,  344,  378,  188,   41,   42,   44,   40,   41,
   42,   43,   40,   45,   42,  959,  343,  279,   44,   44,
   44,  257,   93,  257,   44,   42,  345,   44,   93,  356,
   47,   91,   91,  217,  241,  242,  258,  412,   93,   91,
   40,  435,   42,   43,   61,   45,   93,  287,   93,   41,
  444,   40,  593,   42,   41,  259,   93,   44,  438,  600,
  454,  427,  428,  247,  430,  425,   58,   93,   40,   93,
  310,   58,   40,   93,  281,  282,  226,   42,  285,  257,
  287, 1025,  692,  693,   40,   40,   42,  692,  693,   42,
  374,   44,   40,   40,   47,  270,  303,  304,  305,   41,
  889,   40,  309,  310,  446,  280,  313,   40,  378,   40,
  452,   40,  901,  863,   43,  259,   45,   40,  868,   40,
  870,  884, 1195,   40,  259,  328,   44,  877,   40,  879,
 1203,  257,   42,  258,  259,  407,  257,  887,  263,  264,
  510,  258,  412,  258,  259,  486,  516,  517,  263,  264,
   40,  914,  736,   43,  259,   45,  257,  257,  257,  501,
  259,  259,  485,  370,  688,  488,  489,  305,  372,   40,
  377,  259,  514, 1061,  414,  382,  257,  849,  485,   41,
  420,  259,  257,  257,  850,  392,  393,  394,  395,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410, 1277, 1023, 1150, 1151,  346,  347,
  348, 1029,  485,  420,  407,  422,  502,  788,  504,  259,
  791,  392,  257,  259, 1149,  446,  258,  259,  426,  436,
  409,  263,  264,  407,  455,  442,  443,  407,  407,   40,
  257,   42,   43,  394,   45,  407,  430,  431,  958,  485,
  409,  485,  408,  409,  461,  462,  463,   58,  258,  259,
  408,  603,  469,  263,  264,  409, 1339, 1340,  393,  407,
  257,  408, 1216, 1217,  409,  617,  875,  619,  393,  621,
  407,  309,  310,  409, 1357,  407,  258,  259,  409,  414,
 1363,  259,  392,  408,  259,  407,  421,  407,  643,  414,
 1089,  479,   41,  259,  259,   44,  421,  485,  688,  257,
  409,  259,  259,  394,  526,  257,  523,  392,  687,   58,
  309,  310,   61, 1086,   42,   43, 1076,   45,  259,  258,
  259,  297,  674,  540,  263,  264,  259,  259,  259,  257,
   44, 1159,  259, 1161,  547,  929,  956,   44,  958,  259,
   44,  956,   91,  958,   93,   44,  725,   42,   43,  484,
   45,  393,  792,  121,  824,  707,  826,   44,  258,  259,
  911, 1043,  407,  263,  264,  392,   44,  737,  479,  265,
   47,   44,  414, 1172,  485,  259,  257,  594,  333,  421,
  276,  259,  337,  393,  824,  257,  826,  604,  257,  606,
  259,  260,  427,  428,  429,  691,  431,  432,  433,  434,
   40,  436,  437,  281,  414,   37,  441,  624,   40,  407,
   40,  421,   42,   43,   41,   45,  259,   44,   40, 1192,
   93,   43,  305,   45,  446,  470,  643,  644,  645,   61,
  810, 1204,   40,  455,  479,  815,   37,   40,   37,   40,
  485,   40,   37,   41,  796,   40,   44,  258,  259, 1248,
  672,  259,  263,  264,  393,   37,  259,  260,   40,   91,
   61,  813,   61,  346,  347,  348,   61, 1266,   40,   37,
   40,   40,   40,   42,   43,  414,   45,  694,  259,  256,
 1279, 1280,  421, 1282,   47,  262, 1175,  704,   37,   58,
   91,   40,   91,  393,  688,   41,   91, 1257,   44, 1188,
  259,   40,  724,   42,   43,  604,   45,  606,  257,   91,
  259,   40,   58,   40,  414,   42,   43,   41,   45,  736,
   44,  421,   44,   91,  718,   47,  720,  295,  406,   40,
  780,  259,  782,   42,   43,  259,   45,  513,   47,  929,
  930,  259,   91,  257,   41,   41, 1319,   44,   44, 1309,
  257,   41, 1351,  257,   44,  132,  305,  134,  257,  136,
 1333,   58,   40,   40,  259,  782,   43,  784,   45,  786,
  257, 1331,   40,  823,  824,  930,  826,  259,  948,  257,
  257,   40,  393,  777,  778,   37,  781,   40,   40,   42,
   43,  148,   45,  150,  549,  550,  551,  346,  347,  348,
   40, 1221,  981,  414,   40,  822, 1221,  824,  490,  826,
  421,  493,  494, 1302, 1303, 1195,   40,   40, 1307,   42,
   43,   41,   45, 1203,   44,  258,  259,  982,  258,  259,
  380,  381,   41,  263,  264,   44,  258,  259,  259,   91,
 1191,  263,  264,  392,   40,  394,  423,  424,   41,  464,
  465,   44,   40,   41,   42,   43,   44,   45,  407,   47,
   40,  410,  411,  412,  413, 1354,   40,  438,  439,  440,
   58,  442,  421,   61, 1026, 1027,  491,  492, 1030,  456,
  291,  292,  410,  411,  412,  413,  258,  259,  938,  258,
  259,  263,  264,   40,  263,  264,   40, 1277,   42,   43,
   40,   45,   40,   91,   40,   93,   40,  924,   42,   43,
   40,   45,  929,  930,  259,  410,  411,  412,  413,  258,
  259,   40,   95,   41,  263,  264,   44,   95,  945,  946,
 1082,  258,  259,   95,   61,   41,  263,  264,   44, 1091,
 1092,   40,  959,   41,  321,  962,   44,   40,  325,  326,
   40,   41,   42,   43,   44,   45,  259,   47,  975, 1339,
 1340,   44,   50,  393,   52,  982,   41,   41,   58,   44,
   44,   61,  259,   61, 1000,   63,   41, 1357,  408,   44,
   44,  258,  259, 1363,  414,   41,  263,  264,   44,  259,
   40,  421,   42,   43,   41,   45,   41,   44,   61,   44,
   40,   91,  259,   93,  259,  258,  259, 1024, 1025,   41,
  263,  264,   44, 1063,   41,   41,   41,   44,   44,   44,
   41, 1211,   41,   44,  393,   44,   40,   41,   42,   43,
   44,   45,   44,   47,   41,  258,  259,   44,   44,   44,
  263,  264,   47,   41,   58,  414,   44,   61,   41, 1201,
 1067,   44,  421,  259,  393,   40, 1211,   42,   43,   41,
   45,  259,   44,   44, 1081,   44,  393,   41, 1132,  257,
   44,  259,   44,   41, 1146,  414,   44,   91,   41,   93,
  259,   44,  421,  392,   61,   44,   41,  414,   40,   44,
 1112,   43,   41,   45,  421,   44,  395,  396,  397,  408,
  409,  410,  411,  412,  413,   40,  415,  416,  417,  418,
  419,  420,  421,   40,  258,  259,  393,  305,   41,  263,
  264,   44,   40,   40,  258,  259,   43,  259,   45,  263,
  264,  259,   41, 1150, 1151,   44,   40,  414,   42,   43,
  393,   45,   44,   41,  421, 1162,   44,   44,   44, 1166,
   40,  259,   42,   43,   41,   45,  259,   44,  346,  347,
  348,  414,  259,  259,   40, 1317, 1318,  257,  421,  259,
  393,   44,   41,   40,  305,   44,   41,   42,   43,   44,
   45,   41,   47,   41,   44, 1202,   44,   40, 1205,   40,
 1207,  414, 1209,   58, 1211,   91, 1348,   40,  421, 1216,
 1217, 1273, 1219, 1220,  392, 1222,  394, 1359,  258,  259,
   40,   40,   40,  263,  264,  305,   40,   40,   91,  407,
  408,  409,  410,  411,  412,  413,   40,  415,  416,  417,
  418,  419,  420,  421,  446,   40, 1253,   42,   43,   41,
   45,   41,   44,  257,   44,  259,  259,   40,   40,  393,
   42,   43,   41,   45,   40,   44,  346,  347,  348,  393,
   40,   40, 1312,   43,   41,   45, 1288,   44,   41,   41,
  414,   44,   44,  258,  259,  259,   40,  421,  263,  264,
  414,  259,  490,   40, 1334,   42,   43,  421,   45,   41,
   40,  305,   44,   43,   61,   45,   44, 1347,   41, 1349,
   41,   44,  392,   44,  394, 1355,  258,  259,  259,   37,
   41,  263,  264,   44,  259,   37,  324,  407,  408,  409,
  410,  411,  412,  413,   47,  415,  416,  417,  418,  419,
  420,  421,  346,  347,  348,   41,   41,   44,   44,   44,
   53,  258,  259,  393,   44,   58,  263,  264,   40,   62,
   41,   64,  259,   44,  258,  259,   40,   44,   40,  263,
  264,  257,  479,  259,  414,  482,   91,   44,  258,  259,
   44,  421,   41,  263,  264,   44,   44,   47,  392,   41,
  394,   44,   44,   44,  257,   41,  259,   61,   44,   41,
   40,   40,   44,  407,  408,  409,  410,  411,  412,  413,
   44,  415,  416,  417,  418,  419,  420,  421,  393,  305,
   44,   41,   44,   47,   44,   47,   41,   91,   41,   44,
   41,   44,   41,   91,   41,   44,   61,   44,   41,  414,
   41,   44,  305,   44,   41,   41,  421,   44,   44,   41,
  259,  393,   44,   41,   42,   43,   44,   45,   41,   47,
  346,  347,  348,  258,  259,   58,   41,   44,  263,  264,
   58,   44,  414,   61,   47,  259,  258,  259,  181,  421,
   41,  263,  264,  346,  347,  348,  393,   41,  258,  259,
   44,  259,   41,  263,  264,   44,   41,   41,   41,  393,
   44,   44,   40,   91,  259,   93,   41,  414,  259,   44,
   40,  258,  259,  393,  421,   40,  263,  264,  258,  259,
  414,  407,   41,  263,  264,   44,   40,  421,  479,   41,
   42,   43,   44,   45,  414,   47,  486,   41,  241,  242,
   44,  421,   41,   40,  407,   44,   58,   41,   41,   61,
   44,   44,  407,  408,  409,  410,  411,  412,  413,   40,
  415,  416,  417,  418,  419,  420,  421,   41,   41,   40,
   44,   44,  265,  266,  267,  268,  269,  270,  271,   91,
   40,   93,  488,   41,   42,   43,   44,   45,   41,   47,
  392,   44,  490,  257,   41,  259,  489,   44,  393,  257,
   58,  259,   41,   61,   41,   44,   41,   44,  490,   44,
   41,  393,  305,   44,  259,   37,  259,   44,  259,  414,
  408,   37,  259,  393,   58,   42,  421,  259,  321,   91,
  259,  345,  414,   91,   44,   93,  259,   58,  259,  421,
  259,  305,  259,  259,  414,   41,  393,  305,   41,   41,
   41,  421,   41,  346,  347,  348,   41,  350,  407,   41,
   42,   43,   44,   45,  259,   47,   40,  414,  259,  257,
   40,  259,   91,   41,  421,   58,   58,  259,   47,   61,
   58,   40,  346,  347,  348,   40,   40,  485,  346,  347,
  348,   58,  259,  399,  398,   42,   43,  399,   45,  259,
   47,  265,  266,  267,  268,  269,  270,  271,   41,   91,
   44,   93,   41,   42,   43,   44,   45,  305,   47,  259,
  322,   41,  322,   42,   40,   46,   41,   45,  392,   58,
   44,  259,   61,   58,   44,  392,  259,  259,   41,   41,
   44,   58,  259,  407,  407,  257,  259,  259,   41,  407,
  259,   41,   42,   43,   44,   45,  425,   47,  346,  347,
  348,  259,   91,  407,   93,   40,  435,   61,   58,   41,
   61,   61,  441,   41,   61,  444,   41,   41,  447,  448,
  449,   41,  259,  259,  392,  454,  350,  259,   41,   42,
   43,   44,   45,  305,   47,  259,  259,   47,   61,  257,
  259,  259,   58,   93,  392,   58,  394,   41,   61,   40,
  259,  259,  480,  483,  470,  481,   41,   47,  479,  407,
  408,  409,  410,  411,  412,  413,   44,  415,  416,  417,
  418,  419,  420,  421,  346,  347,  348,   41,  425,  426,
   93,  259,   44,   41,   44,  407,  259,  305,  435,  407,
  407,  259,   40,   40,  441,   41,   40,  444,  445,  259,
  447,  448,  449,  450,  451,  452,  453,  454,   40,   58,
   41,   42,   43,   44,   45,  257,   47,  259,   41,   58,
  392,  479,  394,  407,  257,  257,  257,   41,  346,  347,
  348,   58,  257,  259,  257,  407,  408,  409,  410,  411,
  412,  413,  259,  415,  416,  417,  418,  419,  420,  421,
  479,  257,  257,  257,  257,  257,  257,  257,   41,   42,
   43,   44,   45,  305,   47,  257,  257,  257,  257,  257,
  259,  257,   41,  257,  392,   58,  394,   41,   61,   41,
   41,   44,   47,   41,  257,  257,  257,   41,  257,  407,
  408,  409,  410,  411,  412,  413,  257,  415,  416,  417,
  418,  419,  420,  421,  346,  347,  348,  257,  257,  259,
   93,   41,   42,   43,   44,   45,  305,   47,  257,  257,
  257,  257,   41,  257,  257,  541,  257,  257,   58, 1068,
  257,   61,   41,   42,   43,   44,   45, 1310,   47,  257,
  257, 1275,  257,  257,  257,  257,  259, 1268,  257,  257,
  392,  257,  394,  257,  257,  305,  257,  346,  347,  348,
  257,  257,  257,   93,  257,  407,  408,  409,  410,  411,
  412,  413,  893,  415,  416,  417,  418,  419,  420,  421,
  257,  257,  257,  257,  257,  257,  257,   41,   42,   43,
   44,   45,  305,   47,  257, 1347,  346,  347,  348,   51,
  257,  408,  409,  392,   58,  394,  257,   61,  415,  416,
  417,  418,  419,  420,  257,  257,  257,  257,  407,  408,
  409,  410,  411,  412,  413,   18,  415,  416,  417,  418,
  419,  420,  421,  346,  347,  348,  257,   91,  257,   93,
  257,  257,  392,  965,  394,  257,  257,  257,  257,  257,
  257,  257,  257,  778,  673,  960,  702,  407,  408,  409,
  410,  411,  412,  413,  475,  415,  416,  417,  418,  419,
  420,  421,   42,   43,  257,   45,  259,   47,  430,  392,
  673,  394,  720,  958, 1221,  956,  625,  188,   58,  733,
 1025, 1217, 1151,  433,  407,  408,  409,  410,  411,  412,
  413,  946,  415,  416,  417,  418,  419,  420,  421,  491,
 1024,  723,  456,  420, 1137, 1140,   72,   41,   42,   43,
   44,   45,  305,   47,  443,  482,  118,  257, 1158,  259,
  485, 1297,  740,  792,   58, 1142,   15,   61,  427,  428,
  429,  782,  431,  432,  433,  434,  812,  436,  437,   -1,
   -1, 1184,  441,   -1,   41,   42,   43,   44,   45,   -1,
   47, 1181,   -1,  346,  347,  348,   -1,   91,   -1,   93,
   -1,   58,   -1,   -1,   61,  305,   -1,  408,  409,  410,
  411,  412,  413,   -1,  415,  416,  417,  418,  419,  420,
  421,   -1,   -1,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   -1,  257,   91,  259,   93,   -1,   -1,  392,
   58,  394,   -1,   61,   -1,   -1,  346,  347,  348,   -1,
   -1,   -1,   -1,   -1,  407,  408,  409,  410,  411,  412,
  413,   -1,  415,  416,  417,  418,  419,  420,  421,   -1,
   -1,   -1,   -1,   91,   -1,   93,   41,   -1,   43,   44,
   45,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  392,   58,  394,   -1,   61,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  407,  408,  409,
  410,  411,  412,  413,   -1,  415,  416,  417,  418,  419,
  420,  421,  346,  347,  348,   -1,   91,   -1,   93,  408,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   -1,   43,   44,   45,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  392,   -1,
  394,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  407,   -1,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,   -1,   -1,
  257,   -1,  259,   -1,   91,   41,   93,   43,   44,   45,
   -1,  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,  257,
   47,  259,   -1,   -1,   -1,   -1,   -1,   -1,  305,   -1,
   -1,   -1,  346,  347,  348,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  408,  409,
  410,  411,  412,  413,   -1,  415,  416,  417,  418,  419,
  420,  421,   41,   -1,   -1,   44,   -1,  305,   -1,  346,
  347,  348,  257,   -1,  259,   -1,   -1,   -1,  392,   58,
  394,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  407,   -1,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,  346,  347,
  348,   -1,   91,   -1,   93,  392,   -1,  394,   -1,   -1,
  305,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  407,   -1,  409,  410,  411,  412,  413,   -1,  415,  416,
  417,  418,  419,  420,  421,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,  392,   -1,  394,   -1,   -1,   -1,
   -1,  346,  347,  348,   -1,   -1,   -1,   -1,   -1,  407,
   -1,  409,  410,  411,  412,  413,   -1,  415,  416,  417,
  418,  419,  420,  421,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,  305,   -1,
   -1,  257,   -1,  259,   -1,   -1,   -1,  392,   -1,  394,
   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  407,   -1,  409,  410,  411,  412,  413,   -1,
  415,  416,  417,  418,  419,  420,  421,   -1,   -1,  346,
  347,  348,   -1,   91,   41,   93,   -1,   44,   -1,  305,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,   -1,   -1,  392,   58,  394,   -1,   61,
  346,  347,  348,   -1,   91,   -1,   93,   -1,   -1,   -1,
  407,   -1,  409,  410,  411,  412,  413,   -1,  415,  416,
  417,  418,  419,  420,  421,   -1,   -1,   -1,   -1,   91,
   41,   93,   -1,   44,   -1,   -1,  305,   41,   -1,   -1,
   44,   -1,   -1,   -1,   -1,   -1,  392,   58,  394,   -1,
   61,   -1,   -1,   -1,   58,   -1,   -1,   61,   -1,   -1,
   -1,  407,   -1,  409,  410,  411,  412,  413,   -1,  415,
  416,  417,  418,  419,  420,  421,   -1,  346,  347,  348,
   91,   -1,   93,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,  408,  409,  410,  411,  412,  413,   -1,  415,  416,
  417,  418,  419,  420,  421,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,  257,
   -1,  259,   -1,  392,   -1,  394,   -1,   -1,   -1,   -1,
   58,   -1,   -1,   61,   -1,   -1,   -1,   -1,  407,   -1,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,  305,   -1,   -1,
  257,   41,  259,   -1,   44,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   58,   -1,
   -1,   61,   41,   42,   43,  257,   45,  259,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  346,  347,
  348,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  305,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   41,   -1,   -1,
   44,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,  305,   58,   -1,  257,   61,  259,   -1,
   -1,   -1,   -1,  257,  392,  259,  394,   -1,   -1,  346,
  347,  348,   41,   42,   43,   -1,   45,   -1,   47,  407,
   -1,   -1,  410,  411,  412,  413,   -1,   91,   -1,   93,
   -1,   -1,   -1,  421,  346,  347,  348,   41,   42,   43,
   -1,   45,   -1,   47,  305,   -1,   -1,   -1,   -1,   -1,
   -1,  305,   41,   42,   43,  392,   45,  394,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  407,   -1,   -1,  410,  411,  412,  413,   -1,   -1,  257,
  392,  259,  394,   -1,  421,  346,  347,  348,   -1,   -1,
   -1,   -1,  346,  347,  348,  407,   -1,   -1,  410,  411,
  412,  413,   41,   42,   43,   -1,   45,   -1,   47,  421,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,  305,   -1,   -1,
   -1,  392,   -1,  394,   -1,   -1,   -1,  257,  392,  259,
  394,   41,   42,   43,   -1,   45,  407,   47,   -1,  410,
  411,  412,  413,  407,   -1,   -1,  410,  411,  412,  413,
  421,   -1,   -1,   -1,   -1,   -1,   -1,  421,  346,  347,
  348,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  305,   41,   42,   43,   -1,
   45,   -1,   47,  257,   -1,  259,   -1,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  392,   -1,  394,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  346,  347,  348,  407,
   -1,   -1,  410,  411,  412,  413,   41,   42,   43,   -1,
   45,  305,   47,  421,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  392,   -1,  394,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  346,  347,  348,   -1,   -1,  407,   -1,   -1,
  410,  411,  412,  413,   -1,  408,  409,  410,  411,  412,
  413,  421,  415,  416,  417,  418,  419,  420,  421,  408,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,   41,   42,   43,   -1,   45,  392,   47,
  394,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,  407,   47,   -1,   -1,  411,  412,  413,
   -1,  408,  409,  410,  411,  412,  413,  421,  415,  416,
  417,  418,  419,  420,  421,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  408,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  408,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,   -1,  408,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,   -1,  427,  428,  429,   -1,  431,  432,
  433,  434,  435,  436,  437,   -1,   -1,   41,  441,   -1,
   44,  444,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,  454,   -1,   -1,   58,   -1,   -1,   61,   -1,  408,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,  408,  409,  410,  411,  412,  413,   -1,
  415,  416,  417,  418,  419,  420,  421,   91,   -1,   93,
   42,   43,   44,   45,   -1,   47,   -1,   -1,  408,  409,
  410,  411,  412,  413,   -1,  415,  416,  417,  418,  419,
  420,  421,   -1,   -1,   -1,   42,   43,   -1,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  408,  409,
  410,  411,  412,  413,   61,  415,  416,  417,  418,  419,
  420,  421,   -1,  408,  409,  410,  411,  412,  413,   -1,
  415,  416,  417,  418,  419,  420,  421,  408,  409,  410,
  411,  412,  413,   -1,  415,  416,  417,  418,  419,  420,
  421,   -1,   -1,   -1,  408,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,   -1,   -1,
   -1,   -1,   -1,  408,  409,  410,  411,  412,  413,   -1,
  415,  416,  417,  418,  419,  420,  421,  408,  409,  410,
  411,  412,  413,   -1,  415,  416,  417,  418,  419,  420,
  421,  408,  409,  410,  411,  412,  413,   -1,  415,  416,
  417,  418,  419,  420,  421,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   58,   -1,   -1,   61,
  408,  409,  410,  411,  412,  413,   -1,  415,  416,  417,
  418,  419,  420,  421,   -1,  408,  409,  410,  411,  412,
  413,  305,  415,  416,  417,  418,  419,  420,  421,   91,
   41,   93,   -1,   44,   41,   -1,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,
   61,   58,   42,   43,   61,   45,   -1,   47,   -1,   -1,
   -1,   -1,  346,  347,  348,   -1,   -1,   -1,   58,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   91,   58,   93,   -1,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,  392,   45,
  394,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   42,   43,  407,   45,   46,   47,   -1,  412,  413,
   -1,  408,  409,  410,  411,  412,  413,  421,  415,  416,
  417,  418,  419,  420,  421,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  408,  409,  410,  411,
  412,  413,   -1,  415,  416,  417,  418,  419,  420,  421,
   -1,   42,   43,   -1,   45,  257,   47,  259,   -1,   -1,
   -1,  408,  409,  410,  411,  412,  413,  414,  415,  416,
  417,  418,  419,  420,  421,   -1,   -1,   -1,   -1,  457,
  458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
  468,  469,  470,  471,  472,   -1,   -1,   -1,   -1,  477,
  478,   -1,   -1,  305,   -1,   -1,  257,   -1,  259,   -1,
  257,   -1,  259,  491,  492,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,   -1,  280,   -1,   -1,  283,  284,   -1,
  286,   -1,   -1,   -1,  346,  347,  348,   -1,   -1,   -1,
   -1,   -1,  298,  299,  305,   -1,   -1,   -1,  305,   -1,
  306,   -1,   -1,   -1,   -1,   -1,   -1,  313,  314,   -1,
  316,  317,  318,   -1,  320,   -1,   -1,   -1,   -1,   -1,
  326,  327,  328,  329,  330,  331,  332,   -1,   -1,   -1,
  392,   -1,  394,   -1,   -1,  346,  347,  348,   -1,  346,
  347,  348,   -1,   -1,   -1,  407,   -1,   -1,  354,  355,
  412,  413,   -1,  408,  409,  410,  411,  412,  413,  421,
  415,  416,  417,  418,  419,  420,  421,   -1,   -1,  375,
  376,  377,   -1,  379,  380,  381,  382,  383,  384,  385,
  386,  392,   -1,  394,   -1,  392,   -1,  394,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  407,   -1,   -1,   -1,
  407,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  421,   -1,   -1,   -1,  421,   -1,  422,   -1,  408,  409,
  410,  411,  412,  413,   -1,  415,  416,  417,  418,  419,
  420,  421,   -1,   -1,   -1,  408,  409,  410,  411,  412,
  413,  392,  415,  416,  417,  418,  419,  420,  421,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  408,  409,  410,
  411,  412,  413,   -1,  415,  416,  417,  418,  419,  420,
  421,   -1,  408,  409,  410,  411,  412,  413,   -1,  415,
  416,  417,  418,  419,  420,  421,   -1,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  408,  409,  410,  411,  412,  413,   -1,  415,  416,
  417,  418,  419,  420,  408,  409,  410,  411,   -1,   -1,
   -1,  415,  416,  417,  418,  419,  420,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  408,  409,  410,
   -1,   -1,   -1,   -1,  415,  416,  417,  418,  419,  420,
  261,   -1,   -1,   -1,  265,  266,  267,  268,  269,  270,
  271,   -1,   -1,  274,  275,  276,  277,  278,  279,  280,
   -1,  282,  283,  284,  285,  286,  287,  288,   -1,  290,
  291,  292,   -1,  294,   -1,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,   -1,   -1,
  311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,   -1,   -1,   -1,   -1,  326,  327,  328,  329,  330,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,   -1,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,   -1,   -1,  364,  365,   -1,  367,  368,  369,  370,
   -1,   -1,  373,  274,  375,  376,  377,   -1,  379,  380,
  381,  382,  383,  384,  385,  386,   -1,  288,  289,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  303,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
   -1,  422,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  333,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  352,  353,   -1,   -1,  356,  357,  358,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 494
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,
0,0,"':'",0,0,"'='",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'['",0,"']'",0,"'_'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"EOS","CONSTANT","IDENTIFIER","GENERIC_SPEC","UNKNOWN",
"STATEMENT_LABEL_NO","TRUE_CONSTANT","FALSE_CONSTANT","KW_INTEGER","KW_REAL",
"KW_COMPLEX","KW_DOUBLE","KW_DCOMPLEX","KW_LOGICAL","KW_CHARACTER",
"KW_UNDEFINED","KW_NONE","PARAMETER","INCLUDE","LET","ARITHIF","LOGIF","IFTHEN",
"ASSIGN","ASSIGNMENT","BLOCKDATA","CALL","CLOSE","COMMON","CONTINUE","DATA",
"DIMENSION","CODIMENSION","DO","ENDDO","DOWHILE","WHILE","ELSE","ELSEIF",
"ELSEIFTHEN","END","ENDFILE","ENDFILE_P","ENDIF","ENTRY","EQUIV","EXTERNAL",
"FORMAT","FUNCTION","GOTO","IMPLICIT","IMPLICIT_NONE","SET_LEN","SET_KIND",
"INTRINSIC","NAMELIST","PAUSE","PRINT","PROGRAM","READ","READ_P","RETURN",
"SAVE","STOP","SUBROUTINE","THEN","P_THEN","KW_TO","WRITE","WRITE_P","OPEN",
"INQUIRE","BACKSPACE","BACKSPACE_P","REWIND","REWIND_P","POINTER","ENDPROGRAM",
"MODULE","ENDMODULE","INTERFACE","INTERFACEASSIGNMENT","INTERFACEOPERATOR",
"ENDINTERFACE","PROCEDURE","MODULEPROCEDURE","PRIVATE","SEQUENCE","RESULT",
"RECURSIVE","PURE","ELEMENTAL","CONTAINS","KW_TYPE","ENDTYPE","ALLOCATABLE",
"INTENT","EXIT","CYCLE","PUBLIC","OPTIONAL","TARGET","WHERE","ELSEWHERE",
"ENDWHERE","FORALL","ENDFORALL","ENDFUNCTION","ENDSUBROUTINE","ENDBLOCKDATA",
"SELECT","CASEDEFAULT","CASE","ENDSELECT","KW_DEFAULT","KW_WHILE","KW_USE",
"KW_ONLY","ALLOCATE","DEALLOCATE","NULLIFY","KW_STAT","SYNCALL","SYNCIMAGES",
"SYNCMEMORY","LOCK","UNLOCK","CRITICAL","ENDCRITICAL","ERRORSTOP","KW_SYNC",
"KW_ALL","KW_IMAGES","KW_MEMORY","KW_ERROR","REF_OP","L_ARRAY_CONSTRUCTOR",
"R_ARRAY_CONSTRUCTOR","KW_IN","KW_OUT","KW_INOUT","KW_LEN","KW_KIND","KW_DBL",
"KW_SELECT","KW_BLOCK","KW_ENDBLOCK","KW_GO","KW_PRECISION","OPERATOR","COL2",
"POWER","CONCAT","AND","OR","NEQV","EQV","NOT","EQ","LT","GT","LE","GE","NE",
"USER_DEFINED_OP","PRAGMA_SLINE","PRAGMA_HEAD","OMPKW_LINE","OMPKW_PARALLEL",
"OMPKW_END","OMPKW_PRIVATE","OMPKW_SHARED","OMPKW_DEFAULT","OMPKW_NONE",
"OMPKW_FIRSTPRIVATE","OMPKW_REDUCTION","OMPKW_IF","OMPKW_COPYIN","OMPKW_DO",
"OMPKW_LASTPRIVATE","OMPKW_SCHEDULE","OMPKW_STATIC","OMPKW_DYNAMIC",
"OMPKW_GUIDED","OMPKW_ORDERED","OMPKW_RUNTIME","OMPKW_AFFINITY",
"OMPKW_SECTIONS","OMPKW_SECTION","OMPKW_NOWAIT","OMPKW_SINGLE","OMPKW_MASTER",
"OMPKW_CRITICAL","OMPKW_BARRIER","OMPKW_ATOMIC","OMPKW_FLUSH",
"OMPKW_THREADPRIVATE","OMPKW_WORKSHARE","OMPKW_COPYPRIVATE","XMPKW_LINE",
"XMPKW_END","XMPKW_NODES","XMPKW_TEMPLATE","XMPKW_TEMPLATE_FIX",
"XMPKW_DISTRIBUTE","XMPKW_ALIGN","XMPKW_SHADOW","XMPKW_TASK","XMPKW_TASKS",
"XMPKW_LOOP","XMPKW_REFLECT","XMPKW_GMOVE","XMPKW_BARRIER","XMPKW_REDUCTION",
"XMPKW_BCAST","XMPKW_WAIT_ASYNC","XMPKW_COARRAY","XMPKW_WAIT","XMPKW_POST",
"XMPKW_CRITICAL","XMPKW_ARRAY","XMPKW_LOCAL_ALIAS","XMPKW_ON","XMPKW_ONTO",
"XMPKW_WITH","XMPKW_FROM","XMPKW_WIDTH","XMPKW_PERIODIC","XMPKW_ASYNC",
"XMPKW_NOWAIT","XMPKW_MASTER","XMPKW_IN","XMPKW_OUT","XMPKW_BEGIN",
"XMPKW_MASTER_IO","XMPKW_GLOBAL_IO","XMPKW_ATOMIC","XMPKW_DIRECT",
};
static const char *yyrule[] = {
"$accept : program",
"program :",
"program : program one_statement EOS",
"KW :",
"NEED_CHECK :",
"one_statement : STATEMENT_LABEL_NO",
"one_statement : STATEMENT_LABEL_NO statement",
"one_statement : OMPKW_LINE omp_directive",
"$$1 :",
"one_statement : XMPKW_LINE $$1 xmp_directive",
"one_statement : PRAGMA_HEAD PRAGMA_SLINE",
"one_statement : error",
"statement : PROGRAM program_name",
"statement : ENDPROGRAM name_or_null",
"statement : MODULE name",
"statement : ENDMODULE name_or_null",
"statement : INTERFACEOPERATOR NEED_CHECK '(' defined_operator ')'",
"statement : INTERFACEASSIGNMENT '(' '=' ')'",
"statement : INTERFACE generic_name",
"statement : INTERFACE",
"statement : ENDINTERFACE generic_name",
"statement : ENDINTERFACE OPERATOR '(' '=' ')'",
"statement : ENDINTERFACE ASSIGNMENT '(' '=' ')'",
"statement : ENDINTERFACE OPERATOR '(' intrinsic_operator ')'",
"statement : ENDINTERFACE OPERATOR '(' USER_DEFINED_OP ')'",
"statement : ENDINTERFACE",
"statement : MODULEPROCEDURE ident_list",
"statement : PROCEDURE ident_list",
"statement : BLOCKDATA program_name",
"statement : SUBROUTINE IDENTIFIER dummy_arg_list",
"statement : func_prefix SUBROUTINE IDENTIFIER dummy_arg_list",
"statement : ENDSUBROUTINE name_or_null",
"statement : FUNCTION IDENTIFIER dummy_arg_list KW result_opt",
"statement : func_prefix FUNCTION IDENTIFIER dummy_arg_list KW result_opt",
"statement : type_spec FUNCTION IDENTIFIER dummy_arg_list KW result_opt",
"statement : type_spec func_prefix FUNCTION IDENTIFIER dummy_arg_list KW result_opt",
"statement : func_prefix type_spec FUNCTION IDENTIFIER dummy_arg_list KW result_opt",
"statement : ENDFUNCTION name_or_null",
"statement : type_spec COL2_or_null declaration_list",
"statement : type_spec attr_spec_list COL2 declaration_list",
"statement : ENTRY IDENTIFIER dummy_arg_list KW result_opt",
"statement : CONTAINS",
"statement : declaration_statement",
"statement : executable_statement",
"statement : declaration_statement95",
"statement : INCLUDE file_name",
"statement : END",
"statement : UNKNOWN",
"label : CONSTANT",
"program_name :",
"program_name : IDENTIFIER",
"result_opt :",
"result_opt : RESULT '(' name ')'",
"intrinsic_operator : '.'",
"intrinsic_operator : POWER",
"intrinsic_operator : '*'",
"intrinsic_operator : '/'",
"intrinsic_operator : '+'",
"intrinsic_operator : '-'",
"intrinsic_operator : EQ",
"intrinsic_operator : NE",
"intrinsic_operator : LT",
"intrinsic_operator : LE",
"intrinsic_operator : GE",
"intrinsic_operator : GT",
"intrinsic_operator : NOT",
"intrinsic_operator : AND",
"intrinsic_operator : OR",
"intrinsic_operator : EQV",
"intrinsic_operator : NEQV",
"intrinsic_operator : CONCAT",
"defined_operator : intrinsic_operator",
"defined_operator : '.' IDENTIFIER '.'",
"generic_name : name",
"func_prefix : prefix_spec",
"func_prefix : func_prefix prefix_spec",
"prefix_spec : RECURSIVE",
"prefix_spec : PURE",
"prefix_spec : ELEMENTAL",
"name : IDENTIFIER",
"name_or_null :",
"name_or_null : IDENTIFIER",
"dummy_arg_list :",
"dummy_arg_list : '(' ')'",
"dummy_arg_list : '(' dummy_args ')'",
"dummy_args : dummy_arg",
"dummy_args : dummy_args ',' dummy_arg",
"dummy_arg : IDENTIFIER",
"dummy_arg : '*'",
"file_name : CONSTANT",
"declaration_statement : DIMENSION COL2_or_null declaration_list",
"declaration_statement : COMMON common_decl",
"declaration_statement : EXTERNAL COL2_or_null external_decl",
"declaration_statement : INTRINSIC COL2_or_null intrinsic_decl",
"declaration_statement : EQUIV equivalence_decl",
"declaration_statement : DATA data",
"declaration_statement : IMPLICIT_NONE",
"declaration_statement : IMPLICIT implicit_decl",
"declaration_statement : NAMELIST namelist_decl",
"declaration_statement : SAVE",
"declaration_statement : SAVE COL2_or_null save_list",
"declaration_statement : PARAMETER '(' const_list ')'",
"declaration_statement : POINTER cray_pointer_list",
"declaration_statement : FORMAT",
"declaration_statement95 : KW_TYPE COL2_or_null IDENTIFIER",
"declaration_statement95 : KW_TYPE ',' KW access_spec COL2 IDENTIFIER",
"declaration_statement95 : ENDTYPE",
"declaration_statement95 : ENDTYPE IDENTIFIER",
"declaration_statement95 : OPTIONAL COL2_or_null ident_list",
"declaration_statement95 : POINTER COL2_or_null array_allocation_list",
"declaration_statement95 : TARGET COL2_or_null array_allocation_list",
"declaration_statement95 : PUBLIC",
"declaration_statement95 : PUBLIC access_ident_list",
"declaration_statement95 : PUBLIC COL2 access_ident_list",
"declaration_statement95 : PRIVATE",
"declaration_statement95 : PRIVATE COL2_or_null access_ident_list",
"declaration_statement95 : SEQUENCE",
"declaration_statement95 : KW_USE IDENTIFIER",
"declaration_statement95 : KW_USE IDENTIFIER ',' KW use_rename_list",
"declaration_statement95 : KW_USE IDENTIFIER ',' KW KW_ONLY ':'",
"declaration_statement95 : KW_USE IDENTIFIER ',' KW KW_ONLY ':' use_only_list",
"declaration_statement95 : INTENT '(' KW intent_spec ')' COL2_or_null ident_list",
"declaration_statement95 : ALLOCATABLE COL2_or_null array_allocation_list",
"array_allocation_list : array_allocation",
"array_allocation_list : array_allocation_list ',' array_allocation",
"array_allocation : IDENTIFIER",
"array_allocation : IDENTIFIER '(' defered_shape_list ')'",
"array_allocation : IDENTIFIER '(' defered_shape_list ')' REF_OP IDENTIFIER '(' ')'",
"defered_shape_list : defered_shape",
"defered_shape_list : defered_shape_list ',' defered_shape",
"defered_shape : ':'",
"use_rename_list : use_rename",
"use_rename_list : use_rename_list ',' use_rename",
"use_rename : IDENTIFIER REF_OP IDENTIFIER",
"use_only_list : use_only",
"use_only_list : use_only_list ',' use_only",
"use_only : use_rename",
"use_only : IDENTIFIER",
"COL2_or_null :",
"COL2_or_null : COL2",
"attr_spec_list : ',' KW attr_spec",
"attr_spec_list : attr_spec_list ',' KW attr_spec",
"attr_spec : PARAMETER",
"attr_spec : access_spec",
"attr_spec : ALLOCATABLE",
"attr_spec : DIMENSION '(' dim_list ')'",
"attr_spec : CODIMENSION '[' image_dim_list ']'",
"attr_spec : EXTERNAL",
"attr_spec : INTENT '(' KW intent_spec ')'",
"attr_spec : INTRINSIC",
"attr_spec : OPTIONAL",
"attr_spec : POINTER",
"attr_spec : SAVE",
"attr_spec : TARGET",
"access_spec : PUBLIC",
"access_spec : PRIVATE",
"intent_spec : KW_IN",
"intent_spec : KW_OUT",
"intent_spec : KW_INOUT",
"declaration_list : entity_decl",
"declaration_list : declaration_list ',' entity_decl",
"entity_decl : IDENTIFIER dims image_dims length_spec",
"entity_decl : IDENTIFIER dims image_dims length_spec '=' expr",
"entity_decl : IDENTIFIER dims image_dims length_spec '/' data_val_list '/'",
"entity_decl : IDENTIFIER dims image_dims length_spec REF_OP expr",
"type_spec : type_spec0",
"type_spec0 : KW_TYPE '(' IDENTIFIER ')'",
"type_spec0 : type_keyword kind_selector",
"type_spec0 : type_keyword length_spec",
"type_spec0 : KW_CHARACTER char_selector",
"type_spec0 : KW_DOUBLE",
"type_spec0 : KW_DCOMPLEX",
"type_keyword : KW_INTEGER",
"type_keyword : KW_REAL",
"type_keyword : KW_COMPLEX",
"type_keyword : KW_LOGICAL",
"kind_selector : kind_or_len_selector",
"char_selector :",
"char_selector : '(' len_spec ')'",
"char_selector : SET_LEN len_spec ')'",
"char_selector : SET_LEN len_spec ',' KW kind_key_spec ')'",
"char_selector : '(' len_spec ',' KW KW_KIND '=' expr ')'",
"char_selector : SET_KIND len_spec ')'",
"char_selector : SET_KIND len_spec ',' KW len_key_spec ')'",
"char_selector : length_spec_mark expr",
"char_selector : length_spec_mark '(' '*' ')'",
"len_key_spec : KW_LEN '=' expr",
"len_spec : '*'",
"len_spec : expr",
"kind_key_spec : KW_KIND '=' expr",
"kind_or_len_selector : SET_KIND expr ')'",
"kind_or_len_selector : SET_LEN '*' ')'",
"kind_or_len_selector : SET_LEN expr ')'",
"kind_or_len_selector : '(' expr ')'",
"length_spec :",
"length_spec : length_spec_mark expr",
"length_spec : length_spec_mark '(' '*' ')'",
"length_spec_mark : '*'",
"common_decl : common_var",
"common_decl : common_block common_var",
"common_decl : common_decl comma_or_null common_block comma_or_null common_var",
"common_decl : common_decl ',' common_var",
"common_block : CONCAT",
"common_block : '/' IDENTIFIER '/'",
"common_var : IDENTIFIER dims",
"external_decl : IDENTIFIER",
"external_decl : external_decl ',' IDENTIFIER",
"intrinsic_decl : IDENTIFIER",
"intrinsic_decl : intrinsic_decl ',' IDENTIFIER",
"equivalence_decl : '(' equiv_list ')'",
"equivalence_decl : equivalence_decl ',' '(' equiv_list ')'",
"equiv_list : lhs",
"equiv_list : equiv_list ',' lhs",
"cray_pointer_list : cray_pointer_pair",
"cray_pointer_list : cray_pointer_list ',' cray_pointer_pair",
"cray_pointer_pair : '(' lhs ',' cray_pointer_var ')'",
"cray_pointer_var : IDENTIFIER",
"cray_pointer_var : common_var",
"data : data_list",
"data : data comma_or_null data_list",
"data_list : data_var_list '/' data_val_list '/'",
"data_val_list : data_val",
"data_val_list : data_val_list ',' data_val",
"data_val : value",
"data_val : IDENTIFIER parenthesis_arg_list",
"data_val : simple_value '*' value",
"value : simple_value",
"value : '+' simple_value",
"value : '-' simple_value",
"simple_value : IDENTIFIER",
"simple_value : const",
"simple_value : complex_const",
"save_list : save_item",
"save_list : save_list ',' save_item",
"save_item : IDENTIFIER",
"save_item : common_block",
"access_ident_list : access_ident",
"access_ident_list : access_ident_list ',' access_ident",
"access_ident : GENERIC_SPEC",
"access_ident : IDENTIFIER",
"ident_list : IDENTIFIER",
"ident_list : ident_list ',' IDENTIFIER",
"const_list : const_item",
"const_list : const_list ',' const_item",
"const_item : IDENTIFIER '=' expr",
"data_var_list : data_var",
"data_var_list : data_var_list ',' data_var",
"data_var : lhs",
"data_var : '(' data_var_list ',' do_spec ')'",
"image_dims :",
"image_dims : '[' image_dim_list ']'",
"image_dim_list : image_dim",
"image_dim_list : image_dim_list ',' image_dim",
"image_dim : ubound",
"image_dim : expr ':' ubound",
"image_dim : ':'",
"image_dims_alloc : '[' image_dim_list_alloc ']'",
"image_dim_list_alloc : image_dim_alloc",
"image_dim_list_alloc : image_dim_list_alloc ',' image_dim_alloc",
"image_dim_alloc : ubound",
"image_dim_alloc : expr ':' ubound",
"dims :",
"dims : '(' dim_list ')'",
"dim_list : dim",
"dim_list : dim_list ',' dim",
"dim : ubound",
"dim : expr ':' ubound",
"dim : expr ':'",
"dim : ':'",
"ubound : '*'",
"ubound : expr",
"label_list : label",
"label_list : label_list ',' label",
"implicit_decl : imp_list",
"implicit_decl : implicit_decl ',' imp_list",
"imp_list : KW type_spec '[' letter_groups ']'",
"imp_list : KW type_spec",
"letter_groups : letter_group",
"letter_groups : letter_groups ',' letter_group",
"letter_group : IDENTIFIER",
"letter_group : IDENTIFIER '-' IDENTIFIER",
"namelist_decl : '/' IDENTIFIER '/' namelist_list",
"namelist_decl : '/' IDENTIFIER '/' namelist_list comma_or_null namelist_decl",
"namelist_list : IDENTIFIER",
"namelist_list : namelist_list ',' IDENTIFIER",
"executable_statement : action_statement",
"executable_statement : DO label KW_WHILE '(' expr ')'",
"executable_statement : DO label do_spec",
"executable_statement : DO label ',' do_spec",
"executable_statement : DO label",
"executable_statement : DO do_spec",
"executable_statement : DO",
"executable_statement : ENDDO name_or_null",
"executable_statement : LOGIF '(' expr ')' action_statement_key",
"executable_statement : LOGIF '(' expr ')' action_statement_let",
"executable_statement : IFTHEN '(' expr ')' KW THEN",
"executable_statement : ELSEIFTHEN '(' expr ')' KW THEN",
"executable_statement : ELSE name_or_null",
"executable_statement : ENDIF name_or_null",
"executable_statement : DOWHILE '(' expr ')'",
"executable_statement : WHERE '(' expr ')' assign_statement_or_null",
"executable_statement : ELSEWHERE",
"executable_statement : ELSEWHERE '(' expr ')' assign_statement_or_null",
"executable_statement : ENDWHERE",
"executable_statement : SELECT '(' expr ')'",
"executable_statement : CASE '(' scene_list ')' name_or_null",
"executable_statement : CASEDEFAULT name_or_null",
"executable_statement : ENDSELECT name_or_null",
"assign_statement_or_null :",
"assign_statement_or_null : assign_statement",
"assign_statement : lhs '=' expr",
"do_spec : IDENTIFIER '=' expr ',' expr",
"do_spec : IDENTIFIER '=' expr ',' expr ',' expr",
"action_statement : action_statement_let",
"action_statement : action_statement_key",
"action_statement_let : LET assign_statement",
"action_statement_let : LET expr REF_OP expr",
"action_statement_key : ASSIGN label KW KW_TO IDENTIFIER",
"action_statement_key : CONTINUE",
"action_statement_key : GOTO label",
"action_statement_key : GOTO IDENTIFIER",
"action_statement_key : GOTO IDENTIFIER comma_or_null '(' label_list ')'",
"action_statement_key : GOTO '(' label_list ')' comma_or_null expr",
"action_statement_key : ARITHIF '(' expr ')' label ',' label ',' label",
"action_statement_key : CALL IDENTIFIER",
"action_statement_key : CALL IDENTIFIER '(' ')'",
"action_statement_key : CALL IDENTIFIER '(' arg_list ')'",
"action_statement_key : RETURN expr_or_null",
"action_statement_key : PAUSE expr_or_null",
"action_statement_key : STOP expr_or_null",
"action_statement_key : action_statement95",
"action_statement_key : action_coarray_statement",
"action_statement_key : io_statement",
"action_statement_key : PRAGMA_SLINE",
"action_statement95 : CYCLE name_or_null",
"action_statement95 : EXIT name_or_null",
"action_statement95 : ALLOCATE '(' allocation_list ')'",
"action_statement95 : NULLIFY '(' allocation_list ')'",
"action_statement95 : DEALLOCATE '(' allocation_list ')'",
"allocation_list : allocation",
"allocation_list : allocation_list ',' allocation",
"allocation : lhs_alloc",
"allocation : set_expr",
"action_coarray_statement : coarray_keyword parenthesis_arg_list_or_null",
"action_coarray_statement : coarray_syncimages_keyword '(' syncimages_arg_list ')'",
"coarray_keyword : SYNCALL",
"coarray_keyword : SYNCMEMORY",
"coarray_keyword : LOCK",
"coarray_keyword : UNLOCK",
"coarray_keyword : CRITICAL",
"coarray_keyword : ENDCRITICAL",
"coarray_keyword : ERRORSTOP",
"coarray_syncimages_keyword : SYNCIMAGES",
"comma_or_null :",
"comma_or_null : ','",
"parenthesis_arg_list_or_null :",
"parenthesis_arg_list_or_null : parenthesis_arg_list",
"parenthesis_arg_list : '(' arg_list ')'",
"arg_list :",
"arg_list : arg",
"arg_list : arg_list ',' arg",
"arg : expr",
"arg : set_expr",
"arg : '*' label",
"arg : expr_or_null ':' expr_or_null",
"arg : expr_or_null ':' expr_or_null ':' expr",
"arg : expr_or_null COL2 expr",
"syncimages_arg_list : expr",
"syncimages_arg_list : '*'",
"syncimages_arg_list : syncimages_arg_list ',' arg",
"image_selector : '[' cosubscript_list ']'",
"cosubscript_list : expr",
"cosubscript_list : cosubscript_list ',' expr",
"io_statement : PRINT format_spec",
"io_statement : PRINT format_spec ',' io_list",
"io_statement : WRITE_P ctl_list ')'",
"io_statement : WRITE_P ctl_list ')' io_list",
"io_statement : READ_P ctl_list ')'",
"io_statement : READ_P ctl_list ')' io_list",
"io_statement : READ format_spec",
"io_statement : READ format_spec ',' io_list",
"io_statement : OPEN '(' ctl_list ')'",
"io_statement : CLOSE '(' ctl_list ')'",
"io_statement : BACKSPACE_P ctl_list ')'",
"io_statement : BACKSPACE format_spec",
"io_statement : ENDFILE_P ctl_list ')'",
"io_statement : ENDFILE format_spec",
"io_statement : REWIND_P ctl_list ')'",
"io_statement : REWIND format_spec",
"io_statement : INQUIRE '(' ctl_list ')' io_list_or_null",
"ctl_list : io_clause",
"ctl_list : ctl_list ',' io_clause",
"io_clause : expr",
"io_clause : '*'",
"io_clause : POWER",
"io_clause : IDENTIFIER '=' '*'",
"io_clause : IDENTIFIER '=' POWER",
"io_clause : set_expr",
"set_expr : IDENTIFIER '=' expr",
"format_spec : '*'",
"format_spec : expr",
"io_list_or_null :",
"io_list_or_null : io_list",
"io_list : io_item",
"io_list : io_list ',' io_item",
"io_item : expr",
"io_item : '(' expr ',' io_list ')'",
"io_item : '(' expr ',' do_spec ')'",
"io_item : '(' expr ',' io_list ',' do_spec ')'",
"io_item : '(' io_list ',' do_spec ')'",
"expr : lhs",
"expr : L_ARRAY_CONSTRUCTOR array_constructor_list R_ARRAY_CONSTRUCTOR",
"expr : '(' expr ')'",
"expr : complex_const",
"expr : const",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : '+' expr",
"expr : '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr POWER expr",
"expr : expr EQ expr",
"expr : expr GT expr",
"expr : expr LT expr",
"expr : expr GE expr",
"expr : expr LE expr",
"expr : expr NE expr",
"expr : expr EQV expr",
"expr : expr NEQV expr",
"expr : expr OR expr",
"expr : expr AND expr",
"expr : NOT expr",
"expr : expr CONCAT expr",
"expr : expr USER_DEFINED_OP expr",
"expr : USER_DEFINED_OP expr",
"expr : string_const_substr",
"lhs : IDENTIFIER",
"lhs : IDENTIFIER image_selector",
"lhs : IDENTIFIER parenthesis_arg_list",
"lhs : IDENTIFIER parenthesis_arg_list image_selector",
"lhs : IDENTIFIER parenthesis_arg_list substring",
"lhs : member_ref",
"lhs : member_ref image_selector",
"lhs : member_ref parenthesis_arg_list",
"lhs : member_ref parenthesis_arg_list image_selector",
"lhs : member_ref parenthesis_arg_list substring",
"member_ref : IDENTIFIER '%' IDENTIFIER",
"member_ref : IDENTIFIER image_selector '%' IDENTIFIER",
"member_ref : IDENTIFIER parenthesis_arg_list '%' IDENTIFIER",
"member_ref : IDENTIFIER parenthesis_arg_list image_selector '%' IDENTIFIER",
"member_ref : member_ref '%' IDENTIFIER",
"member_ref : member_ref image_selector '%' IDENTIFIER",
"member_ref : member_ref parenthesis_arg_list '%' IDENTIFIER",
"member_ref : member_ref parenthesis_arg_list image_selector '%' IDENTIFIER",
"lhs_alloc : IDENTIFIER",
"lhs_alloc : IDENTIFIER image_dims_alloc",
"lhs_alloc : IDENTIFIER parenthesis_arg_list",
"lhs_alloc : IDENTIFIER parenthesis_arg_list image_dims_alloc",
"lhs_alloc : member_ref_alloc",
"lhs_alloc : member_ref_alloc image_dims_alloc",
"lhs_alloc : member_ref_alloc parenthesis_arg_list",
"lhs_alloc : member_ref_alloc parenthesis_arg_list image_dims_alloc",
"member_ref_alloc : IDENTIFIER '%' IDENTIFIER",
"member_ref_alloc : IDENTIFIER parenthesis_arg_list '%' IDENTIFIER",
"member_ref_alloc : member_ref_alloc '%' IDENTIFIER",
"member_ref_alloc : member_ref_alloc parenthesis_arg_list '%' IDENTIFIER",
"array_constructor_list : io_item",
"array_constructor_list : array_constructor_list ',' io_item",
"string_const_substr : const substring",
"substring : '(' expr_or_null ':' expr_or_null ')'",
"expr_or_null :",
"expr_or_null : expr",
"const : CONSTANT",
"const : CONSTANT '_' kind_parm",
"const : TRUE_CONSTANT",
"const : FALSE_CONSTANT",
"const : TRUE_CONSTANT '_' kind_parm",
"const : FALSE_CONSTANT '_' kind_parm",
"kind_parm : CONSTANT",
"kind_parm : IDENTIFIER",
"complex_const : '(' expr ',' expr ')'",
"complex_const : '(' '*' ',' expr ')'",
"complex_const : '(' expr ',' '*' ')'",
"scene_list : scene_range",
"scene_list : scene_range ',' scene_list",
"scene_range : expr",
"scene_range : expr_or_null ':' expr_or_null",
"omp_directive : OMPKW_PARALLEL omp_clause_option",
"omp_directive : OMPKW_END OMPKW_PARALLEL",
"omp_directive : OMPKW_DO omp_clause_option",
"omp_directive : OMPKW_END OMPKW_DO omp_nowait_option",
"omp_directive : OMPKW_PARALLEL OMPKW_DO omp_clause_option",
"omp_directive : OMPKW_END OMPKW_PARALLEL OMPKW_DO omp_nowait_option",
"omp_directive : OMPKW_SECTIONS omp_clause_option",
"omp_directive : OMPKW_END OMPKW_SECTIONS omp_nowait_option",
"omp_directive : OMPKW_PARALLEL OMPKW_SECTIONS omp_clause_option",
"omp_directive : OMPKW_END OMPKW_PARALLEL OMPKW_SECTIONS omp_nowait_option",
"omp_directive : OMPKW_SECTION",
"omp_directive : OMPKW_SINGLE omp_clause_option",
"omp_directive : OMPKW_END OMPKW_SINGLE omp_end_clause_option",
"omp_directive : OMPKW_MASTER",
"omp_directive : OMPKW_END OMPKW_MASTER",
"omp_directive : OMPKW_CRITICAL",
"omp_directive : OMPKW_END OMPKW_CRITICAL",
"omp_directive : OMPKW_CRITICAL '(' IDENTIFIER ')'",
"omp_directive : OMPKW_END OMPKW_CRITICAL '(' IDENTIFIER ')'",
"omp_directive : OMPKW_BARRIER",
"omp_directive : OMPKW_ATOMIC",
"omp_directive : OMPKW_FLUSH",
"omp_directive : OMPKW_FLUSH '(' omp_list ')'",
"omp_directive : OMPKW_ORDERED",
"omp_directive : OMPKW_END OMPKW_ORDERED",
"omp_directive : OMPKW_THREADPRIVATE '(' omp_copyin_list ')'",
"omp_directive : OMPKW_WORKSHARE",
"omp_directive : OMPKW_END OMPKW_WORKSHARE omp_nowait_option",
"omp_directive : OMPKW_PARALLEL OMPKW_WORKSHARE omp_clause_option",
"omp_directive : OMPKW_END OMPKW_PARALLEL OMPKW_WORKSHARE omp_nowait_option",
"omp_nowait_option :",
"omp_nowait_option : OMPKW_NOWAIT",
"omp_end_clause_option :",
"omp_end_clause_option : omp_end_clause_list",
"omp_end_clause_list : omp_end_clause",
"omp_end_clause_list : omp_end_clause_list ',' omp_end_clause",
"omp_end_clause_list : omp_end_clause_list omp_end_clause",
"omp_end_clause : OMPKW_NOWAIT",
"omp_end_clause : OMPKW_COPYPRIVATE '(' omp_list ')'",
"omp_clause_option :",
"omp_clause_option : omp_clause_list",
"omp_clause_list : omp_clause",
"omp_clause_list : omp_clause_list ',' omp_clause",
"omp_clause_list : omp_clause_list omp_clause",
"omp_clause : OMPKW_PRIVATE '(' omp_list ')'",
"omp_clause : OMPKW_SHARED '(' omp_list ')'",
"$$2 :",
"omp_clause : OMPKW_DEFAULT '(' $$2 omp_default_attr ')'",
"omp_clause : OMPKW_FIRSTPRIVATE '(' omp_list ')'",
"omp_clause : OMPKW_LASTPRIVATE '(' omp_list ')'",
"omp_clause : OMPKW_COPYIN '(' omp_copyin_list ')'",
"omp_clause : OMPKW_REDUCTION '(' omp_reduction_op ':' omp_list ')'",
"omp_clause : OMPKW_IF '(' expr ')'",
"$$3 :",
"omp_clause : OMPKW_SCHEDULE '(' $$3 omp_schedule_arg ')'",
"omp_clause : OMPKW_ORDERED",
"omp_reduction_op : '+'",
"omp_reduction_op : '-'",
"omp_reduction_op : '*'",
"omp_reduction_op : AND",
"omp_reduction_op : OR",
"omp_reduction_op : EQV",
"omp_reduction_op : NEQV",
"omp_reduction_op : IDENTIFIER",
"omp_list : IDENTIFIER",
"omp_list : omp_list ',' IDENTIFIER",
"omp_copyin_list : IDENTIFIER",
"omp_copyin_list : omp_copyin_list ',' IDENTIFIER",
"omp_copyin_list : '/' IDENTIFIER '/'",
"omp_copyin_list : omp_copyin_list ',' '/' IDENTIFIER '/'",
"omp_schedule_arg : omp_schedule_attr",
"omp_schedule_arg : omp_schedule_attr ',' expr",
"omp_schedule_attr : OMPKW_STATIC",
"omp_schedule_attr : OMPKW_DYNAMIC",
"omp_schedule_attr : OMPKW_GUIDED",
"omp_schedule_attr : OMPKW_RUNTIME",
"omp_default_attr : OMPKW_SHARED",
"omp_default_attr : OMPKW_PRIVATE",
"omp_default_attr : OMPKW_NONE",
"xmp_directive : XMPKW_NODES xmp_nodes_clause",
"xmp_directive : XMPKW_TEMPLATE xmp_template_clause",
"xmp_directive : XMPKW_DISTRIBUTE xmp_distribute_clause",
"xmp_directive : XMPKW_ALIGN xmp_align_clause",
"xmp_directive : XMPKW_SHADOW xmp_shadow_clause",
"xmp_directive : XMPKW_TEMPLATE_FIX xmp_template_fix_clause",
"xmp_directive : XMPKW_TASK xmp_task_clause",
"xmp_directive : XMPKW_END xmp_end_clause",
"xmp_directive : XMPKW_TASKS",
"xmp_directive : XMPKW_TASKS xmp_NOWAIT",
"$$4 :",
"xmp_directive : XMPKW_LOOP $$4 xmp_loop_clause",
"xmp_directive : XMPKW_REFLECT xmp_reflect_clause",
"xmp_directive : XMPKW_GMOVE xmp_gmove_clause",
"$$5 :",
"xmp_directive : XMPKW_BARRIER $$5 xmp_barrier_clause",
"xmp_directive : XMPKW_REDUCTION xmp_reduction_clause",
"xmp_directive : XMPKW_BCAST xmp_bcast_clause",
"xmp_directive : XMPKW_ARRAY xmp_array_clause",
"xmp_directive : XMPKW_LOCAL_ALIAS IDENTIFIER REF_OP IDENTIFIER",
"xmp_directive : XMPKW_WAIT_ASYNC xmp_wait_async_clause",
"xmp_directive : XMPKW_MASTER_IO xmp_master_io_options",
"xmp_directive : XMPKW_GLOBAL_IO xmp_global_io_options",
"xmp_nodes_clause : IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_nodes_clause : IDENTIFIER '(' xmp_subscript_list ')' '=' '*'",
"xmp_nodes_clause : IDENTIFIER '(' xmp_subscript_list ')' '=' xmp_obj_ref",
"xmp_nodes_clause : '(' xmp_subscript_list ')' COL2 xmp_name_list",
"xmp_nodes_clause : '(' xmp_subscript_list ')' '=' '*' COL2 xmp_name_list",
"xmp_nodes_clause : '(' xmp_subscript_list ')' '=' xmp_obj_ref COL2 xmp_name_list",
"xmp_template_clause : IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_template_clause : '(' xmp_subscript_list ')' COL2 xmp_name_list",
"xmp_distribute_clause : IDENTIFIER '(' xmp_dist_fmt_list ')' xmp_ONTO IDENTIFIER",
"xmp_distribute_clause : '(' xmp_dist_fmt_list ')' xmp_ONTO IDENTIFIER COL2 xmp_name_list",
"xmp_align_clause : IDENTIFIER '(' xmp_subscript_list ')' xmp_WITH IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_align_clause : '(' xmp_subscript_list ')' xmp_WITH IDENTIFIER '(' xmp_subscript_list ')' COL2 xmp_name_list",
"xmp_shadow_clause : IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_shadow_clause : '(' xmp_subscript_list ')' COL2 xmp_name_list",
"xmp_template_fix_clause : IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_template_fix_clause : '(' xmp_dist_fmt_list ')' IDENTIFIER",
"xmp_template_fix_clause : '(' xmp_dist_fmt_list ')' IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_task_clause : xmp_ON xmp_obj_ref xmp_clause_opt",
"xmp_loop_clause : xmp_ON xmp_obj_ref xmp_reduction_opt xmp_clause_opt",
"xmp_loop_clause : '(' xmp_subscript_list ')' xmp_ON xmp_obj_ref xmp_reduction_opt xmp_clause_opt",
"xmp_reflect_clause : '(' xmp_expr_list ')' KW xmp_async_opt",
"xmp_reflect_clause : '(' xmp_expr_list ')' KW XMPKW_WIDTH '(' xmp_width_list ')' KW xmp_async_opt",
"xmp_gmove_clause : xmp_gmove_opt xmp_clause_opt",
"xmp_barrier_clause : xmp_ON xmp_obj_ref xmp_clause_opt",
"xmp_barrier_clause : xmp_clause_opt",
"xmp_bcast_clause : '(' xmp_expr_list ')' KW XMPKW_FROM xmp_obj_ref KW xmp_async_opt",
"xmp_bcast_clause : '(' xmp_expr_list ')' KW XMPKW_ON xmp_obj_ref KW xmp_async_opt",
"xmp_bcast_clause : '(' xmp_expr_list ')' KW XMPKW_FROM xmp_obj_ref KW XMPKW_ON xmp_obj_ref KW xmp_async_opt",
"xmp_bcast_clause : '(' xmp_expr_list ')' KW xmp_async_opt",
"xmp_reduction_clause : xmp_reduction_spec KW xmp_async_opt",
"xmp_reduction_clause : xmp_reduction_spec KW xmp_ON xmp_obj_ref KW xmp_async_opt",
"xmp_array_clause : xmp_ON xmp_obj_ref xmp_clause_opt",
"xmp_wait_async_clause : '(' xmp_expr_list ')' KW XMPKW_ON xmp_obj_ref xmp_clause_opt",
"xmp_wait_async_clause : '(' xmp_expr_list ')' KW xmp_clause_opt",
"xmp_end_clause : KW XMPKW_TASK",
"xmp_end_clause : KW XMPKW_TASKS",
"xmp_end_clause : KW XMPKW_MASTER_IO",
"xmp_end_clause : KW XMPKW_GLOBAL_IO",
"xmp_obj_ref : '(' xmp_subscript ')'",
"xmp_obj_ref : IDENTIFIER '(' xmp_subscript_list ')'",
"xmp_obj_ref : IDENTIFIER",
"xmp_obj_ref : '*'",
"xmp_subscript_list : xmp_subscript",
"xmp_subscript_list : xmp_subscript_list ',' xmp_subscript",
"xmp_subscript : expr_or_null",
"xmp_subscript : expr_or_null ':' expr_or_null",
"xmp_subscript : expr_or_null ':' expr_or_null ':' expr",
"xmp_subscript : '*'",
"xmp_dist_fmt_list : xmp_dist_fmt",
"xmp_dist_fmt_list : xmp_dist_fmt_list ',' xmp_dist_fmt",
"xmp_dist_fmt : '*'",
"xmp_dist_fmt : IDENTIFIER",
"xmp_dist_fmt : IDENTIFIER '(' expr ')'",
"xmp_dist_fmt : IDENTIFIER '(' '*' ')'",
"$$6 :",
"xmp_reduction_opt : $$6 xmp_reduction_opt1",
"xmp_reduction_opt1 :",
"xmp_reduction_opt1 : XMPKW_REDUCTION xmp_reduction_spec",
"xmp_reduction_spec : '(' xmp_reduction_op ':' xmp_reduction_var_list ')'",
"xmp_reduction_op : '+'",
"xmp_reduction_op : '*'",
"xmp_reduction_op : '-'",
"xmp_reduction_op : AND",
"xmp_reduction_op : OR",
"xmp_reduction_op : EQV",
"xmp_reduction_op : NEQV",
"xmp_reduction_op : IDENTIFIER",
"xmp_reduction_var_list : xmp_reduction_var",
"xmp_reduction_var_list : xmp_reduction_var_list ',' xmp_reduction_var",
"xmp_reduction_var : IDENTIFIER xmp_pos_var_list",
"xmp_pos_var_list :",
"xmp_pos_var_list : '/' ident_list '/'",
"xmp_gmove_opt :",
"$$7 :",
"xmp_gmove_opt : $$7 XMPKW_IN",
"$$8 :",
"xmp_gmove_opt : $$8 XMPKW_OUT",
"xmp_expr_list : expr",
"xmp_expr_list : xmp_expr_list ',' expr",
"xmp_name_list : IDENTIFIER",
"xmp_name_list : xmp_name_list ',' IDENTIFIER",
"xmp_width_list : xmp_width",
"xmp_width_list : xmp_width_list ',' xmp_width",
"xmp_width : expr_or_null",
"xmp_width : expr_or_null ':' expr_or_null",
"xmp_width : XMPKW_PERIODIC expr_or_null",
"xmp_width : XMPKW_PERIODIC expr_or_null ':' expr_or_null",
"xmp_async_opt :",
"xmp_async_opt : xmp_ASYNC '(' expr ')'",
"xmp_clause_opt :",
"xmp_clause_opt : xmp_clause_list",
"xmp_clause_list : xmp_clause_one",
"xmp_clause_list : xmp_clause_list xmp_clause_one",
"xmp_clause_one : xmp_ASYNC '(' IDENTIFIER ')'",
"$$9 :",
"xmp_ON : $$9 XMPKW_ON",
"$$10 :",
"xmp_ONTO : $$10 XMPKW_ONTO",
"$$11 :",
"xmp_WITH : $$11 XMPKW_WITH",
"$$12 :",
"xmp_ASYNC : $$12 XMPKW_ASYNC",
"$$13 :",
"xmp_NOWAIT : $$13 XMPKW_NOWAIT",
"xmp_master_io_options :",
"xmp_master_io_options : XMPKW_BEGIN",
"xmp_global_io_options :",
"xmp_global_io_options : XMPKW_BEGIN",
"xmp_global_io_options : XMPKW_ATOMIC",
"xmp_global_io_options : XMPKW_ATOMIC XMPKW_BEGIN",
"xmp_global_io_options : XMPKW_DIRECT",
"xmp_global_io_options : XMPKW_DIRECT XMPKW_BEGIN",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

typedef struct {
    unsigned stacksize;
    short    *s_base;
    short    *s_mark;
    short    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 2319 "F95-parser.y"
#include "F95-lex.c"

/* EOF */
#line 2633 "F95-parser.c"

#if YYDEBUG
#include <stdio.h>		/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = data->s_mark - data->s_base;
    newss = (short *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack)) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yystack.s_mark]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 3:
#line 383 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 4:
#line 385 "F95-parser.y"
	{	      need_check_user_defined = FALSE; }
break;
case 6:
#line 390 "F95-parser.y"
	{ compile_statement(st_no,yystack.l_mark[0].val);}
break;
case 7:
#line 392 "F95-parser.y"
	{ compile_OMP_directive(yystack.l_mark[0].val); }
break;
case 8:
#line 393 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 9:
#line 394 "F95-parser.y"
	{ compile_XMP_directive(yystack.l_mark[0].val); }
break;
case 10:
#line 396 "F95-parser.y"
	{ 
	    if (pragmaString != NULL)
		compile_statement(
		    st_no,
		    list1(F_PRAGMA_STATEMENT,
			  GEN_NODE(STRING_CONSTANT,
				   pragmaString)));
	}
break;
case 11:
#line 405 "F95-parser.y"
	{ flush_line(); yyerrok; yyclearin; }
break;
case 12:
#line 410 "F95-parser.y"
	{ yyval.val = list1(F_PROGRAM_STATEMENT,yystack.l_mark[0].val); }
break;
case 13:
#line 412 "F95-parser.y"
	{ yyval.val = list1(F95_ENDPROGRAM_STATEMENT,yystack.l_mark[0].val); }
break;
case 14:
#line 414 "F95-parser.y"
	{ yyval.val = list1(F95_MODULE_STATEMENT,yystack.l_mark[0].val); }
break;
case 15:
#line 416 "F95-parser.y"
	{ yyval.val = list1(F95_ENDMODULE_STATEMENT,yystack.l_mark[0].val); }
break;
case 16:
#line 418 "F95-parser.y"
	{
	      yyval.val = list1(F95_INTERFACE_STATEMENT, yystack.l_mark[-1].val);
	      need_check_user_defined = TRUE;
          }
break;
case 17:
#line 423 "F95-parser.y"
	{ yyval.val = list1(F95_INTERFACE_STATEMENT, list0(F95_ASSIGNOP)); }
break;
case 18:
#line 425 "F95-parser.y"
	{ yyval.val = list1(F95_INTERFACE_STATEMENT, yystack.l_mark[0].val); }
break;
case 19:
#line 427 "F95-parser.y"
	{ yyval.val = list1(F95_INTERFACE_STATEMENT,NULL); }
break;
case 20:
#line 429 "F95-parser.y"
	{ yyval.val = list1(F95_ENDINTERFACE_STATEMENT,yystack.l_mark[0].val); }
break;
case 21:
#line 431 "F95-parser.y"
	{ yyval.val = list1(F95_ENDINTERFACE_STATEMENT,
                       GEN_NODE(IDENT, find_symbol("="))); }
break;
case 22:
#line 434 "F95-parser.y"
	{ yyval.val = list1(F95_ENDINTERFACE_STATEMENT,
                       GEN_NODE(IDENT, find_symbol("="))); }
break;
case 23:
#line 437 "F95-parser.y"
	{ yyval.val = list1(F95_ENDINTERFACE_STATEMENT, yystack.l_mark[-1].val); }
break;
case 24:
#line 439 "F95-parser.y"
	{ yyval.val = list1(F95_ENDINTERFACE_STATEMENT, yystack.l_mark[-1].val); }
break;
case 25:
#line 441 "F95-parser.y"
	{ yyval.val = list1(F95_ENDINTERFACE_STATEMENT,NULL); }
break;
case 26:
#line 443 "F95-parser.y"
	{ yyval.val = list2(F95_MODULEPROCEDURE_STATEMENT, yystack.l_mark[0].val, make_int_enode(1)); }
break;
case 27:
#line 445 "F95-parser.y"
	{ yyval.val = list2(F95_MODULEPROCEDURE_STATEMENT, yystack.l_mark[0].val, make_int_enode(0)); }
break;
case 28:
#line 447 "F95-parser.y"
	{ yyval.val = list1(F_BLOCK_STATEMENT,yystack.l_mark[0].val); }
break;
case 29:
#line 449 "F95-parser.y"
	{ yyval.val = list3(F_SUBROUTINE_STATEMENT,yystack.l_mark[-1].val,yystack.l_mark[0].val,NULL); }
break;
case 30:
#line 451 "F95-parser.y"
	{ yyval.val = list3(F_SUBROUTINE_STATEMENT,yystack.l_mark[-1].val,yystack.l_mark[0].val,yystack.l_mark[-3].val); }
break;
case 31:
#line 453 "F95-parser.y"
	{ yyval.val = list1(F95_ENDSUBROUTINE_STATEMENT,yystack.l_mark[0].val); }
break;
case 32:
#line 455 "F95-parser.y"
	{ yyval.val = list5(F_FUNCTION_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-2].val,NULL,NULL, yystack.l_mark[0].val); }
break;
case 33:
#line 457 "F95-parser.y"
	{ yyval.val = list5(F_FUNCTION_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-2].val,NULL,yystack.l_mark[-5].val, yystack.l_mark[0].val); }
break;
case 34:
#line 459 "F95-parser.y"
	{ yyval.val = list5(F_FUNCTION_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-2].val,yystack.l_mark[-5].val,NULL, yystack.l_mark[0].val); }
break;
case 35:
#line 462 "F95-parser.y"
	{ yyval.val = list5(F_FUNCTION_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-2].val,yystack.l_mark[-6].val,yystack.l_mark[-5].val, yystack.l_mark[0].val); }
break;
case 36:
#line 465 "F95-parser.y"
	{ yyval.val = list5(F_FUNCTION_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-2].val,yystack.l_mark[-5].val,yystack.l_mark[-6].val, yystack.l_mark[0].val); }
break;
case 37:
#line 467 "F95-parser.y"
	{ yyval.val = list1(F95_ENDFUNCTION_STATEMENT,yystack.l_mark[0].val); }
break;
case 38:
#line 469 "F95-parser.y"
	{ yyval.val = list3(F_TYPE_DECL,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL); }
break;
case 39:
#line 471 "F95-parser.y"
	{ yyval.val = list3(F_TYPE_DECL,yystack.l_mark[-3].val,yystack.l_mark[0].val,yystack.l_mark[-2].val); }
break;
case 40:
#line 473 "F95-parser.y"
	{ yyval.val = list3(F_ENTRY_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 41:
#line 475 "F95-parser.y"
	{ yyval.val = list0(F95_CONTAINS_STATEMENT); }
break;
case 45:
#line 480 "F95-parser.y"
	{ yyval.val = list1(F_INCLUDE_STATEMENT,yystack.l_mark[0].val); }
break;
case 46:
#line 482 "F95-parser.y"
	{ yyval.val = list0(F_END_STATEMENT); }
break;
case 47:
#line 484 "F95-parser.y"
	{ error("unclassifiable statement"); flush_line(); yyval.val = NULL; }
break;
case 49:
#line 490 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 51:
#line 495 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 52:
#line 497 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 53:
#line 501 "F95-parser.y"
	{ yyval.val = list0(F95_DOTOP); }
break;
case 54:
#line 503 "F95-parser.y"
	{ yyval.val = list0(F95_POWEOP); }
break;
case 55:
#line 505 "F95-parser.y"
	{ yyval.val = list0(F95_MULOP); }
break;
case 56:
#line 507 "F95-parser.y"
	{ yyval.val = list0(F95_DIVOP); }
break;
case 57:
#line 509 "F95-parser.y"
	{ yyval.val = list0(F95_PLUSOP); }
break;
case 58:
#line 511 "F95-parser.y"
	{ yyval.val = list0(F95_MINUSOP); }
break;
case 59:
#line 513 "F95-parser.y"
	{ yyval.val = list0(F95_EQOP); }
break;
case 60:
#line 515 "F95-parser.y"
	{ yyval.val = list0(F95_NEOP); }
break;
case 61:
#line 517 "F95-parser.y"
	{ yyval.val = list0(F95_LTOP); }
break;
case 62:
#line 519 "F95-parser.y"
	{ yyval.val = list0(F95_LEOP); }
break;
case 63:
#line 521 "F95-parser.y"
	{ yyval.val = list0(F95_GEOP); }
break;
case 64:
#line 523 "F95-parser.y"
	{ yyval.val = list0(F95_GTOP); }
break;
case 65:
#line 525 "F95-parser.y"
	{ yyval.val = list0(F95_NOTOP); }
break;
case 66:
#line 527 "F95-parser.y"
	{ yyval.val = list0(F95_ANDOP); }
break;
case 67:
#line 529 "F95-parser.y"
	{ yyval.val = list0(F95_OROP); }
break;
case 68:
#line 531 "F95-parser.y"
	{ yyval.val = list0(F95_EQVOP); }
break;
case 69:
#line 533 "F95-parser.y"
	{ yyval.val = list0(F95_NEQVOP); }
break;
case 70:
#line 535 "F95-parser.y"
	{ yyval.val = list0(F95_CONCATOP); }
break;
case 72:
#line 540 "F95-parser.y"
	{ yyval.val = list1(F95_USER_DEFINED, yystack.l_mark[-1].val); }
break;
case 74:
#line 549 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); need_keyword = TRUE; }
break;
case 75:
#line 551 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-1].val,yystack.l_mark[0].val); need_keyword = TRUE; }
break;
case 76:
#line 556 "F95-parser.y"
	{ yyval.val = list0(F95_RECURSIVE_SPEC); }
break;
case 77:
#line 558 "F95-parser.y"
	{ yyval.val = list0(F95_PURE_SPEC); }
break;
case 78:
#line 560 "F95-parser.y"
	{ yyval.val = list0(F95_ELEMENTAL_SPEC); }
break;
case 80:
#line 566 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 82:
#line 571 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 83:
#line 573 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 84:
#line 575 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 85:
#line 580 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 86:
#line 582 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 88:
#line 588 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 90:
#line 597 "F95-parser.y"
	{ yyval.val = list1(F95_DIMENSION_DECL,yystack.l_mark[0].val); }
break;
case 91:
#line 599 "F95-parser.y"
	{ yyval.val = list1(F_COMMON_DECL,yystack.l_mark[0].val); }
break;
case 92:
#line 601 "F95-parser.y"
	{ yyval.val = list1(F_EXTERNAL_DECL, yystack.l_mark[0].val); }
break;
case 93:
#line 603 "F95-parser.y"
	{ yyval.val = list1(F_INTRINSIC_DECL,yystack.l_mark[0].val); }
break;
case 94:
#line 605 "F95-parser.y"
	{ yyval.val = list1(F_EQUIV_DECL,yystack.l_mark[0].val); }
break;
case 95:
#line 607 "F95-parser.y"
	{ yyval.val = list1(F_DATA_DECL,yystack.l_mark[0].val); }
break;
case 96:
#line 609 "F95-parser.y"
	{ yyval.val = list1(F_IMPLICIT_DECL, NULL); }
break;
case 97:
#line 611 "F95-parser.y"
	{ yyval.val = list1(F_IMPLICIT_DECL, yystack.l_mark[0].val); }
break;
case 98:
#line 613 "F95-parser.y"
	{ yyval.val = list1(F_NAMELIST_DECL,yystack.l_mark[0].val); }
break;
case 99:
#line 615 "F95-parser.y"
	{ yyval.val = list1(F_SAVE_DECL,NULL); }
break;
case 100:
#line 617 "F95-parser.y"
	{ yyval.val = list1(F_SAVE_DECL,yystack.l_mark[0].val); }
break;
case 101:
#line 619 "F95-parser.y"
	{ yyval.val = list1(F_PARAM_DECL,yystack.l_mark[-1].val); }
break;
case 102:
#line 621 "F95-parser.y"
	{ yyval.val = list1(F_CRAY_POINTER_DECL, yystack.l_mark[0].val); }
break;
case 103:
#line 623 "F95-parser.y"
	{
            if (formatString == NULL) {
                fatal("can't get format statement as string.");
            }
            yyval.val = list1(F_FORMAT_DECL, GEN_NODE(STRING_CONSTANT, formatString));
            formatString = NULL;
        }
break;
case 104:
#line 634 "F95-parser.y"
	{ yyval.val = list2(F95_TYPEDECL_STATEMENT,yystack.l_mark[0].val,NULL); }
break;
case 105:
#line 636 "F95-parser.y"
	{ yyval.val = list2(F95_TYPEDECL_STATEMENT,yystack.l_mark[0].val,yystack.l_mark[-2].val); }
break;
case 106:
#line 638 "F95-parser.y"
	{ yyval.val = list1(F95_ENDTYPEDECL_STATEMENT,NULL); }
break;
case 107:
#line 640 "F95-parser.y"
	{ yyval.val = list1(F95_ENDTYPEDECL_STATEMENT,yystack.l_mark[0].val); }
break;
case 108:
#line 642 "F95-parser.y"
	{ yyval.val = list1(F95_OPTIONAL_STATEMENT, yystack.l_mark[0].val); }
break;
case 109:
#line 644 "F95-parser.y"
	{ yyval.val = list1(F95_POINTER_STATEMENT, yystack.l_mark[0].val); }
break;
case 110:
#line 646 "F95-parser.y"
	{ yyval.val = list1(F95_TARGET_STATEMENT, yystack.l_mark[0].val); }
break;
case 111:
#line 648 "F95-parser.y"
	{ yyval.val = list1(F95_PUBLIC_STATEMENT,NULL); }
break;
case 112:
#line 650 "F95-parser.y"
	{ yyval.val = list1(F95_PUBLIC_STATEMENT, yystack.l_mark[0].val); }
break;
case 113:
#line 652 "F95-parser.y"
	{ yyval.val = list1(F95_PUBLIC_STATEMENT, yystack.l_mark[0].val); }
break;
case 114:
#line 654 "F95-parser.y"
	{ yyval.val = list1(F95_PRIVATE_STATEMENT,NULL); }
break;
case 115:
#line 656 "F95-parser.y"
	{ yyval.val = list1(F95_PRIVATE_STATEMENT, yystack.l_mark[0].val); }
break;
case 116:
#line 658 "F95-parser.y"
	{ yyval.val = list0(F95_SEQUENCE_STATEMENT); }
break;
case 117:
#line 660 "F95-parser.y"
	{ yyval.val = list2(F95_USE_STATEMENT,yystack.l_mark[0].val,NULL); }
break;
case 118:
#line 662 "F95-parser.y"
	{ yyval.val = list2(F95_USE_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[0].val); }
break;
case 119:
#line 664 "F95-parser.y"
	{ yyval.val = list2(F95_USE_ONLY_STATEMENT,yystack.l_mark[-4].val, NULL); }
break;
case 120:
#line 666 "F95-parser.y"
	{ yyval.val = list2(F95_USE_ONLY_STATEMENT,yystack.l_mark[-5].val,yystack.l_mark[0].val); }
break;
case 121:
#line 668 "F95-parser.y"
	{ yyval.val = list2(F95_INTENT_STATEMENT, yystack.l_mark[-3].val, yystack.l_mark[0].val); }
break;
case 122:
#line 670 "F95-parser.y"
	{ yyval.val = list1(F95_ALLOCATABLE_STATEMENT,yystack.l_mark[0].val); }
break;
case 123:
#line 675 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 124:
#line 677 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 125:
#line 682 "F95-parser.y"
	{ yyval.val = list5(F95_ARRAY_ALLOCATION, yystack.l_mark[0].val, NULL, NULL, NULL, NULL); }
break;
case 126:
#line 684 "F95-parser.y"
	{ yyval.val = list5(F95_ARRAY_ALLOCATION, yystack.l_mark[-3].val, yystack.l_mark[-1].val, NULL, NULL, NULL); }
break;
case 127:
#line 686 "F95-parser.y"
	{ yyval.val = list5(F95_ARRAY_ALLOCATION, yystack.l_mark[-7].val, yystack.l_mark[-5].val, yystack.l_mark[-2].val, NULL, NULL); }
break;
case 128:
#line 691 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 129:
#line 693 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 130:
#line 697 "F95-parser.y"
	{ yyval.val = list2(LIST,NULL,NULL); }
break;
case 131:
#line 702 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 132:
#line 704 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 133:
#line 709 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 134:
#line 714 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 135:
#line 716 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 140:
#line 730 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 141:
#line 732 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-3].val,yystack.l_mark[0].val); }
break;
case 142:
#line 737 "F95-parser.y"
	{ yyval.val = list0(F95_PARAMETER_SPEC); }
break;
case 144:
#line 740 "F95-parser.y"
	{ yyval.val = list0(F95_ALLOCATABLE_SPEC); }
break;
case 145:
#line 742 "F95-parser.y"
	{ yyval.val = list1(F95_DIMENSION_SPEC,yystack.l_mark[-1].val); }
break;
case 146:
#line 744 "F95-parser.y"
	{ yyval.val = list1(XMP_CODIMENSION_SPEC,yystack.l_mark[-1].val); }
break;
case 147:
#line 746 "F95-parser.y"
	{ yyval.val = list0(F95_EXTERNAL_SPEC); }
break;
case 148:
#line 748 "F95-parser.y"
	{ yyval.val = list1(F95_INTENT_SPEC,yystack.l_mark[-1].val); }
break;
case 149:
#line 750 "F95-parser.y"
	{ yyval.val = list0(F95_INTRINSIC_SPEC); }
break;
case 150:
#line 752 "F95-parser.y"
	{ yyval.val = list0(F95_OPTIONAL_SPEC); }
break;
case 151:
#line 754 "F95-parser.y"
	{ yyval.val = list0(F95_POINTER_SPEC); }
break;
case 152:
#line 756 "F95-parser.y"
	{ yyval.val = list0(F95_SAVE_SPEC); }
break;
case 153:
#line 758 "F95-parser.y"
	{ yyval.val = list0(F95_TARGET_SPEC); }
break;
case 154:
#line 763 "F95-parser.y"
	{ yyval.val = list0(F95_PUBLIC_SPEC); }
break;
case 155:
#line 765 "F95-parser.y"
	{ yyval.val = list0(F95_PRIVATE_SPEC); }
break;
case 156:
#line 770 "F95-parser.y"
	{ yyval.val = list0(F95_IN_EXTENT); }
break;
case 157:
#line 772 "F95-parser.y"
	{ yyval.val = list0(F95_OUT_EXTENT); }
break;
case 158:
#line 774 "F95-parser.y"
	{ yyval.val = list0(F95_INOUT_EXTENT); }
break;
case 159:
#line 779 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 160:
#line 781 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 161:
#line 786 "F95-parser.y"
	{ yyval.val = list5(LIST,yystack.l_mark[-3].val,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL,yystack.l_mark[-1].val); }
break;
case 162:
#line 788 "F95-parser.y"
	{ yyval.val = list5(LIST,yystack.l_mark[-5].val,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val,yystack.l_mark[-3].val);}
break;
case 163:
#line 790 "F95-parser.y"
	{ yyval.val = list5(LIST,yystack.l_mark[-6].val,yystack.l_mark[-5].val,yystack.l_mark[-3].val,
                     list1(F_DATA_DECL,
                           list1(LIST,
                                 list2(LIST,
                                       list1(LIST, yystack.l_mark[-6].val ),
                                       yystack.l_mark[-1].val ))), yystack.l_mark[-4].val);
        }
break;
case 164:
#line 798 "F95-parser.y"
	{ yyval.val = list5(LIST,yystack.l_mark[-5].val,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val,yystack.l_mark[-3].val);}
break;
case 165:
#line 801 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; /* need_keyword = TRUE; */ }
break;
case 166:
#line 805 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 167:
#line 807 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 168:
#line 809 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-1].val, yystack.l_mark[0].val);}
break;
case 169:
#line 811 "F95-parser.y"
	{ yyval.val = list2(LIST,GEN_NODE(F_TYPE_NODE,TYPE_CHAR),yystack.l_mark[0].val); }
break;
case 170:
#line 813 "F95-parser.y"
	{ yyval.val = list2 (LIST, GEN_NODE(F_TYPE_NODE, TYPE_REAL),
                      gen_default_real_kind()); }
break;
case 171:
#line 816 "F95-parser.y"
	{ yyval.val = list2 (LIST, GEN_NODE(F_TYPE_NODE, TYPE_COMPLEX),
                      gen_default_real_kind()); }
break;
case 172:
#line 821 "F95-parser.y"
	{ yyval.val = GEN_NODE(F_TYPE_NODE,TYPE_INT); }
break;
case 173:
#line 822 "F95-parser.y"
	{ yyval.val = GEN_NODE(F_TYPE_NODE,TYPE_REAL); }
break;
case 174:
#line 823 "F95-parser.y"
	{ yyval.val = GEN_NODE(F_TYPE_NODE,TYPE_COMPLEX); }
break;
case 175:
#line 824 "F95-parser.y"
	{ yyval.val = GEN_NODE(F_TYPE_NODE,TYPE_LOGICAL); }
break;
case 176:
#line 829 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 177:
#line 833 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 178:
#line 835 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-1].val, NULL); }
break;
case 179:
#line 837 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-1].val, NULL); }
break;
case 180:
#line 839 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-4].val, yystack.l_mark[-1].val); }
break;
case 181:
#line 841 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-6].val, list1(F95_KIND_SELECTOR_SPEC, yystack.l_mark[-1].val)); }
break;
case 182:
#line 843 "F95-parser.y"
	{ yyval.val = list2(LIST, NULL, yystack.l_mark[-1].val); }
break;
case 183:
#line 845 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-1].val, yystack.l_mark[-4].val); }
break;
case 184:
#line 847 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 185:
#line 849 "F95-parser.y"
	{ yyval.val = list0(LIST); }
break;
case 186:
#line 853 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC, yystack.l_mark[0].val); }
break;
case 187:
#line 857 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC, NULL); }
break;
case 188:
#line 859 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC, yystack.l_mark[0].val); }
break;
case 189:
#line 863 "F95-parser.y"
	{ yyval.val = list1(F95_KIND_SELECTOR_SPEC, yystack.l_mark[0].val); }
break;
case 190:
#line 867 "F95-parser.y"
	{ yyval.val = list1(F95_KIND_SELECTOR_SPEC, yystack.l_mark[-1].val); }
break;
case 191:
#line 869 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC, NULL); }
break;
case 192:
#line 871 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC, yystack.l_mark[-1].val); }
break;
case 193:
#line 873 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 194:
#line 877 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 195:
#line 879 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC,yystack.l_mark[0].val); }
break;
case 196:
#line 881 "F95-parser.y"
	{ yyval.val = list1(F95_LEN_SELECTOR_SPEC, NULL); }
break;
case 197:
#line 885 "F95-parser.y"
	{ need_type_len = TRUE; }
break;
case 198:
#line 890 "F95-parser.y"
	{ yyval.val = list2(LIST, NULL, yystack.l_mark[0].val); }
break;
case 199:
#line 892 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 200:
#line 894 "F95-parser.y"
	{ yyval.val = list_put_last(list_put_last(yystack.l_mark[-4].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 201:
#line 896 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 202:
#line 900 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 203:
#line 902 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 204:
#line 906 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 205:
#line 910 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 206:
#line 912 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 207:
#line 916 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 208:
#line 918 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 209:
#line 923 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[-1].val); }
break;
case 210:
#line 925 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-4].val,yystack.l_mark[-1].val); }
break;
case 211:
#line 930 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 212:
#line 932 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 213:
#line 937 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 214:
#line 939 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 215:
#line 944 "F95-parser.y"
	{ yyval.val = list2(LIST, yystack.l_mark[-3].val, yystack.l_mark[-1].val); }
break;
case 216:
#line 949 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 217:
#line 951 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF, EXPR_ARG1(yystack.l_mark[0].val), EXPR_ARG2(yystack.l_mark[0].val)); }
break;
case 218:
#line 955 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 219:
#line 957 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 220:
#line 961 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 221:
#line 965 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 222:
#line 967 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 223:
#line 971 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 224:
#line 973 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); /* struct constructor */ }
break;
case 225:
#line 975 "F95-parser.y"
	{ yyval.val = list2(F_DUP_DECL,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 227:
#line 980 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val;}
break;
case 228:
#line 982 "F95-parser.y"
	{ yyval.val = list1(F_UNARY_MINUS_EXPR,yystack.l_mark[0].val); }
break;
case 232:
#line 992 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 233:
#line 994 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 235:
#line 999 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 236:
#line 1003 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 237:
#line 1005 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 240:
#line 1022 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 241:
#line 1024 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 242:
#line 1028 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 243:
#line 1030 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 244:
#line 1034 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 245:
#line 1039 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 246:
#line 1041 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 248:
#line 1046 "F95-parser.y"
	{ yyval.val = list2(F_IMPLIED_DO, yystack.l_mark[-1].val, yystack.l_mark[-3].val); }
break;
case 249:
#line 1050 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 250:
#line 1052 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 251:
#line 1056 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 252:
#line 1058 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 254:
#line 1063 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 255:
#line 1065 "F95-parser.y"
	{ yyval.val = list2(LIST,NULL,NULL); }
break;
case 256:
#line 1070 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 257:
#line 1074 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 258:
#line 1076 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 259:
#line 1080 "F95-parser.y"
	{ yyval.val = list3(F95_TRIPLET_EXPR,NULL,yystack.l_mark[0].val,NULL); }
break;
case 260:
#line 1082 "F95-parser.y"
	{ yyval.val = list3(F95_TRIPLET_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL); }
break;
case 261:
#line 1086 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 262:
#line 1088 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 263:
#line 1092 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 264:
#line 1094 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 266:
#line 1099 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 267:
#line 1101 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,NULL); }
break;
case 268:
#line 1103 "F95-parser.y"
	{ yyval.val = list2(LIST,NULL,NULL); }
break;
case 269:
#line 1107 "F95-parser.y"
	{ yyval.val = list0(F_ASTERISK); }
break;
case 271:
#line 1112 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 272:
#line 1114 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 273:
#line 1118 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 274:
#line 1120 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 275:
#line 1125 "F95-parser.y"
	{ yyval.val = list2(LIST, list2(LIST, yystack.l_mark[-3].val, yystack.l_mark[-1].val), NULL); }
break;
case 276:
#line 1127 "F95-parser.y"
	{ yyval.val = list2(LIST, list2(LIST, yystack.l_mark[0].val,NULL), NULL); }
break;
case 277:
#line 1131 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 278:
#line 1133 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 280:
#line 1138 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 281:
#line 1142 "F95-parser.y"
	{ yyval.val = list1(LIST,list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val)); }
break;
case 282:
#line 1144 "F95-parser.y"
	{ yyval.val = list_cons(list2(LIST,yystack.l_mark[-4].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 283:
#line 1148 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 284:
#line 1150 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 286:
#line 1159 "F95-parser.y"
	{ yyval.val = list3(F_DOWHILE_STATEMENT, yystack.l_mark[-4].val, yystack.l_mark[-1].val, st_name); }
break;
case 287:
#line 1161 "F95-parser.y"
	{ yyval.val = list3(F_DO_STATEMENT, yystack.l_mark[-1].val, yystack.l_mark[0].val, st_name); }
break;
case 288:
#line 1163 "F95-parser.y"
	{ yyval.val = list3(F_DO_STATEMENT, yystack.l_mark[-2].val, yystack.l_mark[0].val, st_name); }
break;
case 289:
#line 1165 "F95-parser.y"
	{ yyval.val = list3(F_DO_STATEMENT, yystack.l_mark[0].val, NULL, st_name); }
break;
case 290:
#line 1167 "F95-parser.y"
	{ yyval.val = list3(F_DO_STATEMENT,NULL, yystack.l_mark[0].val, st_name); }
break;
case 291:
#line 1169 "F95-parser.y"
	{ yyval.val = list3(F_DO_STATEMENT,NULL, NULL, st_name); }
break;
case 292:
#line 1171 "F95-parser.y"
	{ yyval.val = list1(F_ENDDO_STATEMENT,yystack.l_mark[0].val); }
break;
case 293:
#line 1173 "F95-parser.y"
	{ yyval.val = list2(F_IF_STATEMENT, yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 294:
#line 1175 "F95-parser.y"
	{ yyval.val = list2(F_IF_STATEMENT, yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 295:
#line 1177 "F95-parser.y"
	{ yyval.val = list3(F_IF_STATEMENT, yystack.l_mark[-3].val, NULL, st_name); }
break;
case 296:
#line 1179 "F95-parser.y"
	{ yyval.val = list1(F_ELSEIF_STATEMENT,yystack.l_mark[-3].val); }
break;
case 297:
#line 1181 "F95-parser.y"
	{ yyval.val = list0(F_ELSE_STATEMENT); }
break;
case 298:
#line 1183 "F95-parser.y"
	{ yyval.val = list0(F_ENDIF_STATEMENT); }
break;
case 299:
#line 1185 "F95-parser.y"
	{ yyval.val = list3(F_DOWHILE_STATEMENT, NULL, yystack.l_mark[-1].val, st_name); }
break;
case 300:
#line 1204 "F95-parser.y"
	{ yyval.val = list2(F_WHERE_STATEMENT,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 301:
#line 1206 "F95-parser.y"
	{ yyval.val = list0(F_ELSEWHERE_STATEMENT); }
break;
case 302:
#line 1208 "F95-parser.y"
	{ yyval.val = list2(F_ELSEWHERE_STATEMENT, yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 303:
#line 1210 "F95-parser.y"
	{ yyval.val = list0(F_ENDWHERE_STATEMENT); }
break;
case 304:
#line 1212 "F95-parser.y"
	{ yyval.val = list2(F_SELECTCASE_STATEMENT, yystack.l_mark[-1].val, st_name); }
break;
case 305:
#line 1214 "F95-parser.y"
	{ yyval.val = list2(F_CASELABEL_STATEMENT, yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 306:
#line 1216 "F95-parser.y"
	{ yyval.val = list2(F_CASELABEL_STATEMENT, NULL, yystack.l_mark[0].val); }
break;
case 307:
#line 1218 "F95-parser.y"
	{ yyval.val = list1(F_ENDSELECT_STATEMENT,yystack.l_mark[0].val); }
break;
case 308:
#line 1222 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 309:
#line 1224 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 310:
#line 1228 "F95-parser.y"
	{ yyval.val = list2(F_LET_STATEMENT,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 311:
#line 1233 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL); }
break;
case 312:
#line 1235 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-6].val,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 315:
#line 1245 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 316:
#line 1247 "F95-parser.y"
	{ yyval.val = list2(F95_POINTER_SET_STATEMENT,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 317:
#line 1250 "F95-parser.y"
	{ yyval.val = list2(F_ASSIGN_LABEL_STATEMENT, yystack.l_mark[-3].val, yystack.l_mark[0].val); }
break;
case 318:
#line 1252 "F95-parser.y"
	{ yyval.val = list0(F_CONTINUE_STATEMENT); }
break;
case 319:
#line 1254 "F95-parser.y"
	{ yyval.val = list1(F_GOTO_STATEMENT,yystack.l_mark[0].val); }
break;
case 320:
#line 1256 "F95-parser.y"
	{ yyval.val = list2(F_ASGOTO_STATEMENT,yystack.l_mark[0].val,NULL); }
break;
case 321:
#line 1258 "F95-parser.y"
	{ yyval.val = list2(F_ASGOTO_STATEMENT,yystack.l_mark[-4].val,yystack.l_mark[-1].val); }
break;
case 322:
#line 1260 "F95-parser.y"
	{ yyval.val = list2(F_COMPGOTO_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[0].val); }
break;
case 323:
#line 1262 "F95-parser.y"
	{ yyval.val = list4(F_ARITHIF_STATEMENT,yystack.l_mark[-6].val,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 324:
#line 1264 "F95-parser.y"
	{ yyval.val = list2(F_CALL_STATEMENT,yystack.l_mark[0].val,NULL); }
break;
case 325:
#line 1266 "F95-parser.y"
	{ yyval.val = list2(F_CALL_STATEMENT,yystack.l_mark[-2].val,NULL); }
break;
case 326:
#line 1268 "F95-parser.y"
	{ yyval.val = list2(F_CALL_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 327:
#line 1270 "F95-parser.y"
	{ yyval.val = list1(F_RETURN_STATEMENT,yystack.l_mark[0].val); }
break;
case 328:
#line 1272 "F95-parser.y"
	{ yyval.val = list1(F_PAUSE_STATEMENT,yystack.l_mark[0].val); }
break;
case 329:
#line 1274 "F95-parser.y"
	{ yyval.val = list1(F_STOP_STATEMENT,yystack.l_mark[0].val); }
break;
case 333:
#line 1279 "F95-parser.y"
	{
          yyval.val = list1(F_PRAGMA_STATEMENT,
                     GEN_NODE(STRING_CONSTANT, pragmaString)); 
         pragmaString = NULL;
        }
break;
case 334:
#line 1288 "F95-parser.y"
	{ yyval.val = list1(F95_CYCLE_STATEMENT,yystack.l_mark[0].val); }
break;
case 335:
#line 1290 "F95-parser.y"
	{ yyval.val = list1(F95_EXIT_STATEMENT,yystack.l_mark[0].val); }
break;
case 336:
#line 1292 "F95-parser.y"
	{ yyval.val = list1(F95_ALLOCATE_STATEMENT,yystack.l_mark[-1].val); }
break;
case 337:
#line 1294 "F95-parser.y"
	{ yyval.val = list1(F95_NULLIFY_STATEMENT,yystack.l_mark[-1].val); }
break;
case 338:
#line 1296 "F95-parser.y"
	{ yyval.val = list1(F95_DEALLOCATE_STATEMENT,yystack.l_mark[-1].val); }
break;
case 339:
#line 1301 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 340:
#line 1303 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 343:
#line 1313 "F95-parser.y"
	{ yyval.val = list2(F_CALL_STATEMENT,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 344:
#line 1315 "F95-parser.y"
	{ yyval.val = list2(F_CALL_STATEMENT,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 345:
#line 1320 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_sync_all")); }
break;
case 346:
#line 1322 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_sync_memory")); }
break;
case 347:
#line 1324 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_lock")); }
break;
case 348:
#line 1326 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_unlock")); }
break;
case 349:
#line 1328 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_critical")); }
break;
case 350:
#line 1330 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_end_critical")); }
break;
case 351:
#line 1332 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_error_stop")); }
break;
case 352:
#line 1337 "F95-parser.y"
	{ yyval.val = GEN_NODE(IDENT, find_symbol("xmpf_sync_images")); }
break;
case 355:
#line 1345 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 356:
#line 1347 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 357:
#line 1352 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 358:
#line 1357 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 359:
#line 1359 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 360:
#line 1361 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 363:
#line 1368 "F95-parser.y"
	{ yyval.val = list1(F_LABEL_REF,yystack.l_mark[0].val); }
break;
case 364:
#line 1370 "F95-parser.y"
	{ yyval.val = list3(F95_TRIPLET_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL); }
break;
case 365:
#line 1372 "F95-parser.y"
	{ yyval.val = list3(F95_TRIPLET_EXPR,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 366:
#line 1374 "F95-parser.y"
	{ yyval.val = list3(F95_TRIPLET_EXPR,yystack.l_mark[-2].val,NULL,yystack.l_mark[0].val); }
break;
case 367:
#line 1379 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 368:
#line 1381 "F95-parser.y"
	{ yyval.val = list1(LIST,GEN_NODE(STRING_CONSTANT,strdup("*"))); }
break;
case 369:
#line 1383 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 370:
#line 1388 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 371:
#line 1393 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 372:
#line 1395 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 373:
#line 1402 "F95-parser.y"
	{ yyval.val = list2(F_PRINT_STATEMENT,yystack.l_mark[0].val,NULL); }
break;
case 374:
#line 1404 "F95-parser.y"
	{ yyval.val = list2(F_PRINT_STATEMENT,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 375:
#line 1406 "F95-parser.y"
	{ yyval.val = list2(F_WRITE_STATEMENT,yystack.l_mark[-1].val,NULL); }
break;
case 376:
#line 1408 "F95-parser.y"
	{ yyval.val = list2(F_WRITE_STATEMENT,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 377:
#line 1410 "F95-parser.y"
	{ yyval.val = list2(F_READ_STATEMENT,yystack.l_mark[-1].val,NULL); }
break;
case 378:
#line 1412 "F95-parser.y"
	{ yyval.val = list2(F_READ_STATEMENT,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 379:
#line 1414 "F95-parser.y"
	{ yyval.val = list2(F_READ1_STATEMENT,list2(LIST,NULL,yystack.l_mark[0].val),NULL); }
break;
case 380:
#line 1416 "F95-parser.y"
	{ yyval.val = list2(F_READ1_STATEMENT,list2(LIST,NULL,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 381:
#line 1418 "F95-parser.y"
	{ yyval.val = list1(F_OPEN_STATEMENT,yystack.l_mark[-1].val); }
break;
case 382:
#line 1420 "F95-parser.y"
	{ yyval.val = list1(F_CLOSE_STATEMENT,yystack.l_mark[-1].val); }
break;
case 383:
#line 1422 "F95-parser.y"
	{ yyval.val = list1(F_BACKSPACE_STATEMENT,yystack.l_mark[-1].val); }
break;
case 384:
#line 1424 "F95-parser.y"
	{ yyval.val = list1(F_BACKSPACE_STATEMENT,yystack.l_mark[0].val); }
break;
case 385:
#line 1426 "F95-parser.y"
	{ yyval.val = list1(F_ENDFILE_STATEMENT,yystack.l_mark[-1].val); }
break;
case 386:
#line 1428 "F95-parser.y"
	{ yyval.val = list1(F_ENDFILE_STATEMENT,yystack.l_mark[0].val); }
break;
case 387:
#line 1430 "F95-parser.y"
	{ yyval.val = list1(F_REWIND_STATEMENT,yystack.l_mark[-1].val); }
break;
case 388:
#line 1432 "F95-parser.y"
	{ yyval.val = list1(F_REWIND_STATEMENT,yystack.l_mark[0].val); }
break;
case 389:
#line 1434 "F95-parser.y"
	{ yyval.val = list2(F_INQUIRE_STATEMENT,yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 390:
#line 1438 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 391:
#line 1440 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 393:
#line 1446 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 394:
#line 1448 "F95-parser.y"
	{ yyval.val = list0(F_STARSTAR); }
break;
case 395:
#line 1450 "F95-parser.y"
	{ yyval.val = list2(F_SET_EXPR,yystack.l_mark[-2].val,NULL); }
break;
case 396:
#line 1452 "F95-parser.y"
	{ yyval.val = list2(F_SET_EXPR,yystack.l_mark[-2].val,list0(F_STARSTAR)); }
break;
case 397:
#line 1454 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 398:
#line 1459 "F95-parser.y"
	{
            /*
             * FIXME:
             *
             *	Sorry I can't let a grammer "KW KW_KIND '=' expr" work
             *	well, never even close.
             */
            if (strcasecmp(SYM_NAME(EXPR_SYM(yystack.l_mark[-2].val)), "kind") == 0) {
                yyval.val = list1(F95_KIND_SELECTOR_SPEC, yystack.l_mark[0].val);
            } else {
                yyval.val = list2(F_SET_EXPR, yystack.l_mark[-2].val, yystack.l_mark[0].val);
            }
        }
break;
case 399:
#line 1475 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 401:
#line 1480 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 403:
#line 1486 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 404:
#line 1488 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 406:
#line 1494 "F95-parser.y"
	{ yyval.val = list_cons(yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 407:
#line 1496 "F95-parser.y"
	{ yyval.val = list2(F_IMPLIED_DO,yystack.l_mark[-1].val,list1(LIST,yystack.l_mark[-3].val)); }
break;
case 408:
#line 1498 "F95-parser.y"
	{ yyval.val = list2(F_IMPLIED_DO,yystack.l_mark[-1].val,list_cons(yystack.l_mark[-5].val,yystack.l_mark[-3].val)); }
break;
case 409:
#line 1500 "F95-parser.y"
	{ yyval.val = list2(F_IMPLIED_DO,yystack.l_mark[-1].val,yystack.l_mark[-3].val); }
break;
case 411:
#line 1505 "F95-parser.y"
	{ yyval.val = list1(F95_ARRAY_CONSTRUCTOR, yystack.l_mark[-1].val); }
break;
case 412:
#line 1507 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 415:
#line 1511 "F95-parser.y"
	{ yyval.val = list2(F_PLUS_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 416:
#line 1513 "F95-parser.y"
	{ yyval.val = list2(F_MINUS_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 417:
#line 1515 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 418:
#line 1517 "F95-parser.y"
	{ yyval.val = list1(F_UNARY_MINUS_EXPR,yystack.l_mark[0].val); }
break;
case 419:
#line 1519 "F95-parser.y"
	{ yyval.val = list2(F_MUL_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 420:
#line 1521 "F95-parser.y"
	{ yyval.val = list2(F_DIV_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 421:
#line 1523 "F95-parser.y"
	{ yyval.val = list2(F_POWER_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 422:
#line 1525 "F95-parser.y"
	{ yyval.val = list2(F_EQ_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 423:
#line 1527 "F95-parser.y"
	{ yyval.val = list2(F_GT_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 424:
#line 1529 "F95-parser.y"
	{ yyval.val = list2(F_LT_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 425:
#line 1531 "F95-parser.y"
	{ yyval.val = list2(F_GE_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 426:
#line 1533 "F95-parser.y"
	{ yyval.val = list2(F_LE_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 427:
#line 1535 "F95-parser.y"
	{ yyval.val = list2(F_NE_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 428:
#line 1537 "F95-parser.y"
	{ yyval.val = list2(F_EQV_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 429:
#line 1539 "F95-parser.y"
	{ yyval.val = list2(F_NEQV_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 430:
#line 1541 "F95-parser.y"
	{ yyval.val = list2(F_OR_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 431:
#line 1543 "F95-parser.y"
	{ yyval.val = list2(F_AND_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 432:
#line 1545 "F95-parser.y"
	{ yyval.val = list1(F_NOT_EXPR,yystack.l_mark[0].val); }
break;
case 433:
#line 1547 "F95-parser.y"
	{ yyval.val = list2(F_CONCAT_EXPR,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 434:
#line 1549 "F95-parser.y"
	{ yyval.val = list3(F95_USER_DEFINED_BINARY_EXPR, yystack.l_mark[-1].val, yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 435:
#line 1551 "F95-parser.y"
	{ yyval.val = list2(F95_USER_DEFINED_UNARY_EXPR, yystack.l_mark[-1].val, yystack.l_mark[0].val); }
break;
case 436:
#line 1553 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 437:
#line 1558 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 438:
#line 1560 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 439:
#line 1562 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 440:
#line 1564 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF, list2(F_ARRAY_REF,yystack.l_mark[-2].val,yystack.l_mark[-1].val), yystack.l_mark[0].val); }
break;
case 441:
#line 1566 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,list2(F_ARRAY_REF,yystack.l_mark[-2].val,yystack.l_mark[-1].val),yystack.l_mark[0].val); }
break;
case 442:
#line 1568 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 443:
#line 1570 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 444:
#line 1572 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 445:
#line 1574 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF,list2(F_ARRAY_REF,yystack.l_mark[-2].val,yystack.l_mark[-1].val),yystack.l_mark[0].val); }
break;
case 446:
#line 1576 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,list2(F_ARRAY_REF,yystack.l_mark[-2].val,yystack.l_mark[-1].val),yystack.l_mark[0].val); }
break;
case 447:
#line 1581 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 448:
#line 1583 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,list2(XMP_COARRAY_REF,yystack.l_mark[-3].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 449:
#line 1585 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,list2(F_ARRAY_REF,yystack.l_mark[-3].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 450:
#line 1587 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF, list2(XMP_COARRAY_REF,list2(F_ARRAY_REF,yystack.l_mark[-4].val,yystack.l_mark[-3].val),yystack.l_mark[-2].val), yystack.l_mark[0].val); }
break;
case 451:
#line 1589 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 452:
#line 1591 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,list2(XMP_COARRAY_REF,yystack.l_mark[-3].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 453:
#line 1593 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,list2(F_ARRAY_REF,yystack.l_mark[-3].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 454:
#line 1595 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF, list2(XMP_COARRAY_REF,list2(F_ARRAY_REF,yystack.l_mark[-4].val,yystack.l_mark[-3].val),yystack.l_mark[-2].val), yystack.l_mark[0].val); }
break;
case 455:
#line 1600 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 456:
#line 1602 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 457:
#line 1604 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 458:
#line 1606 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF, list2(F_ARRAY_REF,yystack.l_mark[-2].val,yystack.l_mark[-1].val), yystack.l_mark[0].val); }
break;
case 459:
#line 1610 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 460:
#line 1612 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 461:
#line 1614 "F95-parser.y"
	{ yyval.val = list2(F_ARRAY_REF,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 462:
#line 1616 "F95-parser.y"
	{ yyval.val = list2(XMP_COARRAY_REF,list2(F_ARRAY_REF,yystack.l_mark[-2].val,yystack.l_mark[-1].val),yystack.l_mark[0].val); }
break;
case 463:
#line 1623 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 464:
#line 1627 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,list2(F_ARRAY_REF,yystack.l_mark[-3].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 465:
#line 1631 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 466:
#line 1635 "F95-parser.y"
	{ yyval.val = list2(F95_MEMBER_REF,list2(F_ARRAY_REF,yystack.l_mark[-3].val,yystack.l_mark[-2].val),yystack.l_mark[0].val); }
break;
case 467:
#line 1642 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 468:
#line 1644 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 469:
#line 1656 "F95-parser.y"
	{
            if (EXPR_CODE(yystack.l_mark[-1].val) != STRING_CONSTANT) {
                error_at_node(yystack.l_mark[-1].val, "not a string constant.");
                yyval.val = NULL;
            } else {
                yyval.val = list2(F_STRING_CONST_SUBSTR, yystack.l_mark[-1].val, yystack.l_mark[0].val);
            }
        }
break;
case 470:
#line 1666 "F95-parser.y"
	{ yyval.val = list1(LIST, list3(F95_TRIPLET_EXPR,yystack.l_mark[-3].val,yystack.l_mark[-1].val,NULL)); }
break;
case 471:
#line 1670 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 474:
#line 1676 "F95-parser.y"
	{ yyval.val = list2(F95_CONSTANT_WITH, yystack.l_mark[-2].val, yystack.l_mark[0].val);  }
break;
case 475:
#line 1678 "F95-parser.y"
	{ yyval.val = list0(F_TRUE_CONSTANT); }
break;
case 476:
#line 1680 "F95-parser.y"
	{ yyval.val = list0(F_FALSE_CONSTANT); }
break;
case 477:
#line 1682 "F95-parser.y"
	{ yyval.val = list1(F95_TRUE_CONSTANT_WITH, yystack.l_mark[0].val); }
break;
case 478:
#line 1684 "F95-parser.y"
	{ yyval.val = list1(F95_FALSE_CONSTANT_WITH, yystack.l_mark[0].val); }
break;
case 481:
#line 1692 "F95-parser.y"
	{ yyval.val = list2(COMPLEX_CONSTANT,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 482:
#line 1694 "F95-parser.y"
	{ yyval.val = list2(COMPLEX_CONSTANT,NULL,yystack.l_mark[-1].val); }
break;
case 483:
#line 1696 "F95-parser.y"
	{ yyval.val = list2(COMPLEX_CONSTANT,yystack.l_mark[-3].val,NULL); }
break;
case 484:
#line 1700 "F95-parser.y"
	{ yyval.val = list1(LIST, yystack.l_mark[0].val); }
break;
case 485:
#line 1702 "F95-parser.y"
	{ yyval.val = list_cons(yystack.l_mark[-2].val, yystack.l_mark[0].val); }
break;
case 486:
#line 1706 "F95-parser.y"
	{ yyval.val = list3(F_SCENE_RANGE_EXPR,yystack.l_mark[0].val,NULL,NULL); }
break;
case 487:
#line 1708 "F95-parser.y"
	{ yyval.val = list3(F_SCENE_RANGE_EXPR,NULL,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 488:
#line 1716 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_PARALLEL,yystack.l_mark[0].val); }
break;
case 489:
#line 1718 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_PARALLEL,NULL); }
break;
case 490:
#line 1720 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_DO,yystack.l_mark[0].val); }
break;
case 491:
#line 1722 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_DO,yystack.l_mark[0].val); }
break;
case 492:
#line 1724 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_PARALLEL_DO,yystack.l_mark[0].val); }
break;
case 493:
#line 1726 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_PARALLEL_DO,yystack.l_mark[0].val); }
break;
case 494:
#line 1728 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_SECTIONS,yystack.l_mark[0].val); }
break;
case 495:
#line 1730 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_SECTIONS,yystack.l_mark[0].val); }
break;
case 496:
#line 1732 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_PARALLEL_SECTIONS,yystack.l_mark[0].val); }
break;
case 497:
#line 1734 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_PARALLEL_SECTIONS,yystack.l_mark[0].val); }
break;
case 498:
#line 1736 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_SECTION,NULL); }
break;
case 499:
#line 1738 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_SINGLE,yystack.l_mark[0].val); }
break;
case 500:
#line 1740 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_SINGLE,yystack.l_mark[0].val); }
break;
case 501:
#line 1742 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_MASTER,NULL); }
break;
case 502:
#line 1744 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_MASTER,NULL); }
break;
case 503:
#line 1746 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_CRITICAL,NULL); }
break;
case 504:
#line 1748 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_CRITICAL,NULL); }
break;
case 505:
#line 1750 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_CRITICAL,list1(LIST,yystack.l_mark[-1].val)); }
break;
case 506:
#line 1752 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_CRITICAL,list1(LIST,yystack.l_mark[-1].val)); }
break;
case 507:
#line 1754 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_BARRIER,NULL); }
break;
case 508:
#line 1756 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_ATOMIC,NULL); }
break;
case 509:
#line 1758 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_FLUSH,NULL); }
break;
case 510:
#line 1760 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_FLUSH,yystack.l_mark[-1].val); }
break;
case 511:
#line 1762 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_ORDERED,NULL); }
break;
case 512:
#line 1764 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_END_ORDERED,NULL); }
break;
case 513:
#line 1766 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_F_THREADPRIVATE,yystack.l_mark[-1].val); }
break;
case 514:
#line 1768 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 515:
#line 1770 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 516:
#line 1772 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 517:
#line 1774 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 518:
#line 1778 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 519:
#line 1780 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DIR_NOWAIT,NULL); }
break;
case 520:
#line 1784 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 522:
#line 1790 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 523:
#line 1792 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 524:
#line 1794 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 525:
#line 1799 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DIR_NOWAIT,NULL); }
break;
case 526:
#line 1801 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_COPYPRIVATE,yystack.l_mark[-1].val); }
break;
case 527:
#line 1805 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 529:
#line 1811 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 530:
#line 1813 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 531:
#line 1815 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 532:
#line 1820 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_PRIVATE,yystack.l_mark[-1].val); }
break;
case 533:
#line 1822 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_SHARED,yystack.l_mark[-1].val); }
break;
case 534:
#line 1823 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 535:
#line 1824 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_DEFAULT,yystack.l_mark[-1].val); }
break;
case 536:
#line 1826 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_FIRSTPRIVATE,yystack.l_mark[-1].val); }
break;
case 537:
#line 1828 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_LASTPRIVATE,yystack.l_mark[-1].val); }
break;
case 538:
#line 1830 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DATA_COPYIN,yystack.l_mark[-1].val); }
break;
case 539:
#line 1832 "F95-parser.y"
	{ yyval.val = OMP_LIST(yystack.l_mark[-3].code,yystack.l_mark[-1].val); }
break;
case 540:
#line 1834 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DIR_IF,yystack.l_mark[-1].val); }
break;
case 541:
#line 1835 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 542:
#line 1836 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 543:
#line 1838 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DIR_ORDERED,NULL); }
break;
case 544:
#line 1842 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_PLUS; }
break;
case 545:
#line 1843 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_MINUS; }
break;
case 546:
#line 1844 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_MUL; }
break;
case 547:
#line 1845 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_LOGAND; }
break;
case 548:
#line 1846 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_LOGOR; }
break;
case 549:
#line 1847 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_EQV; }
break;
case 550:
#line 1848 "F95-parser.y"
	{ yyval.code = (int) OMP_DATA_REDUCTION_NEQV; }
break;
case 551:
#line 1849 "F95-parser.y"
	{ yyval.code = OMP_reduction_op(yystack.l_mark[0].val); }
break;
case 552:
#line 1854 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 553:
#line 1856 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 554:
#line 1869 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 555:
#line 1871 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 556:
#line 1873 "F95-parser.y"
	{ yyval.val = list1(LIST,list1(LIST,yystack.l_mark[-1].val)); }
break;
case 557:
#line 1875 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-4].val,list1(LIST,yystack.l_mark[-1].val)); }
break;
case 558:
#line 1880 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DIR_SCHEDULE,OMP_LIST(yystack.l_mark[0].code,NULL)); }
break;
case 559:
#line 1882 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DIR_SCHEDULE,OMP_LIST(yystack.l_mark[-2].code,yystack.l_mark[0].val)); }
break;
case 560:
#line 1886 "F95-parser.y"
	{ yyval.code = (int) OMP_SCHED_STATIC; }
break;
case 561:
#line 1887 "F95-parser.y"
	{ yyval.code = (int) OMP_SCHED_DYNAMIC; }
break;
case 562:
#line 1888 "F95-parser.y"
	{ yyval.code = (int) OMP_SCHED_GUIDED; }
break;
case 563:
#line 1889 "F95-parser.y"
	{ yyval.code = (int) OMP_SCHED_RUNTIME; }
break;
case 564:
#line 1893 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DEFAULT_SHARED,NULL); }
break;
case 565:
#line 1894 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DEFAULT_PRIVATE,NULL); }
break;
case 566:
#line 1895 "F95-parser.y"
	{ yyval.val = OMP_LIST(OMP_DEFAULT_NONE,NULL); }
break;
case 567:
#line 1903 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_NODES,yystack.l_mark[0].val); }
break;
case 568:
#line 1905 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_TEMPLATE,yystack.l_mark[0].val); }
break;
case 569:
#line 1907 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_DISTRIBUTE,yystack.l_mark[0].val); }
break;
case 570:
#line 1909 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_ALIGN,yystack.l_mark[0].val); }
break;
case 571:
#line 1911 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_SHADOW,yystack.l_mark[0].val); }
break;
case 572:
#line 1913 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_TEMPLATE_FIX,yystack.l_mark[0].val); }
break;
case 573:
#line 1915 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_TASK,yystack.l_mark[0].val); }
break;
case 574:
#line 1917 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 575:
#line 1919 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_TASKS,NULL); }
break;
case 576:
#line 1921 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_TASKS,
	                    GEN_NODE(INT_CONSTANT, XMP_OPT_NOWAIT)); }
break;
case 577:
#line 1923 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 578:
#line 1924 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_LOOP,yystack.l_mark[0].val); }
break;
case 579:
#line 1926 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_REFLECT,yystack.l_mark[0].val); }
break;
case 580:
#line 1928 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_GMOVE,yystack.l_mark[0].val); }
break;
case 581:
#line 1929 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 582:
#line 1930 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_BARRIER,yystack.l_mark[0].val); }
break;
case 583:
#line 1932 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_REDUCTION,yystack.l_mark[0].val); }
break;
case 584:
#line 1934 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_BCAST,yystack.l_mark[0].val); }
break;
case 585:
#line 1936 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_ARRAY,yystack.l_mark[0].val); }
break;
case 586:
#line 1938 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_LOCAL_ALIAS, list2(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val)); }
break;
case 587:
#line 1941 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_WAIT_ASYNC, yystack.l_mark[0].val); }
break;
case 588:
#line 1944 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_MASTER_IO_BEGIN, yystack.l_mark[0].val); }
break;
case 589:
#line 1946 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_GLOBAL_IO_BEGIN, yystack.l_mark[0].val); }
break;
case 590:
#line 1953 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-3].val,yystack.l_mark[-1].val,NULL); }
break;
case 591:
#line 1955 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-5].val,yystack.l_mark[-3].val,XMP_LIST(XMP_NODES_INHERIT_EXEC,NULL)); }
break;
case 592:
#line 1957 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-5].val,yystack.l_mark[-3].val,XMP_LIST(XMP_NODES_INHERIT_NODES,yystack.l_mark[0].val)); }
break;
case 593:
#line 1959 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[-3].val,NULL); }
break;
case 594:
#line 1961 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[-5].val,XMP_LIST(XMP_NODES_INHERIT_EXEC,NULL)); }
break;
case 595:
#line 1963 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[-5].val,XMP_LIST(XMP_NODES_INHERIT_NODES,yystack.l_mark[-2].val)); }
break;
case 596:
#line 1968 "F95-parser.y"
	{ yyval.val=list2(LIST,list1(LIST,yystack.l_mark[-3].val),yystack.l_mark[-1].val); }
break;
case 597:
#line 1970 "F95-parser.y"
	{ yyval.val=list2(LIST,yystack.l_mark[0].val,yystack.l_mark[-3].val); }
break;
case 598:
#line 1975 "F95-parser.y"
	{ yyval.val = list3(LIST,list1(LIST,yystack.l_mark[-5].val),yystack.l_mark[-3].val,yystack.l_mark[0].val); }
break;
case 599:
#line 1977 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[-5].val,yystack.l_mark[-2].val); }
break;
case 600:
#line 1983 "F95-parser.y"
	{ yyval.val = list4(LIST,list1(LIST,yystack.l_mark[-8].val),yystack.l_mark[-6].val,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 601:
#line 1986 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[0].val,yystack.l_mark[-8].val,yystack.l_mark[-5].val,yystack.l_mark[-3].val); }
break;
case 602:
#line 1991 "F95-parser.y"
	{ yyval.val = list2(LIST,list1(LIST,yystack.l_mark[-3].val),yystack.l_mark[-1].val); }
break;
case 603:
#line 1993 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[0].val,yystack.l_mark[-3].val); }
break;
case 604:
#line 1998 "F95-parser.y"
	{ yyval.val = list3(LIST,NULL,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 605:
#line 2000 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL); }
break;
case 606:
#line 2002 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-5].val,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 607:
#line 2010 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 608:
#line 2015 "F95-parser.y"
	{ yyval.val = list4(LIST,NULL,yystack.l_mark[-2].val,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 609:
#line 2018 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-5].val,yystack.l_mark[-2].val,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 610:
#line 2030 "F95-parser.y"
	{ yyval.val= list3(LIST,yystack.l_mark[-3].val,NULL,yystack.l_mark[0].val); }
break;
case 611:
#line 2032 "F95-parser.y"
	{ yyval.val= list3(LIST,yystack.l_mark[-8].val,yystack.l_mark[-3].val,yystack.l_mark[0].val); }
break;
case 612:
#line 2037 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 613:
#line 2042 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 614:
#line 2044 "F95-parser.y"
	{ yyval.val = list2(LIST,NULL,yystack.l_mark[0].val); }
break;
case 615:
#line 2061 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-6].val,yystack.l_mark[-2].val,NULL,yystack.l_mark[0].val); }
break;
case 616:
#line 2063 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-6].val,NULL,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 617:
#line 2065 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-9].val,yystack.l_mark[-5].val,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 618:
#line 2067 "F95-parser.y"
	{ yyval.val = list4(LIST,yystack.l_mark[-3].val,NULL,NULL,yystack.l_mark[0].val); }
break;
case 619:
#line 2079 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-2].val,NULL,yystack.l_mark[0].val); }
break;
case 620:
#line 2081 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-5].val,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 621:
#line 2086 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 622:
#line 2091 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-5].val,yystack.l_mark[-1].val); }
break;
case 623:
#line 2093 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-3].val,NULL); }
break;
case 624:
#line 2097 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_END_TASK,NULL); }
break;
case 625:
#line 2098 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_END_TASKS,NULL); }
break;
case 626:
#line 2099 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_END_MASTER_IO,NULL); }
break;
case 627:
#line 2100 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_END_GLOBAL_IO,NULL); }
break;
case 628:
#line 2105 "F95-parser.y"
	{ yyval.val = list2(LIST,NULL,yystack.l_mark[-1].val); }
break;
case 629:
#line 2107 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 630:
#line 2109 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[0].val,NULL); }
break;
case 631:
#line 2111 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 632:
#line 2116 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 633:
#line 2118 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 634:
#line 2123 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[0].val,GEN_NODE(INT_CONSTANT, 0)); }
break;
case 635:
#line 2125 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val,NULL); }
break;
case 636:
#line 2127 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-4].val,yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 637:
#line 2129 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 638:
#line 2134 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 639:
#line 2136 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 640:
#line 2140 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 641:
#line 2142 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[0].val,NULL); }
break;
case 642:
#line 2144 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-3].val,yystack.l_mark[-1].val); }
break;
case 643:
#line 2146 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-3].val,NULL); }
break;
case 644:
#line 2150 "F95-parser.y"
	{ need_keyword=TRUE; }
break;
case 645:
#line 2150 "F95-parser.y"
	{ yyval.val = yystack.l_mark[0].val; }
break;
case 646:
#line 2153 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 647:
#line 2154 "F95-parser.y"
	{ yyval.val=yystack.l_mark[0].val; }
break;
case 648:
#line 2159 "F95-parser.y"
	{ yyval.val = list2(LIST,GEN_NODE(INT_CONSTANT,yystack.l_mark[-3].code),yystack.l_mark[-1].val); }
break;
case 649:
#line 2163 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_SUM; }
break;
case 650:
#line 2164 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_PROD; }
break;
case 651:
#line 2165 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_SUB; }
break;
case 652:
#line 2166 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_LAND; }
break;
case 653:
#line 2167 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_LOR; }
break;
case 654:
#line 2168 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_EQV; }
break;
case 655:
#line 2169 "F95-parser.y"
	{ yyval.code = (int) XMP_DATA_REDUCE_NEQV; }
break;
case 656:
#line 2170 "F95-parser.y"
	{ yyval.code = XMP_reduction_op(yystack.l_mark[0].val); }
break;
case 657:
#line 2175 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 658:
#line 2177 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 659:
#line 2182 "F95-parser.y"
	{ yyval.val = list2(LIST,yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 660:
#line 2186 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 661:
#line 2187 "F95-parser.y"
	{ yyval.val=yystack.l_mark[-1].val; }
break;
case 662:
#line 2191 "F95-parser.y"
	{ yyval.val= NULL; }
break;
case 663:
#line 2192 "F95-parser.y"
	{ need_keyword=TRUE; }
break;
case 664:
#line 2192 "F95-parser.y"
	{ yyval.val = GEN_NODE(INT_CONSTANT, XMP_GMOVE_IN); }
break;
case 665:
#line 2193 "F95-parser.y"
	{ need_keyword=TRUE; }
break;
case 666:
#line 2193 "F95-parser.y"
	{ yyval.val = GEN_NODE(INT_CONSTANT, XMP_GMOVE_OUT); }
break;
case 667:
#line 2198 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 668:
#line 2200 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 669:
#line 2205 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 670:
#line 2207 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 671:
#line 2221 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 672:
#line 2223 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-2].val,yystack.l_mark[0].val); }
break;
case 673:
#line 2228 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[0].val,GEN_NODE(INT_CONSTANT, 0)); }
break;
case 674:
#line 2230 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val,GEN_NODE(INT_CONSTANT, 0)); }
break;
case 675:
#line 2232 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[0].val,yystack.l_mark[0].val,GEN_NODE(INT_CONSTANT, 1)); }
break;
case 676:
#line 2234 "F95-parser.y"
	{ yyval.val = list3(LIST,yystack.l_mark[-2].val,yystack.l_mark[0].val,GEN_NODE(INT_CONSTANT, 1)); }
break;
case 677:
#line 2247 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 678:
#line 2249 "F95-parser.y"
	{ yyval.val = yystack.l_mark[-1].val; }
break;
case 679:
#line 2253 "F95-parser.y"
	{ yyval.val = NULL; }
break;
case 681:
#line 2259 "F95-parser.y"
	{ yyval.val = list1(LIST,yystack.l_mark[0].val); }
break;
case 682:
#line 2261 "F95-parser.y"
	{ yyval.val = list_put_last(yystack.l_mark[-1].val,yystack.l_mark[0].val); }
break;
case 683:
#line 2266 "F95-parser.y"
	{ yyval.val = XMP_LIST(XMP_OPT_ASYNC, yystack.l_mark[-1].val); }
break;
case 684:
#line 2269 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 686:
#line 2270 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 688:
#line 2271 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 690:
#line 2273 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 692:
#line 2274 "F95-parser.y"
	{ need_keyword = TRUE; }
break;
case 694:
#line 2292 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, 1), NULL); }
break;
case 695:
#line 2294 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, INT_MAX), NULL); }
break;
case 696:
#line 2299 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, 1),
			 GEN_NODE(INT_CONSTANT, XMP_GLOBAL_IO_COLLECTIVE)); }
break;
case 697:
#line 2302 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, INT_MAX),
			 GEN_NODE(INT_CONSTANT, XMP_GLOBAL_IO_COLLECTIVE)); }
break;
case 698:
#line 2305 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, 1),
			 GEN_NODE(INT_CONSTANT, XMP_GLOBAL_IO_ATOMIC)); }
break;
case 699:
#line 2308 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, INT_MAX),
			 GEN_NODE(INT_CONSTANT, XMP_GLOBAL_IO_ATOMIC)); }
break;
case 700:
#line 2311 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, 1),
			 GEN_NODE(INT_CONSTANT, XMP_GLOBAL_IO_DIRECT)); }
break;
case 701:
#line 2314 "F95-parser.y"
	{ yyval.val = list2(LIST, GEN_NODE(INT_CONSTANT, INT_MAX),
			 GEN_NODE(INT_CONSTANT, XMP_GLOBAL_IO_DIRECT)); }
break;
#line 5451 "F95-parser.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            if ((yychar = YYLEX) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack))
    {
        goto yyoverflow;
    }
    *++yystack.s_mark = (short) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
